// This code conforms with the UFC specification version 2018.1.0
// and was automatically generated by FFC version 2019.1.0.post0.
//
// This code was generated with the option '-l dolfin' and
// contains DOLFIN-specific wrappers that depend on DOLFIN.
//
// This code was generated with the following parameters:
//

//  add_tabulate_tensor_timing:     False
//  convert_exceptions_to_warnings: False
//  cpp_optimize:                   True
//  cpp_optimize_flags:             '-O2'
//  epsilon:                        1e-14
//  error_control:                  False
//  external_include_dirs:          ''
//  external_includes:              ''
//  external_libraries:             ''
//  external_library_dirs:          ''
//  form_postfix:                   True
//  format:                         'dolfin'
//  generate_dummy_tabulate_tensor: False
//  max_signature_length:           0
//  optimize:                       True
//  precision:                      None
//  quadrature_degree:              None
//  quadrature_rule:                None
//  representation:                 'auto'
//  split:                          False

#ifndef __FORMS_H
#define __FORMS_H
#include <algorithm>
#include <cmath>
#include <iostream>
#include <stdexcept>
#include <ufc.h>

class forms_finite_element_0: public ufc::finite_element
{
public:

  forms_finite_element_0() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Lagrange', triangle, 1)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 3;
  }

  std::size_t value_rank() const final override
  {
    return 0;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t value_size() const final override
  {
    return 1;
  }

  std::size_t reference_value_rank() const final override
  {
    return 0;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t reference_value_size() const final override
  {
    return 1;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 3; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 2] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 3 * num_derivatives, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[3] = {};
    const std::size_t num_components[3] = { 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 3; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[3 * num_derivatives * ip + num_derivatives * i + r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 3 * num_derivatives, 0.0);
    const std::size_t reference_offsets[3] = {};
    const std::size_t physical_offsets[3] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 3; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[3 * num_derivatives * ip + num_derivatives * d + s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[3 * num_derivatives * ip + num_derivatives * d + r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[3];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[3];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 1; ++k)
        values[k] = physical_values[i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold value of a single dof.
    double dof_values = 0.0;
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
        values[r] = dof_values;
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, num_derivatives * 3, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < num_derivatives; ++s)
            values[num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[6] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 6, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_0();
  }

};


class forms_finite_element_1: public ufc::finite_element
{
public:

  forms_finite_element_1() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 6;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 6 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 2] += coefficients2[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 3 + 1] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 4 + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 5 + 1] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 6 * num_derivatives * 2, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t num_components[6] = { 1, 1, 1, 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 6; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 6 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t physical_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 6; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[12];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[12];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 3:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 4:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 5:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 6, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[4] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 3:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 4:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 5:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[3] = vals[1];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[4] = vals[1];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[1];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate function and change variables
    vertex_values[1] = dof_values[3];
    vertex_values[3] = dof_values[4];
    vertex_values[5] = dof_values[5];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
    dof_coordinates[2 * 3] = coordinate_dofs[0];
    dof_coordinates[2 * 3 + 1] = coordinate_dofs[1];
    dof_coordinates[2 * 4] = coordinate_dofs[2];
    dof_coordinates[2 * 4 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 5] = coordinate_dofs[4];
    dof_coordinates[2 * 5 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[12] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 12, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 2;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_0();
    case 1:
        return new forms_finite_element_0();
    default:
        return nullptr;
    }
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_1();
  }

};


class forms_finite_element_2: public ufc::finite_element
{
public:

  forms_finite_element_2() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 15;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 3;
  }

  const char * family() const final override
  {
    return "Nedelec 1st kind H(curl)";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112332, 0.08417937871268405, -0.11664236870396062, 0.0, -0.14682003422210355, 0.07290148043997528, -0.10101525445522067 },
          { 0.0, 0.0, 0.0, 0.32167832742366936, -0.13468700594029506, 0.09720197391996711, 0.2605797108646139, -0.12987926104263028, 0.09768798378956726, -0.06313453403451307 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.07824607964359533, -0.16835875742536802, 0.3499271061118824, 0.0, 0.06776309271789387, -0.14580296087995068, 0.3030457633656627 },
          { 0.0, 0.0, 0.0, -0.16518616813647954, 0.2357022603955161, -0.27216552697590807, -0.12026755886059126, 0.14682003422210413, -0.2245365597551246, 0.17677669529663706 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.03912303982179771, -0.08417937871268419, -0.34992710611188266, 0.0, -0.033881546358947, -0.07290148043997566, -0.303045763365663 },
          { 0.0, 0.0, 0.0, 0.06085806194501898, 0.0, 0.213844342623928, 0.06013377943029554, 0.039528470752104417, 0.11226827987756229, -0.13889597487592936 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.1695331725611231, 0.08417937871268412, 0.11664236870396084, 0.0, 0.14682003422210352, 0.07290148043997557, 0.10101525445522094 },
          { 0.0, 0.0, 0.0, 0.4912114999847914, 0.21886638465297925, 0.21384434262392815, -0.2605797108646135, 0.016940773179473578, -0.024786503349591812, 0.03788072042070799 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359531, -0.1683587574253683, -0.34992710611188255, 0.0, -0.06776309271789392, -0.14580296087995115, -0.3030457633656631 },
          { 0.0, 0.0, 0.0, -0.24343224778007325, -0.40406101782088416, -0.6220926330877913, 0.1202675588605909, 0.07905694150420935, 0.07873359887517353, -0.12626906806902674 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.039123039821797524, -0.08417937871268384, 0.3499271061118825, 0.0, 0.03388154635894678, -0.07290148043997523, 0.30304576336566286 },
          { 0.0, 0.0, 0.0, 0.09998110176681528, -0.084179378712684, 0.5637714487358111, -0.06013377943029554, 0.07341001711105218, -0.18516976031753773, 0.16414978848973452 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868734, 0.3030457633656633, 0.311046316543896, 0.0, -0.09035079029052523, -0.14580296087995093, -0.20203050891044208 },
          { 0.0, 0.0, 0.0, 0.1695331725611229, 0.08417937871268402, 0.11664236870396098, 0.16035674514745452, 0.06776309271789353, 0.0320766513935894, -0.07576144084141612 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373746, 0.0, -0.15552315827194835, 0.0, 0.18070158058105038, 0.0, 0.10101525445522071 },
          { 0.0, 0.0, 0.0, -0.38253638936868767, 0.06734350297014802, -0.07776157913597376, -0.32071349029490925, 0.09035079029052573, -0.06415330278717868, 0.05050762722761052 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686872, -0.303045763365664, 0.3110463165438963, 0.0, -0.09035079029052506, 0.14580296087995076, -0.20203050891044172 },
          { 0.0, 0.0, 0.0, 0.213003216807565, -0.21886638465297964, 0.1944039478399343, 0.16035674514745493, -0.15811388300841986, 0.17787961227354038, -0.12626906806902638 } };
    static const double coefficients9[2][10] =
        { { 4.0, 0.0, 0.0, -0.36885555678165965, -0.4761904761904762, -1.6495721976846456, 0.0, -0.3194382824999707, -0.4123930494211603, 0.5714285714285702 },
          { 0.0, 0.0, 0.0, 0.6147592613027621, 0.4761904761904764, -0.5498573992282134, 0.5669467095138395, 0.15971914124998646, -0.45363235436327665, 0.3571428571428574 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.9999999999999987, 0.0, -0.6776309271789394, 1.8079567149113955, 0.0, 0.0, -0.5868455973269654, -1.2626906806902614, 0.0 },
          { 0.0, 0.0, 0.0, 1.054092553389458, 1.1664236870396079, -0.3367175148507339, 1.0415476122441187, 0.6846531968814584, -0.5808377131175195, 0.21870444131992572 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 3.999999999999999, 0.13041013273932514, -0.841793787126841, 0.9331389496316853, 0.0, 0.11293848786315577, -0.7290148043997556, -2.020305089104421 },
          { 0.0, 0.0, 0.0, -0.34776035397153116, 0.33671751485073786, 1.360827634879543, -0.20044593143431805, 0.6211616832473591, 0.597792139607799, -0.8838834764831877 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809514, 0.0, 0.0, 0.0, 0.8247860988423218, 0.0 },
          { 4.0, 0.0, 0.0, -1.5983740793871868, 0.4761904761904755, -0.5498573992282164, 0.0, -0.6388765649999414, 0.4123930494211609, -0.1428571428571421 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.3552618543578792, 0.0, 0.0, 0.0, 1.1736911946539288, 0.0, 0.0 },
          { 0.0, 3.9999999999999964, 0.0, 0.6776309271789384, -0.5248906591678214, 0.0, -2.0830952244882392, 0.5868455973269646, -0.1010152544552221, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.683587574253682, 0.0, 0.0, 0.0, 1.4580296087995084, 0.0 },
          { 0.0, 0.0, 3.9999999999999987, 0.8259308406823945, 0.8417937871268409, -1.7885163201274015, 0.0, -1.1293848786315661, 0.7290148043997546, -0.25253813613805115 } };
    for (std::size_t k = 0; k < num_points * 15 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + c] += coefficients0[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 + c] += coefficients1[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 2 + c] += coefficients2[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 3 + c] += coefficients3[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 4 + c] += coefficients4[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 5 + c] += coefficients5[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 6 + c] += coefficients6[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 7 + c] += coefficients7[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 8 + c] += coefficients8[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 9 + c] += coefficients9[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 10 + c] += coefficients10[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 11 + c] += coefficients11[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 12 + c] += coefficients12[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 13 + c] += coefficients13[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 14 + c] += coefficients14[c][r] * basisvalues3[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 15 * num_derivatives * 2, 0.0);
    if (order > 3)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][10][10] =
        { { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.898979485566349, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.999999999999996, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 5.291502622129197, 0.0, -2.9933259094191627, 13.662601021279464, 0.0, 0.6110100926607828, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 4.381780460041363, 0.0, 0.0, 12.521980673998849, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.464101615137759, 0.0, 7.838367176906179, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.5819888974716187, 4.743416490252573, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 1.9999999999999138, 6.123724356957937, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { -2.3094010767584883, 0.0, 8.164965809277268, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.6457513110645636, 5.184592558726247, -1.4966629547095622, 6.831300510639719, -1.058300524425831, 0.3055050463303885, 0.0, 0.0, 0.0, 0.0 },
            { 2.2360679774998355, 2.19089023002069, 2.5298221281346853, 8.082903768654775, 6.26099033699942, -1.8073922282301293, 0.0, 0.0, 0.0, 0.0 },
            { 1.73205080756888, -5.091168824543122, 3.9191835884531008, 0.0, 9.699484522385701, 4.200000000000008, 0.0, 0.0, 0.0, 0.0 },
            { 5.0000000000000195, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } } };
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112332, 0.08417937871268405, -0.11664236870396062, 0.0, -0.14682003422210355, 0.07290148043997528, -0.10101525445522067 },
          { 0.0, 0.0, 0.0, 0.32167832742366936, -0.13468700594029506, 0.09720197391996711, 0.2605797108646139, -0.12987926104263028, 0.09768798378956726, -0.06313453403451307 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.07824607964359533, -0.16835875742536802, 0.3499271061118824, 0.0, 0.06776309271789387, -0.14580296087995068, 0.3030457633656627 },
          { 0.0, 0.0, 0.0, -0.16518616813647954, 0.2357022603955161, -0.27216552697590807, -0.12026755886059126, 0.14682003422210413, -0.2245365597551246, 0.17677669529663706 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.03912303982179771, -0.08417937871268419, -0.34992710611188266, 0.0, -0.033881546358947, -0.07290148043997566, -0.303045763365663 },
          { 0.0, 0.0, 0.0, 0.06085806194501898, 0.0, 0.213844342623928, 0.06013377943029554, 0.039528470752104417, 0.11226827987756229, -0.13889597487592936 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.1695331725611231, 0.08417937871268412, 0.11664236870396084, 0.0, 0.14682003422210352, 0.07290148043997557, 0.10101525445522094 },
          { 0.0, 0.0, 0.0, 0.4912114999847914, 0.21886638465297925, 0.21384434262392815, -0.2605797108646135, 0.016940773179473578, -0.024786503349591812, 0.03788072042070799 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359531, -0.1683587574253683, -0.34992710611188255, 0.0, -0.06776309271789392, -0.14580296087995115, -0.3030457633656631 },
          { 0.0, 0.0, 0.0, -0.24343224778007325, -0.40406101782088416, -0.6220926330877913, 0.1202675588605909, 0.07905694150420935, 0.07873359887517353, -0.12626906806902674 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.039123039821797524, -0.08417937871268384, 0.3499271061118825, 0.0, 0.03388154635894678, -0.07290148043997523, 0.30304576336566286 },
          { 0.0, 0.0, 0.0, 0.09998110176681528, -0.084179378712684, 0.5637714487358111, -0.06013377943029554, 0.07341001711105218, -0.18516976031753773, 0.16414978848973452 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868734, 0.3030457633656633, 0.311046316543896, 0.0, -0.09035079029052523, -0.14580296087995093, -0.20203050891044208 },
          { 0.0, 0.0, 0.0, 0.1695331725611229, 0.08417937871268402, 0.11664236870396098, 0.16035674514745452, 0.06776309271789353, 0.0320766513935894, -0.07576144084141612 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373746, 0.0, -0.15552315827194835, 0.0, 0.18070158058105038, 0.0, 0.10101525445522071 },
          { 0.0, 0.0, 0.0, -0.38253638936868767, 0.06734350297014802, -0.07776157913597376, -0.32071349029490925, 0.09035079029052573, -0.06415330278717868, 0.05050762722761052 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686872, -0.303045763365664, 0.3110463165438963, 0.0, -0.09035079029052506, 0.14580296087995076, -0.20203050891044172 },
          { 0.0, 0.0, 0.0, 0.213003216807565, -0.21886638465297964, 0.1944039478399343, 0.16035674514745493, -0.15811388300841986, 0.17787961227354038, -0.12626906806902638 } };
    static const double coefficients9[2][10] =
        { { 4.0, 0.0, 0.0, -0.36885555678165965, -0.4761904761904762, -1.6495721976846456, 0.0, -0.3194382824999707, -0.4123930494211603, 0.5714285714285702 },
          { 0.0, 0.0, 0.0, 0.6147592613027621, 0.4761904761904764, -0.5498573992282134, 0.5669467095138395, 0.15971914124998646, -0.45363235436327665, 0.3571428571428574 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.9999999999999987, 0.0, -0.6776309271789394, 1.8079567149113955, 0.0, 0.0, -0.5868455973269654, -1.2626906806902614, 0.0 },
          { 0.0, 0.0, 0.0, 1.054092553389458, 1.1664236870396079, -0.3367175148507339, 1.0415476122441187, 0.6846531968814584, -0.5808377131175195, 0.21870444131992572 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 3.999999999999999, 0.13041013273932514, -0.841793787126841, 0.9331389496316853, 0.0, 0.11293848786315577, -0.7290148043997556, -2.020305089104421 },
          { 0.0, 0.0, 0.0, -0.34776035397153116, 0.33671751485073786, 1.360827634879543, -0.20044593143431805, 0.6211616832473591, 0.597792139607799, -0.8838834764831877 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809514, 0.0, 0.0, 0.0, 0.8247860988423218, 0.0 },
          { 4.0, 0.0, 0.0, -1.5983740793871868, 0.4761904761904755, -0.5498573992282164, 0.0, -0.6388765649999414, 0.4123930494211609, -0.1428571428571421 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.3552618543578792, 0.0, 0.0, 0.0, 1.1736911946539288, 0.0, 0.0 },
          { 0.0, 3.9999999999999964, 0.0, 0.6776309271789384, -0.5248906591678214, 0.0, -2.0830952244882392, 0.5868455973269646, -0.1010152544552221, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.683587574253682, 0.0, 0.0, 0.0, 1.4580296087995084, 0.0 },
          { 0.0, 0.0, 3.9999999999999987, 0.8259308406823945, 0.8417937871268409, -1.7885163201274015, 0.0, -1.1293848786315661, 0.7290148043997546, -0.25253813613805115 } };
    const std::size_t reference_offset[15] = {};
    const std::size_t num_components[15] = { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2 };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 15; ++i)
        {
            double derivatives[16] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients0[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients0[1][s] * aux[s];
                    }
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients1[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients1[1][s] * aux[s];
                    }
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients2[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients2[1][s] * aux[s];
                    }
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients3[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients3[1][s] * aux[s];
                    }
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients4[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients4[1][s] * aux[s];
                    }
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients5[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients5[1][s] * aux[s];
                    }
                }
                break;
            case 6:
                // Compute reference derivatives for dof 6.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients6[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients6[1][s] * aux[s];
                    }
                }
                break;
            case 7:
                // Compute reference derivatives for dof 7.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients7[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients7[1][s] * aux[s];
                    }
                }
                break;
            case 8:
                // Compute reference derivatives for dof 8.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients8[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients8[1][s] * aux[s];
                    }
                }
                break;
            case 9:
                // Compute reference derivatives for dof 9.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients9[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients9[1][s] * aux[s];
                    }
                }
                break;
            case 10:
                // Compute reference derivatives for dof 10.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients10[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients10[1][s] * aux[s];
                    }
                }
                break;
            case 11:
                // Compute reference derivatives for dof 11.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients11[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients11[1][s] * aux[s];
                    }
                }
                break;
            case 12:
                // Compute reference derivatives for dof 12.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients12[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients12[1][s] * aux[s];
                    }
                }
                break;
            case 13:
                // Compute reference derivatives for dof 13.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients13[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients13[1][s] * aux[s];
                    }
                }
                break;
            case 14:
                // Compute reference derivatives for dof 14.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients14[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients14[1][s] * aux[s];
                    }
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    std::fill_n(values, num_points * 15 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[15] = {};
    const std::size_t physical_offsets[15] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[8][8];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 15; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 2; ++i)
                {
                    // Using covariant Piola transform to map values back to the physical element.
                    const double mapped_value = K[2 * 2 * ip + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]] + K[2 * 2 * ip + 2 + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + (reference_offsets[d] + 1)];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[30];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[30];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    // Declare transformation matrix
    double transform[8][8] =
        { { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.16953317256112332, 0.08417937871268405, -0.11664236870396062, 0.0, -0.14682003422210355, 0.07290148043997528, -0.10101525445522067 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.32167832742366936, -0.13468700594029506, 0.09720197391996711, 0.2605797108646139, -0.12987926104263028, 0.09768798378956726, -0.06313453403451307 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999996, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, 0.0, -2.9933259094191627, 13.662601021279464, 0.0, 0.6110100926607828, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041363, 0.0, 0.0, 12.521980673998849, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137759, 0.0, 7.838367176906179, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716187, 4.743416490252573, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999138, 6.123724356957937, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584883, 0.0, 8.164965809277268, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.184592558726247, -1.4966629547095622, 6.831300510639719, -1.058300524425831, 0.3055050463303885, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998355, 2.19089023002069, 2.5298221281346853, 8.082903768654775, 6.26099033699942, -1.8073922282301293, 0.0, 0.0, 0.0, 0.0 },
                  { 1.73205080756888, -5.091168824543122, 3.9191835884531008, 0.0, 9.699484522385701, 4.200000000000008, 0.0, 0.0, 0.0, 0.0 },
                  { 5.0000000000000195, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 1:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.07824607964359533, -0.16835875742536802, 0.3499271061118824, 0.0, 0.06776309271789387, -0.14580296087995068, 0.3030457633656627 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.16518616813647954, 0.2357022603955161, -0.27216552697590807, -0.12026755886059126, 0.14682003422210413, -0.2245365597551246, 0.17677669529663706 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999996, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, 0.0, -2.9933259094191627, 13.662601021279464, 0.0, 0.6110100926607828, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041363, 0.0, 0.0, 12.521980673998849, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137759, 0.0, 7.838367176906179, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716187, 4.743416490252573, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999138, 6.123724356957937, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584883, 0.0, 8.164965809277268, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.184592558726247, -1.4966629547095622, 6.831300510639719, -1.058300524425831, 0.3055050463303885, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998355, 2.19089023002069, 2.5298221281346853, 8.082903768654775, 6.26099033699942, -1.8073922282301293, 0.0, 0.0, 0.0, 0.0 },
                  { 1.73205080756888, -5.091168824543122, 3.9191835884531008, 0.0, 9.699484522385701, 4.200000000000008, 0.0, 0.0, 0.0, 0.0 },
                  { 5.0000000000000195, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 2:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.03912303982179771, -0.08417937871268419, -0.34992710611188266, 0.0, -0.033881546358947, -0.07290148043997566, -0.303045763365663 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.06085806194501898, 0.0, 0.213844342623928, 0.06013377943029554, 0.039528470752104417, 0.11226827987756229, -0.13889597487592936 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999996, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, 0.0, -2.9933259094191627, 13.662601021279464, 0.0, 0.6110100926607828, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041363, 0.0, 0.0, 12.521980673998849, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137759, 0.0, 7.838367176906179, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716187, 4.743416490252573, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999138, 6.123724356957937, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584883, 0.0, 8.164965809277268, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.184592558726247, -1.4966629547095622, 6.831300510639719, -1.058300524425831, 0.3055050463303885, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998355, 2.19089023002069, 2.5298221281346853, 8.082903768654775, 6.26099033699942, -1.8073922282301293, 0.0, 0.0, 0.0, 0.0 },
                  { 1.73205080756888, -5.091168824543122, 3.9191835884531008, 0.0, 9.699484522385701, 4.200000000000008, 0.0, 0.0, 0.0, 0.0 },
                  { 5.0000000000000195, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 3:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.1695331725611231, 0.08417937871268412, 0.11664236870396084, 0.0, 0.14682003422210352, 0.07290148043997557, 0.10101525445522094 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.4912114999847914, 0.21886638465297925, 0.21384434262392815, -0.2605797108646135, 0.016940773179473578, -0.024786503349591812, 0.03788072042070799 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999996, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, 0.0, -2.9933259094191627, 13.662601021279464, 0.0, 0.6110100926607828, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041363, 0.0, 0.0, 12.521980673998849, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137759, 0.0, 7.838367176906179, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716187, 4.743416490252573, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999138, 6.123724356957937, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584883, 0.0, 8.164965809277268, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.184592558726247, -1.4966629547095622, 6.831300510639719, -1.058300524425831, 0.3055050463303885, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998355, 2.19089023002069, 2.5298221281346853, 8.082903768654775, 6.26099033699942, -1.8073922282301293, 0.0, 0.0, 0.0, 0.0 },
                  { 1.73205080756888, -5.091168824543122, 3.9191835884531008, 0.0, 9.699484522385701, 4.200000000000008, 0.0, 0.0, 0.0, 0.0 },
                  { 5.0000000000000195, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 4:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.07824607964359531, -0.1683587574253683, -0.34992710611188255, 0.0, -0.06776309271789392, -0.14580296087995115, -0.3030457633656631 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.24343224778007325, -0.40406101782088416, -0.6220926330877913, 0.1202675588605909, 0.07905694150420935, 0.07873359887517353, -0.12626906806902674 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999996, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, 0.0, -2.9933259094191627, 13.662601021279464, 0.0, 0.6110100926607828, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041363, 0.0, 0.0, 12.521980673998849, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137759, 0.0, 7.838367176906179, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716187, 4.743416490252573, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999138, 6.123724356957937, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584883, 0.0, 8.164965809277268, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.184592558726247, -1.4966629547095622, 6.831300510639719, -1.058300524425831, 0.3055050463303885, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998355, 2.19089023002069, 2.5298221281346853, 8.082903768654775, 6.26099033699942, -1.8073922282301293, 0.0, 0.0, 0.0, 0.0 },
                  { 1.73205080756888, -5.091168824543122, 3.9191835884531008, 0.0, 9.699484522385701, 4.200000000000008, 0.0, 0.0, 0.0, 0.0 },
                  { 5.0000000000000195, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 5:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.039123039821797524, -0.08417937871268384, 0.3499271061118825, 0.0, 0.03388154635894678, -0.07290148043997523, 0.30304576336566286 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.09998110176681528, -0.084179378712684, 0.5637714487358111, -0.06013377943029554, 0.07341001711105218, -0.18516976031753773, 0.16414978848973452 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999996, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, 0.0, -2.9933259094191627, 13.662601021279464, 0.0, 0.6110100926607828, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041363, 0.0, 0.0, 12.521980673998849, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137759, 0.0, 7.838367176906179, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716187, 4.743416490252573, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999138, 6.123724356957937, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584883, 0.0, 8.164965809277268, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.184592558726247, -1.4966629547095622, 6.831300510639719, -1.058300524425831, 0.3055050463303885, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998355, 2.19089023002069, 2.5298221281346853, 8.082903768654775, 6.26099033699942, -1.8073922282301293, 0.0, 0.0, 0.0, 0.0 },
                  { 1.73205080756888, -5.091168824543122, 3.9191835884531008, 0.0, 9.699484522385701, 4.200000000000008, 0.0, 0.0, 0.0, 0.0 },
                  { 5.0000000000000195, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 6:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.38253638936868734, 0.3030457633656633, 0.311046316543896, 0.0, -0.09035079029052523, -0.14580296087995093, -0.20203050891044208 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.1695331725611229, 0.08417937871268402, 0.11664236870396098, 0.16035674514745452, 0.06776309271789353, 0.0320766513935894, -0.07576144084141612 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999996, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, 0.0, -2.9933259094191627, 13.662601021279464, 0.0, 0.6110100926607828, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041363, 0.0, 0.0, 12.521980673998849, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137759, 0.0, 7.838367176906179, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716187, 4.743416490252573, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999138, 6.123724356957937, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584883, 0.0, 8.164965809277268, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.184592558726247, -1.4966629547095622, 6.831300510639719, -1.058300524425831, 0.3055050463303885, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998355, 2.19089023002069, 2.5298221281346853, 8.082903768654775, 6.26099033699942, -1.8073922282301293, 0.0, 0.0, 0.0, 0.0 },
                  { 1.73205080756888, -5.091168824543122, 3.9191835884531008, 0.0, 9.699484522385701, 4.200000000000008, 0.0, 0.0, 0.0, 0.0 },
                  { 5.0000000000000195, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 7:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.7650727787373746, 0.0, -0.15552315827194835, 0.0, 0.18070158058105038, 0.0, 0.10101525445522071 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.38253638936868767, 0.06734350297014802, -0.07776157913597376, -0.32071349029490925, 0.09035079029052573, -0.06415330278717868, 0.05050762722761052 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999996, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, 0.0, -2.9933259094191627, 13.662601021279464, 0.0, 0.6110100926607828, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041363, 0.0, 0.0, 12.521980673998849, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137759, 0.0, 7.838367176906179, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716187, 4.743416490252573, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999138, 6.123724356957937, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584883, 0.0, 8.164965809277268, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.184592558726247, -1.4966629547095622, 6.831300510639719, -1.058300524425831, 0.3055050463303885, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998355, 2.19089023002069, 2.5298221281346853, 8.082903768654775, 6.26099033699942, -1.8073922282301293, 0.0, 0.0, 0.0, 0.0 },
                  { 1.73205080756888, -5.091168824543122, 3.9191835884531008, 0.0, 9.699484522385701, 4.200000000000008, 0.0, 0.0, 0.0, 0.0 },
                  { 5.0000000000000195, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 8:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.3825363893686872, -0.303045763365664, 0.3110463165438963, 0.0, -0.09035079029052506, 0.14580296087995076, -0.20203050891044172 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.213003216807565, -0.21886638465297964, 0.1944039478399343, 0.16035674514745493, -0.15811388300841986, 0.17787961227354038, -0.12626906806902638 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999996, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, 0.0, -2.9933259094191627, 13.662601021279464, 0.0, 0.6110100926607828, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041363, 0.0, 0.0, 12.521980673998849, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137759, 0.0, 7.838367176906179, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716187, 4.743416490252573, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999138, 6.123724356957937, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584883, 0.0, 8.164965809277268, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.184592558726247, -1.4966629547095622, 6.831300510639719, -1.058300524425831, 0.3055050463303885, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998355, 2.19089023002069, 2.5298221281346853, 8.082903768654775, 6.26099033699942, -1.8073922282301293, 0.0, 0.0, 0.0, 0.0 },
                  { 1.73205080756888, -5.091168824543122, 3.9191835884531008, 0.0, 9.699484522385701, 4.200000000000008, 0.0, 0.0, 0.0, 0.0 },
                  { 5.0000000000000195, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 9:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 4.0, 0.0, 0.0, -0.36885555678165965, -0.4761904761904762, -1.6495721976846456, 0.0, -0.3194382824999707, -0.4123930494211603, 0.5714285714285702 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.6147592613027621, 0.4761904761904764, -0.5498573992282134, 0.5669467095138395, 0.15971914124998646, -0.45363235436327665, 0.3571428571428574 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999996, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, 0.0, -2.9933259094191627, 13.662601021279464, 0.0, 0.6110100926607828, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041363, 0.0, 0.0, 12.521980673998849, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137759, 0.0, 7.838367176906179, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716187, 4.743416490252573, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999138, 6.123724356957937, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584883, 0.0, 8.164965809277268, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.184592558726247, -1.4966629547095622, 6.831300510639719, -1.058300524425831, 0.3055050463303885, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998355, 2.19089023002069, 2.5298221281346853, 8.082903768654775, 6.26099033699942, -1.8073922282301293, 0.0, 0.0, 0.0, 0.0 },
                  { 1.73205080756888, -5.091168824543122, 3.9191835884531008, 0.0, 9.699484522385701, 4.200000000000008, 0.0, 0.0, 0.0, 0.0 },
                  { 5.0000000000000195, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 10:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 3.9999999999999987, 0.0, -0.6776309271789394, 1.8079567149113955, 0.0, 0.0, -0.5868455973269654, -1.2626906806902614, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 1.054092553389458, 1.1664236870396079, -0.3367175148507339, 1.0415476122441187, 0.6846531968814584, -0.5808377131175195, 0.21870444131992572 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999996, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, 0.0, -2.9933259094191627, 13.662601021279464, 0.0, 0.6110100926607828, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041363, 0.0, 0.0, 12.521980673998849, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137759, 0.0, 7.838367176906179, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716187, 4.743416490252573, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999138, 6.123724356957937, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584883, 0.0, 8.164965809277268, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.184592558726247, -1.4966629547095622, 6.831300510639719, -1.058300524425831, 0.3055050463303885, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998355, 2.19089023002069, 2.5298221281346853, 8.082903768654775, 6.26099033699942, -1.8073922282301293, 0.0, 0.0, 0.0, 0.0 },
                  { 1.73205080756888, -5.091168824543122, 3.9191835884531008, 0.0, 9.699484522385701, 4.200000000000008, 0.0, 0.0, 0.0, 0.0 },
                  { 5.0000000000000195, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 11:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 3.999999999999999, 0.13041013273932514, -0.841793787126841, 0.9331389496316853, 0.0, 0.11293848786315577, -0.7290148043997556, -2.020305089104421 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.34776035397153116, 0.33671751485073786, 1.360827634879543, -0.20044593143431805, 0.6211616832473591, 0.597792139607799, -0.8838834764831877 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999996, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, 0.0, -2.9933259094191627, 13.662601021279464, 0.0, 0.6110100926607828, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041363, 0.0, 0.0, 12.521980673998849, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137759, 0.0, 7.838367176906179, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716187, 4.743416490252573, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999138, 6.123724356957937, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584883, 0.0, 8.164965809277268, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.184592558726247, -1.4966629547095622, 6.831300510639719, -1.058300524425831, 0.3055050463303885, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998355, 2.19089023002069, 2.5298221281346853, 8.082903768654775, 6.26099033699942, -1.8073922282301293, 0.0, 0.0, 0.0, 0.0 },
                  { 1.73205080756888, -5.091168824543122, 3.9191835884531008, 0.0, 9.699484522385701, 4.200000000000008, 0.0, 0.0, 0.0, 0.0 },
                  { 5.0000000000000195, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 12:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 0.9523809523809514, 0.0, 0.0, 0.0, 0.8247860988423218, 0.0 };
            static const double coefficients1[10] = { 4.0, 0.0, 0.0, -1.5983740793871868, 0.4761904761904755, -0.5498573992282164, 0.0, -0.6388765649999414, 0.4123930494211609, -0.1428571428571421 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999996, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, 0.0, -2.9933259094191627, 13.662601021279464, 0.0, 0.6110100926607828, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041363, 0.0, 0.0, 12.521980673998849, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137759, 0.0, 7.838367176906179, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716187, 4.743416490252573, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999138, 6.123724356957937, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584883, 0.0, 8.164965809277268, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.184592558726247, -1.4966629547095622, 6.831300510639719, -1.058300524425831, 0.3055050463303885, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998355, 2.19089023002069, 2.5298221281346853, 8.082903768654775, 6.26099033699942, -1.8073922282301293, 0.0, 0.0, 0.0, 0.0 },
                  { 1.73205080756888, -5.091168824543122, 3.9191835884531008, 0.0, 9.699484522385701, 4.200000000000008, 0.0, 0.0, 0.0, 0.0 },
                  { 5.0000000000000195, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 13:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 1.3552618543578792, 0.0, 0.0, 0.0, 1.1736911946539288, 0.0, 0.0 };
            static const double coefficients1[10] = { 0.0, 3.9999999999999964, 0.0, 0.6776309271789384, -0.5248906591678214, 0.0, -2.0830952244882392, 0.5868455973269646, -0.1010152544552221, 0.0 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999996, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, 0.0, -2.9933259094191627, 13.662601021279464, 0.0, 0.6110100926607828, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041363, 0.0, 0.0, 12.521980673998849, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137759, 0.0, 7.838367176906179, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716187, 4.743416490252573, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999138, 6.123724356957937, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584883, 0.0, 8.164965809277268, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.184592558726247, -1.4966629547095622, 6.831300510639719, -1.058300524425831, 0.3055050463303885, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998355, 2.19089023002069, 2.5298221281346853, 8.082903768654775, 6.26099033699942, -1.8073922282301293, 0.0, 0.0, 0.0, 0.0 },
                  { 1.73205080756888, -5.091168824543122, 3.9191835884531008, 0.0, 9.699484522385701, 4.200000000000008, 0.0, 0.0, 0.0, 0.0 },
                  { 5.0000000000000195, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 14:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 1.683587574253682, 0.0, 0.0, 0.0, 1.4580296087995084, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 3.9999999999999987, 0.8259308406823945, 0.8417937871268409, -1.7885163201274015, 0.0, -1.1293848786315661, 0.7290148043997546, -0.25253813613805115 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999996, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129197, 0.0, -2.9933259094191627, 13.662601021279464, 0.0, 0.6110100926607828, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041363, 0.0, 0.0, 12.521980673998849, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137759, 0.0, 7.838367176906179, 0.0, 0.0, 8.40000000000001, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716187, 4.743416490252573, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999138, 6.123724356957937, 3.535533905932735, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584883, 0.0, 8.164965809277268, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.184592558726247, -1.4966629547095622, 6.831300510639719, -1.058300524425831, 0.3055050463303885, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998355, 2.19089023002069, 2.5298221281346853, 8.082903768654775, 6.26099033699942, -1.8073922282301293, 0.0, 0.0, 0.0, 0.0 },
                  { 1.73205080756888, -5.091168824543122, 3.9191835884531008, 0.0, 9.699484522385701, 4.200000000000008, 0.0, 0.0, 0.0, 0.0 },
                  { 5.0000000000000195, 0.0, -2.8284271247462653, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 15, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[16] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    switch (i)
    {
    case 0:
        {
            y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 1:
        {
            y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 2:
        {
            y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 3:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 4:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 5:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 6:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 7:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 8:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 9:
        {
            result = 0.0;
            double X_9[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_9[36][1] = {};
            double W_9[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_9[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_9[r][0] - X_9[r][1];
                const double w1 = X_9[r][0];
                const double w2 = X_9[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_9[D_9[r][s]] * W_9[r][s];
            }
            return result;
        }
        break;
    case 10:
        {
            result = 0.0;
            double X_10[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_10[36][1] = {};
            double W_10[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_10[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_10[r][0] - X_10[r][1];
                const double w1 = X_10[r][0];
                const double w2 = X_10[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_10[D_10[r][s]] * W_10[r][s];
            }
            return result;
        }
        break;
    case 11:
        {
            result = 0.0;
            double X_11[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_11[36][1] = {};
            double W_11[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_11[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_11[r][0] - X_11[r][1];
                const double w1 = X_11[r][0];
                const double w2 = X_11[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_11[D_11[r][s]] * W_11[r][s];
            }
            return result;
        }
        break;
    case 12:
        {
            result = 0.0;
            double X_12[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_12[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_12[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_12[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_12[r][0] - X_12[r][1];
                const double w1 = X_12[r][0];
                const double w2 = X_12[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_12[D_12[r][s]] * W_12[r][s];
            }
            return result;
        }
        break;
    case 13:
        {
            result = 0.0;
            double X_13[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_13[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_13[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_13[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_13[r][0] - X_13[r][1];
                const double w1 = X_13[r][0];
                const double w2 = X_13[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_13[D_13[r][s]] * W_13[r][s];
            }
            return result;
        }
        break;
    case 14:
        {
            result = 0.0;
            double X_14[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_14[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_14[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_14[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_14[r][0] - X_14[r][1];
                const double w1 = X_14[r][0];
                const double w2 = X_14[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_14[D_14[r][s]] * W_14[r][s];
            }
            return result;
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[0] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[3] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[4] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[6] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[7] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[8] = vals[0] * J[0] + vals[1] * J[2];
    result = 0.0;
    double X_9[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_9[36][1] = {};
    double W_9[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_9[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_9[r][0] - X_9[r][1];
        const double w1 = X_9[r][0];
        const double w2 = X_9[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_9[D_9[r][s]] * W_9[r][s];
    }
    values[9] = result;
    result = 0.0;
    double X_10[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_10[36][1] = {};
    double W_10[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_10[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_10[r][0] - X_10[r][1];
        const double w1 = X_10[r][0];
        const double w2 = X_10[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_10[D_10[r][s]] * W_10[r][s];
    }
    values[10] = result;
    result = 0.0;
    double X_11[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_11[36][1] = {};
    double W_11[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_11[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_11[r][0] - X_11[r][1];
        const double w1 = X_11[r][0];
        const double w2 = X_11[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_11[D_11[r][s]] * W_11[r][s];
    }
    values[11] = result;
    result = 0.0;
    double X_12[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_12[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_12[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_12[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_12[r][0] - X_12[r][1];
        const double w1 = X_12[r][0];
        const double w2 = X_12[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_12[D_12[r][s]] * W_12[r][s];
    }
    values[12] = result;
    result = 0.0;
    double X_13[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_13[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_13[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_13[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_13[r][0] - X_13[r][1];
        const double w1 = X_13[r][0];
        const double w2 = X_13[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_13[D_13[r][s]] * W_13[r][s];
    }
    values[13] = result;
    result = 0.0;
    double X_14[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_14[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_14[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_14[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_14[r][0] - X_14[r][1];
        const double w1 = X_14[r][0];
        const double w2 = X_14[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_14[D_14[r][s]] * W_14[r][s];
    }
    values[14] = result;
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Evaluate function and change variables
    vertex_values[0] = dof_values[3] * (K[2] * 2.9999999999999987) + dof_values[4] * (K[2] * -2.9999999999999964) + dof_values[5] * K[2] + dof_values[6] * (K[0] * 3.0) + dof_values[7] * (K[0] * -2.999999999999999) + dof_values[8] * K[0];
    vertex_values[2] = dof_values[0] * (K[2] * 3.000000000000002) + dof_values[1] * (K[2] * -3.0000000000000053) + dof_values[2] * K[2] + dof_values[6] * (K[0] + K[2]) + dof_values[7] * (K[0] * -3.0000000000000004 + K[2] * -3.0000000000000036) + dof_values[8] * (K[0] * 3.0000000000000004 + K[2] * 3.0000000000000058);
    vertex_values[4] = dof_values[0] * -K[0] + dof_values[1] * (K[0] * 2.999999999999996) + dof_values[2] * (K[0] * -2.999999999999999) + dof_values[3] * (K[0] + K[2]) + dof_values[4] * (K[0] * -2.9999999999999987 + K[2] * -3.000000000000002) + dof_values[5] * (K[0] * 2.9999999999999973 + K[2] * 3.0000000000000027);
    vertex_values[1] = dof_values[3] * (K[2 + 1] * 2.9999999999999987) + dof_values[4] * (K[2 + 1] * -2.9999999999999964) + dof_values[5] * K[2 + 1] + dof_values[6] * (K[1] * 3.0) + dof_values[7] * (K[1] * -2.999999999999999) + dof_values[8] * K[1];
    vertex_values[3] = dof_values[0] * (K[2 + 1] * 3.000000000000002) + dof_values[1] * (K[2 + 1] * -3.0000000000000053) + dof_values[2] * K[2 + 1] + dof_values[6] * (K[1] + K[2 + 1]) + dof_values[7] * (K[1] * -3.0000000000000004 + K[2 + 1] * -3.0000000000000036) + dof_values[8] * (K[1] * 3.0000000000000004 + K[2 + 1] * 3.0000000000000058);
    vertex_values[5] = dof_values[0] * -K[1] + dof_values[1] * (K[1] * 2.999999999999996) + dof_values[2] * (K[1] * -2.999999999999999) + dof_values[3] * (K[1] + K[2 + 1]) + dof_values[4] * (K[1] * -2.9999999999999987 + K[2 + 1] * -3.000000000000002) + dof_values[5] * (K[1] * 2.9999999999999973 + K[2 + 1] * 3.0000000000000027);
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    throw std::runtime_error("tabulate_dof_coordinates is not defined for this element");
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    throw std::runtime_error("tabulate_reference_dof_coordinates is not defined for this element");
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_2();
  }

};


class forms_dofmap_0: public ufc::dofmap
{
public:

  forms_dofmap_0() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Lagrange', triangle, 1)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 3;
  }

  std::size_t num_element_dofs() const final override
  {
    return 3;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 2;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 2, 3 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    dofs[0] = entity_indices[0][0];
    dofs[1] = entity_indices[0][1];
    dofs[2] = entity_indices[0][2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_0();
  }

};


class forms_dofmap_1: public ufc::dofmap
{
public:

  forms_dofmap_1() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 2 * num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 6;
  }

  std::size_t num_element_dofs() const final override
  {
    return 6;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 4;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 4, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
    dofs[3] = offset + entity_indices[0][0];
    dofs[4] = offset + entity_indices[0][1];
    dofs[5] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 4;
        dofs[3] = 5;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 5;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 4;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            dofs[2] = 4;
            dofs[3] = 5;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            dofs[2] = 3;
            dofs[3] = 5;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 3;
            dofs[3] = 4;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 2;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_0();
    case 1:
        return new forms_dofmap_0();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_1();
  }

};


class forms_dofmap_2: public ufc::dofmap
{
public:

  forms_dofmap_2() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { false, true, true };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 3 * num_global_entities[1] + 6 * num_global_entities[2];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 15;
  }

  std::size_t num_element_dofs() const final override
  {
    return 15;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 3;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 15 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + 3 * entity_indices[1][0];
    dofs[1] = offset + 3 * entity_indices[1][0] + 1;
    dofs[2] = offset + 3 * entity_indices[1][0] + 2;
    dofs[3] = offset + 3 * entity_indices[1][1];
    dofs[4] = offset + 3 * entity_indices[1][1] + 1;
    dofs[5] = offset + 3 * entity_indices[1][1] + 2;
    dofs[6] = offset + 3 * entity_indices[1][2];
    dofs[7] = offset + 3 * entity_indices[1][2] + 1;
    dofs[8] = offset + 3 * entity_indices[1][2] + 2;
    offset += 3 * num_global_entities[1];
    dofs[9] = offset + 6 * entity_indices[2][0];
    dofs[10] = offset + 6 * entity_indices[2][0] + 1;
    dofs[11] = offset + 6 * entity_indices[2][0] + 2;
    dofs[12] = offset + 6 * entity_indices[2][0] + 3;
    dofs[13] = offset + 6 * entity_indices[2][0] + 4;
    dofs[14] = offset + 6 * entity_indices[2][0] + 5;
    offset += 6 * num_global_entities[2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
        break;
    case 1:
        dofs[0] = 3;
        dofs[1] = 4;
        dofs[2] = 5;
        break;
    case 2:
        dofs[0] = 6;
        dofs[1] = 7;
        dofs[2] = 8;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 9;
            dofs[1] = 10;
            dofs[2] = 11;
            dofs[3] = 12;
            dofs[4] = 13;
            dofs[5] = 14;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            break;
        case 1:
            break;
        case 2:
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            dofs[6] = 6;
            dofs[7] = 7;
            dofs[8] = 8;
            dofs[9] = 9;
            dofs[10] = 10;
            dofs[11] = 11;
            dofs[12] = 12;
            dofs[13] = 13;
            dofs[14] = 14;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_2();
  }

};


class forms_coordinate_mapping_1: public ufc::coordinate_mapping
{
public:

  forms_coordinate_mapping_1() : ufc::coordinate_mapping()
  {
    // Do nothing
  }

  ~forms_coordinate_mapping_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC coordinate_mapping from VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::coordinate_mapping * create() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
  }

  void compute_physical_coordinates(
      double * x, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double phi[3];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis values of coordinate element
        xelement.evaluate_reference_basis(phi, 1, &X[2 * ip]);
        // Compute x
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t d = 0; d < 3; ++d)
                x[2 * ip + i] += coordinate_dofs[2 * d + i] * phi[d];
    }
  }

  void compute_reference_coordinates(
      double * X, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double J[4];
    double detJ[1];
    double K[4];
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_reference_geometry(
      double * X, double * J, double * detJ, double * K, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_jacobians(
      double * J, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double dphi[6];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis derivatives of coordinate element
        xelement.evaluate_reference_basis_derivatives(dphi, 1, 1, &X[2 * ip]);
        // Compute J
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t j = 0; j < 2; ++j)
                for (std::size_t d = 0; d < 3; ++d)
                    J[2 * 2 * ip + 2 * i + j] += coordinate_dofs[2 * d + i] * dphi[2 * d + j];
    }
  }

  void compute_jacobian_determinants(
      double * detJ, std::size_t num_points,
      const double * J,
      int cell_orientation) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
        detJ[ip] = J[2 * 2 * ip] * J[2 * 2 * ip + 2 + 1] - J[2 * 2 * ip + 1] * J[2 * 2 * ip + 2];
  }

  void compute_jacobian_inverses(
      double * K, std::size_t num_points,
      const double * J, const double * detJ) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        K[2 * 2 * ip] = J[2 * 2 * ip + 2 + 1] / detJ[ip];
        K[2 * 2 * ip + 1] = -J[2 * 2 * ip + 1] / detJ[ip];
        K[2 * 2 * ip + 2] = -J[2 * 2 * ip + 2] / detJ[ip];
        K[2 * 2 * ip + 2 + 1] = J[2 * 2 * ip] / detJ[ip];
    }
  }

  void compute_geometry(
      double * x, double * J, double * detJ, double * K, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    compute_physical_coordinates(x, num_points, X, coordinate_dofs);
    compute_jacobians(J, num_points, X, coordinate_dofs);
    compute_jacobian_determinants(detJ, num_points, J, cell_orientation);
    compute_jacobian_inverses(K, num_points, J, detJ);
  }

  void compute_midpoint_geometry(
      double * x, double * J,
      const double * coordinate_dofs) const final override
  {
    const double phi_Xm[3] = { 0.33333333333333337, 0.3333333333333333, 0.3333333333333333 };
    const double dphi_Xm[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    // Compute x
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t d = 0; d < 3; ++d)
            x[i] += coordinate_dofs[2 * d + i] * phi_Xm[d];
    // Compute J
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t d = 0; d < 3; ++d)
                J[2 * i + j] += coordinate_dofs[2 * d + i] * dphi_Xm[j][d];
  }

};


class forms_cell_integral_0_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_0_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_0_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 4
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 4
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           4
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q6[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q6[0][0][1];
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q6[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q6[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q6[0][0][1];
    alignas(32) double sp[36];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c3 / sp[2];
    sp[4] = -1 * J_c2 / sp[2];
    sp[5] = J_c0 / sp[2];
    sp[6] = sp[5] * sp[3];
    sp[7] = sp[5] * sp[4];
    sp[8] = -1 * J_c1 / sp[2];
    sp[9] = sp[3] * sp[8];
    sp[10] = sp[8] * sp[4];
    sp[11] = -1 * sp[10] + sp[6];
    sp[12] = -1 * sp[7] + sp[7];
    sp[13] = -1 * sp[9] + sp[9];
    sp[14] = -1 * sp[6] + sp[10];
    sp[15] = sp[11] * sp[11];
    sp[16] = sp[11] * sp[12];
    sp[17] = sp[11] * sp[13];
    sp[18] = sp[11] * sp[14];
    sp[19] = sp[12] * sp[12];
    sp[20] = sp[13] * sp[12];
    sp[21] = sp[12] * sp[14];
    sp[22] = sp[13] * sp[13];
    sp[23] = sp[13] * sp[14];
    sp[24] = sp[14] * sp[14];
    sp[25] = std::abs(sp[2]);
    sp[26] = sp[15] * sp[25];
    sp[27] = sp[16] * sp[25];
    sp[28] = sp[17] * sp[25];
    sp[29] = sp[18] * sp[25];
    sp[30] = sp[19] * sp[25];
    sp[31] = sp[20] * sp[25];
    sp[32] = sp[21] * sp[25];
    sp[33] = sp[22] * sp[25];
    sp[34] = sp[23] * sp[25];
    sp[35] = sp[24] * sp[25];
    A[0] = 2.633333333333348 * sp[33] + 0.3583333333333465 * sp[34] + -0.6083333333333391 * sp[28] + -0.6083333333333281 * sp[31] + 0.3583333333333465 * sp[34] + 0.8583333333333474 * sp[35] + -1.875000000000024 * sp[29] + -0.6083333333333392 * sp[32] + -0.6083333333333391 * sp[28] + -1.875000000000024 * sp[29] + 6.191666666666721 * sp[26] + 1.691666666666666 * sp[27] + -0.6083333333333281 * sp[31] + -0.6083333333333392 * sp[32] + 1.691666666666666 * sp[27] + 0.6333333333333275 * sp[30];
    A[1] = -2.016666666666667 * sp[33] + 1.116666666666656 * sp[34] + -0.6166666666666688 * sp[28] + -0.6166666666666795 * sp[31] + 0.2833333333333279 * sp[34] + -0.8000000000000032 * sp[35] + sp[29] + -0.6166666666666802 * sp[32] + 0.2166666666666688 * sp[28] + 1.666666666666687 * sp[29] + -3.466666666666704 * sp[26] + 2.783333333333356 * sp[27] + 0.216666666666659 * sp[31] + 0.2166666666666781 * sp[32] + -0.7166666666666716 * sp[27] + 0.8166666666666638 * sp[30];
    A[2] = -0.03333333333332678 * sp[33] + -0.8916666666666508 * sp[34] + -0.1916666666666733 * sp[28] + -0.1916666666666693 * sp[31] + 0.4416666666666713 * sp[34] + 1.275000000000002 * sp[35] + -0.791666666666676 * sp[29] + -0.1916666666666638 * sp[32] + -0.1916666666666689 * sp[28] + -0.791666666666673 * sp[29] + 1.275000000000013 * sp[26] + -0.8916666666666747 * sp[27] + -0.1916666666666698 * sp[31] + -0.1916666666666771 * sp[32] + 0.4416666666666701 * sp[27] + -0.03333333333333194 * sp[30];
    A[3] = -1.591666666666686 * sp[33] + -0.6500000000000171 * sp[34] + -2.283333333333352 * sp[28] + -0.6500000000000206 * sp[31] + -0.9416666666666804 * sp[34] + -1.295833333333349 * sp[35] + -0.1125000000000012 * sp[29] + -0.4666666666666746 * sp[32] + 0.6916666666666722 * sp[28] + 1.52083333333335 * sp[29] + -1.09583333333334 * sp[26] + -0.266666666666653 * sp[27] + 0.6916666666666673 * sp[31] + 0.6916666666666718 * sp[32] + 0.6916666666666635 * sp[27] + 0.5083333333333402 * sp[30];
    A[4] = -0.06666666666665388 * sp[33] + -0.5333333333333123 * sp[34] + -0.09999999999999276 * sp[28] + -0.5333333333333181 * sp[31] + 0.8833333333333413 * sp[34] + 1.675000000000006 * sp[35] + 0.1416666666666657 * sp[29] + 0.9333333333333247 * sp[32] + -0.3833333333333367 * sp[28] + -0.9583333333333401 * sp[29] + 0.4416666666666685 * sp[26] + -0.1333333333333383 * sp[27] + -0.383333333333339 * sp[31] + -0.3833333333333437 * sp[32] + -0.3833333333333346 * sp[27] + -0.6000000000000064 * sp[30];
    A[5] = -1.00833333333333 * sp[33] + 1.183333333333323 * sp[34] + -2.116666666666669 * sp[28] + 1.183333333333323 * sp[31] + 0.1416666666666642 * sp[34] + -0.8374999999999995 * sp[35] + 0.5124999999999996 * sp[29] + -0.466666666666663 * sp[32] + 0.1083333333333338 * sp[28] + 1.145833333333345 * sp[29] + -0.6375000000000111 * sp[26] + 0.4000000000000148 * sp[27] + 0.108333333333329 * sp[31] + 0.1083333333333436 * sp[32] + 0.108333333333323 * sp[27] + 0.09166666666667812 * sp[30];
    A[6] = -1.091666666666677 * sp[33] + -1.108333333333345 * sp[34] + -1.108333333333344 * sp[28] + -1.108333333333341 * sp[31] + -0.733333333333345 * sp[34] + -0.3624999999999972 * sp[35] + -1.479166666666687 * sp[29] + -1.108333333333342 * sp[32] + 2.133333333333354 * sp[28] + 1.154166666666664 * sp[29] + 3.170833333333359 * sp[26] + 2.19166666666667 * sp[27] + 1.149999999999998 * sp[31] + 1.116666666666658 * sp[32] + 1.149999999999999 * sp[27] + 1.008333333333327 * sp[30];
    A[7] = 2.600000000000017 * sp[33] + 1.216666666666668 * sp[34] + 1.216666666666676 * sp[28] + 1.216666666666665 * sp[31] + 1.466666666666685 * sp[34] + 0.3083333333333411 * sp[35] + 2.375000000000032 * sp[29] + 1.216666666666678 * sp[32] + -4.933333333333374 * sp[28] + -1.058333333333336 * sp[29] + -7.258333333333394 * sp[26] + -3.383333333333337 * sp[27] + -2.133333333333326 * sp[31] + -0.8999999999999941 * sp[32] + -2.133333333333332 * sp[27] + -1.266666666666656 * sp[30];
    A[8] = -1.508333333333343 * sp[33] + 0.3083333333333477 * sp[34] + 0.3083333333333369 * sp[28] + 0.3083333333333472 * sp[31] + -0.7333333333333387 * sp[34] + 0.7625000000000076 * sp[35] + -1.187500000000011 * sp[29] + 0.3083333333333429 * sp[32] + 2.80000000000002 * sp[28] + -2.887500000000014 * sp[29] + 4.295833333333375 * sp[26] + -1.391666666666686 * sp[27] + 0.9833333333333283 * sp[31] + -0.7166666666666626 * sp[32] + 0.9833333333333349 * sp[27] + -0.408333333333335 * sp[30];
    A[9] = 1.649915822768669 * sp[33] + 0.4714045207910704 * sp[34] + -5.185449728701382 * sp[28] + -5.185449728701383 * sp[31] + 3.064129385141739 * sp[34] + 1.767766952966358 * sp[35] + -3.889087296526076 * sp[29] + -5.185449728701422 * sp[32] + -1.649915822768626 * sp[28] + 5.067598598503606 * sp[29] + 10.72445284799603 * sp[26] + 17.44196726926825 * sp[27] + -1.649915822768627 * sp[31] + -0.2357022603955365 * sp[32] + 4.006938426723749 * sp[27] + 5.892556509887858 * sp[30];
    A[10] = 10.96965511460295 * sp[33] + 0.7216878364869966 * sp[34] + -10.53664241271075 * sp[28] + -10.53664241271075 * sp[31] + 0.1443375672973302 * sp[34] + -1.732050807568884 * sp[35] + -8.660254037844528 * sp[29] + -10.5366424127108 * sp[32] + 0.7216878364870659 * sp[28] + 11.54700538379251 * sp[29] + 18.47520861406814 * sp[26] + 29.30052616137363 * sp[27] + 0.7216878364870556 * sp[31] + 5.051814855409181 * sp[32] + 7.649891066762519 * sp[27] + 10.96965511460283 * sp[30];
    A[11] = -6.83333333333331 * sp[33] + 1.583333333333384 * sp[34] + 0.08333333333329618 * sp[28] + 0.08333333333330017 * sp[31] + 2.416666666666669 * sp[34] + 3.749999999999967 * sp[35] + -1.25000000000001 * sp[29] + 0.08333333333337012 * sp[32] + 0.08333333333332811 * sp[28] + -4.916666666666663 * sp[29] + -5.916666666666699 * sp[26] + -10.91666666666673 * sp[27] + 0.08333333333329537 * sp[31] + 0.5833333333333339 * sp[32] + -0.9166666666666407 * sp[27] + -1.833333333333309 * sp[30];
    A[12] = 5.892556509887864 * sp[33] + -1.649915822768637 * sp[34] + 16.7348604880817 * sp[28] + 4.006938426723819 * sp[31] + -3.299831645537231 * sp[34] + -2.47487373415293 * sp[35] + 3.181980515339541 * sp[29] + 4.006938426723851 * sp[32] + 0.4714045207910353 * sp[28] + -2.003469213361916 * sp[29] + -7.660323462854307 * sp[26] + -10.1351971970073 * sp[27] + 0.4714045207910698 * sp[31] + 0.4714045207910301 * sp[32] + -5.185449728701302 * sp[27] + -4.006938426723785 * sp[30];
    A[13] = -16.88749537379671 * sp[33] + -7.361215932167815 * sp[34] + -7.361215932167775 * sp[28] + 3.897114317029945 * sp[31] + -5.196152422706717 * sp[34] + -6.278684177437303 * sp[35] + 4.979646071760514 * sp[29] + 3.897114317029919 * sp[32] + 5.196152422706665 * sp[28] + 11.90784930203618 * sp[29] + -21.86714144555724 * sp[26] + -15.1554445662276 * sp[27] + 5.196152422706609 * sp[31] + 5.196152422706646 * sp[32] + -1.732050807568885 * sp[27] + -3.897114317029883 * sp[30];
    A[14] = 10.41666666666659 * sp[33] + -2.916666666666717 * sp[34] + 10.08333333333334 * sp[28] + -1.416666666666649 * sp[31] + -5.833333333333347 * sp[34] + -4.375000000000023 * sp[35] + -2.874999999999992 * sp[29] + -1.416666666666772 * sp[32] + 0.8333333333333394 * sp[28] + -3.541666666666716 * sp[29] + 7.95833333333343 * sp[26] + 3.583333333333321 * sp[27] + 0.8333333333334019 * sp[31] + 0.8333333333333339 * sp[32] + 1.833333333333375 * sp[27] + 2.916666666666639 * sp[30];
    A[15] = -2.016666666666667 * sp[33] + 0.2833333333333279 * sp[34] + 0.2166666666666688 * sp[28] + 0.216666666666659 * sp[31] + 1.116666666666656 * sp[34] + -0.8000000000000032 * sp[35] + 1.666666666666687 * sp[29] + 0.2166666666666781 * sp[32] + -0.6166666666666688 * sp[28] + sp[29] + -3.466666666666704 * sp[26] + -0.7166666666666716 * sp[27] + -0.6166666666666795 * sp[31] + -0.6166666666666802 * sp[32] + 2.783333333333356 * sp[27] + 0.8166666666666638 * sp[30];
    A[16] = 2.533333333333329 * sp[33] + -1.733333333333327 * sp[34] + 0.7333333333333362 * sp[28] + 0.7333333333333495 * sp[31] + -1.733333333333327 * sp[34] + 2.766666666666656 * sp[35] + -2.166666666666675 * sp[29] + 0.7333333333333421 * sp[32] + 0.7333333333333362 * sp[28] + -2.166666666666675 * sp[29] + 2.766666666666695 * sp[26] + -1.733333333333344 * sp[27] + 0.7333333333333495 * sp[31] + 0.7333333333333421 * sp[32] + -1.733333333333344 * sp[27] + 2.533333333333339 * sp[30];
    A[17] = 0.816666666666667 * sp[33] + 2.783333333333328 * sp[34] + -0.616666666666668 * sp[28] + -0.6166666666666708 * sp[31] + -0.7166666666666714 * sp[34] + -3.466666666666665 * sp[35] + sp[29] + -0.6166666666666738 * sp[32] + 0.216666666666669 * sp[28] + 1.666666666666671 * sp[29] + -0.8000000000000093 * sp[26] + 1.116666666666672 * sp[27] + 0.2166666666666727 * sp[31] + 0.2166666666666723 * sp[32] + 0.283333333333336 * sp[27] + -2.016666666666671 * sp[30];
    A[18] = -0.06666666666666507 * sp[33] + -0.9499999999999953 * sp[34] + 0.3166666666666719 * sp[28] + -0.9499999999999889 * sp[31] + 0.4666666666666789 * sp[34] + 1.258333333333346 * sp[35] + -0.1083333333333382 * sp[29] + 0.6833333333333361 * sp[32] + 0.03333333333333222 * sp[28] + -0.7083333333333411 * sp[29] + 0.8583333333333373 * sp[26] + 0.1166666666666588 * sp[27] + 0.03333333333333169 * sp[31] + 0.03333333333333885 * sp[32] + 0.0333333333333086 * sp[27] + -0.1833333333333436 * sp[30];
    A[19] = 1.633333333333333 * sp[33] + 3.06666666666666 * sp[34] + 1.199999999999992 * sp[28] + 3.066666666666657 * sp[31] + -1.433333333333342 * sp[34] + -3.683333333333339 * sp[35] + -0.2833333333333292 * sp[29] + -2.533333333333315 * sp[32] + 0.4333333333333372 * sp[28] + 1.583333333333339 * sp[29] + -0.2166666666666642 * sp[26] + 0.9333333333333445 * sp[27] + 0.4333333333333453 * sp[31] + 0.4333333333333401 * sp[32] + 0.4333333333333562 * sp[27] + 1.200000000000032 * sp[30];
    A[20] = 1.266666666666662 * sp[33] + -2.116666666666662 * sp[34] + 2.483333333333333 * sp[28] + -2.116666666666665 * sp[31] + -0.8666666666666623 * sp[34] + 3.008333333333324 * sp[35] + -2.025000000000002 * sp[29] + 1.84999999999998 * sp[32] + 0.3666666666666673 * sp[28] + -1.958333333333339 * sp[29] + 1.275000000000012 * sp[26] + -1.050000000000009 * sp[27] + 0.3666666666666739 * sp[31] + 0.3666666666666686 * sp[32] + 0.3666666666666736 * sp[27] + -1.016666666666669 * sp[30];
    A[21] = 0.1833333333333412 * sp[33] + -0.03333333333332403 * sp[34] + -0.03333333333333258 * sp[28] + -0.03333333333333213 * sp[31] + -0.1166666666666599 * sp[34] + -0.8583333333333464 * sp[35] + 0.7083333333333546 * sp[29] + -0.03333333333332755 * sp[32] + -0.6833333333333484 * sp[28] + 0.1083333333333287 * sp[29] + -1.25833333333335 * sp[26] + -0.4666666666666702 * sp[27] + 0.949999999999996 * sp[31] + -0.3166666666666986 * sp[32] + 0.9500000000000109 * sp[27] + 0.06666666666666018 * sp[30];
    A[22] = -1.200000000000008 * sp[33] + -0.4333333333333309 * sp[34] + -0.4333333333333368 * sp[28] + -0.4333333333333294 * sp[31] + -0.9333333333333429 * sp[34] + 0.2166666666666547 * sp[35] + -1.583333333333362 * sp[29] + -0.43333333333335 * sp[32] + 2.533333333333363 * sp[28] + 0.2833333333333407 * sp[29] + 3.683333333333375 * sp[26] + 1.433333333333342 * sp[27] + -3.06666666666667 * sp[31] + -1.199999999999982 * sp[32] + -3.066666666666695 * sp[27] + -1.633333333333329 * sp[30];
    A[23] = 1.016666666666671 * sp[33] + -0.3666666666666879 * sp[34] + -0.366666666666668 * sp[28] + -0.3666666666666805 * sp[31] + 1.049999999999999 * sp[34] + -1.275000000000004 * sp[35] + 1.958333333333344 * sp[29] + -0.3666666666666686 * sp[32] + -1.850000000000013 * sp[28] + 2.025000000000006 * sp[29] + -3.008333333333365 * sp[26] + 0.8666666666666734 * sp[27] + 2.116666666666674 * sp[31] + -2.483333333333339 * sp[32] + 2.116666666666682 * sp[27] + -1.266666666666672 * sp[30];
    A[24] = 3.771236166328242 * sp[33] + 6.128258770283427 * sp[34] + 3.299831645537233 * sp[28] + 3.299831645537253 * sp[31] + -3.771236166328277 * sp[34] + 1.178511301977614 * sp[35] + -1.649915822768554 * sp[29] + 3.299831645537291 * sp[32] + 0.9428090415820685 * sp[28] + -5.421151989096865 * sp[29] + -2.592724864350704 * sp[26] + -8.956685895029651 * sp[27] + 0.9428090415820897 * sp[31] + 12.25651754056687 * sp[32] + 3.771236166328294 * sp[27] + 11.78511301977579 * sp[30];
    A[25] = -8.948929172439176 * sp[33] + -1.443375672973974 * sp[34] + 3.752776749732586 * sp[28] + 3.752776749732625 * sp[31] + -3.175426480542789 * sp[34] + 2.020725942163688 * sp[35] + -1.443375672973926 * sp[29] + 3.752776749732667 * sp[32] + 1.443375672974009 * sp[28] + -7.216878364870351 * sp[29] + -3.752776749732634 * sp[26] + -12.41303078757703 * sp[27] + 1.443375672973953 * sp[31] + 10.10362971081829 * sp[32] + 4.907477288111901 * sp[27] + 14.14508159514581 * sp[30];
    A[26] = 11.16666666666666 * sp[33] + 1.833333333333302 * sp[34] + -5.166666666666681 * sp[28] + -5.166666666666679 * sp[31] + -8.166666666666675 * sp[34] + -16.66666666666665 * sp[35] + 3.333333333333356 * sp[29] + -5.16666666666675 * sp[32] + 3.166666666666689 * sp[28] + 10.66666666666666 * sp[29] + 2.66666666666669 * sp[26] + 10.16666666666672 * sp[27] + 3.166666666666742 * sp[31] + -7.833333333333401 * sp[32] + -4.833333333333373 * sp[27] + -17.1666666666667 * sp[30];
    A[27] = -11.78511301977579 * sp[33] + -3.771236166328259 * sp[34] + -12.25651754056683 * sp[28] + -0.9428090415820713 * sp[31] + 8.956685895029612 * sp[34] + 2.592724864350727 * sp[35] + 5.421151989096808 * sp[29] + -0.9428090415821013 * sp[32] + -3.299831645537241 * sp[28] + 1.649915822768612 * sp[29] + -1.17851130197758 * sp[26] + 3.771236166328304 * sp[27] + -3.299831645537303 * sp[31] + -3.299831645537264 * sp[32] + -6.128258770283473 * sp[27] + -3.7712361663283 * sp[30];
    A[28] = 7.794228634060015 * sp[33] + 1.732050807568902 * sp[34] + 1.732050807568887 * sp[28] + -3.464101615137751 * sp[31] + -2.598076211353281 * sp[34] + -0.4330127018921353 * sp[35] + -5.629165124598794 * sp[29] + -3.464101615137699 * sp[32] + 2.598076211353348 * sp[28] + -2.165063509461153 * sp[29] + 13.42339375865891 * sp[26] + 8.66025403784438 * sp[27] + 2.598076211353373 * sp[31] + 2.5980762113534 * sp[32] + -0.8660254037846384 * sp[27] + -5.19615242270659 * sp[30];
    A[29] = -20.8333333333333 * sp[33] + -6.666666666666666 * sp[34] + -12.66666666666665 * sp[28] + 0.3333333333333474 * sp[31] + 15.83333333333334 * sp[34] + 4.583333333333418 * sp[35] + 11.58333333333331 * sp[29] + 0.3333333333335826 * sp[32] + -5.833333333333362 * sp[28] + 2.916666666666671 * sp[29] + -10.08333333333344 * sp[26] + -1.333333333333365 * sp[27] + -5.833333333333472 * sp[31] + -5.833333333333407 * sp[32] + 2.166666666666587 * sp[27] + 13.33333333333322 * sp[30];
    A[30] = -0.03333333333332678 * sp[33] + 0.4416666666666713 * sp[34] + -0.1916666666666689 * sp[28] + -0.1916666666666698 * sp[31] + -0.8916666666666508 * sp[34] + 1.275000000000002 * sp[35] + -0.791666666666673 * sp[29] + -0.1916666666666771 * sp[32] + -0.1916666666666733 * sp[28] + -0.791666666666676 * sp[29] + 1.275000000000013 * sp[26] + 0.4416666666666701 * sp[27] + -0.1916666666666693 * sp[31] + -0.1916666666666638 * sp[32] + -0.8916666666666747 * sp[27] + -0.03333333333333194 * sp[30];
    A[31] = 0.816666666666667 * sp[33] + -0.7166666666666714 * sp[34] + 0.216666666666669 * sp[28] + 0.2166666666666727 * sp[31] + 2.783333333333328 * sp[34] + -3.466666666666665 * sp[35] + 1.666666666666671 * sp[29] + 0.2166666666666723 * sp[32] + -0.616666666666668 * sp[28] + sp[29] + -0.8000000000000093 * sp[26] + 0.283333333333336 * sp[27] + -0.6166666666666708 * sp[31] + -0.6166666666666738 * sp[32] + 1.116666666666672 * sp[27] + -2.016666666666671 * sp[30];
    A[32] = 0.6333333333333392 * sp[33] + 1.691666666666677 * sp[34] + -0.6083333333333398 * sp[28] + -0.6083333333333394 * sp[31] + 1.691666666666677 * sp[34] + 6.191666666666677 * sp[35] + -1.875000000000011 * sp[29] + -0.6083333333333343 * sp[32] + -0.6083333333333398 * sp[28] + -1.875000000000011 * sp[29] + 0.8583333333333414 * sp[26] + 0.3583333333333356 * sp[27] + -0.6083333333333394 * sp[31] + -0.6083333333333343 * sp[32] + 0.3583333333333356 * sp[27] + 2.633333333333346 * sp[30];
    A[33] = -1.008333333333345 * sp[33] + -1.150000000000009 * sp[34] + -1.116666666666674 * sp[28] + -1.150000000000005 * sp[31] + -2.191666666666688 * sp[34] + -3.170833333333346 * sp[35] + -1.154166666666678 * sp[29] + -2.13333333333334 * sp[32] + 1.108333333333346 * sp[28] + 1.479166666666678 * sp[29] + 0.3625000000000121 * sp[26] + 0.7333333333333448 * sp[27] + 1.108333333333343 * sp[31] + 1.108333333333335 * sp[32] + 1.108333333333355 * sp[27] + 1.091666666666677 * sp[30];
    A[34] = 1.266666666666677 * sp[33] + 2.133333333333346 * sp[34] + 0.9000000000000001 * sp[28] + 2.13333333333334 * sp[31] + 3.383333333333351 * sp[34] + 7.258333333333349 * sp[35] + 1.05833333333333 * sp[29] + 4.93333333333333 * sp[32] + -1.216666666666678 * sp[28] + -2.375000000000014 * sp[29] + -0.3083333333333389 * sp[26] + -1.46666666666668 * sp[27] + -1.216666666666678 * sp[31] + -1.216666666666669 * sp[32] + -1.216666666666679 * sp[27] + -2.600000000000022 * sp[30];
    A[35] = 0.408333333333333 * sp[33] + -0.9833333333333394 * sp[34] + 0.7166666666666691 * sp[28] + -0.9833333333333407 * sp[31] + 1.391666666666662 * sp[34] + -4.295833333333335 * sp[35] + 2.887500000000001 * sp[29] + -2.800000000000002 * sp[32] + -0.3083333333333338 * sp[28] + 1.187500000000008 * sp[29] + -0.7625000000000042 * sp[26] + 0.7333333333333467 * sp[27] + -0.3083333333333352 * sp[31] + -0.3083333333333382 * sp[32] + -0.3083333333333339 * sp[27] + 1.50833333333334 * sp[30];
    A[36] = -0.5083333333333333 * sp[33] + -0.6916666666666667 * sp[34] + -0.6916666666666735 * sp[28] + -0.6916666666666709 * sp[31] + 0.2666666666666676 * sp[34] + 1.095833333333341 * sp[35] + -1.520833333333348 * sp[29] + -0.6916666666666703 * sp[32] + 0.4666666666666754 * sp[28] + 0.1125000000000072 * sp[29] + 1.295833333333344 * sp[26] + 0.9416666666666724 * sp[27] + 0.6500000000000062 * sp[31] + 2.283333333333364 * sp[32] + 0.6499999999999992 * sp[27] + 1.591666666666679 * sp[30];
    A[37] = 0.600000000000003 * sp[33] + 0.3833333333333363 * sp[34] + 0.3833333333333366 * sp[28] + 0.3833333333333357 * sp[31] + 0.1333333333333413 * sp[34] + -0.4416666666666544 * sp[35] + 0.9583333333333427 * sp[29] + 0.3833333333333433 * sp[32] + -0.9333333333333516 * sp[28] + -0.1416666666666748 * sp[29] + -1.675000000000016 * sp[26] + -0.8833333333333384 * sp[27] + 0.5333333333333284 * sp[31] + 0.0999999999999871 * sp[32] + 0.5333333333333441 * sp[27] + 0.0666666666666641 * sp[30];
    A[38] = -0.09166666666666771 * sp[33] + -0.1083333333333418 * sp[34] + -0.1083333333333331 * sp[28] + -0.1083333333333365 * sp[31] + -0.4000000000000018 * sp[34] + 0.6374999999999854 * sp[35] + -1.145833333333334 * sp[29] + -0.1083333333333393 * sp[32] + 0.4666666666666747 * sp[28] + -0.5124999999999972 * sp[29] + 0.8375000000000083 * sp[26] + -0.1416666666666696 * sp[27] + -1.183333333333334 * sp[31] + 2.116666666666677 * sp[32] + -1.183333333333342 * sp[27] + 1.008333333333334 * sp[30];
    A[39] = 4.006938426723805 * sp[33] + 5.185449728701394 * sp[34] + -0.4714045207910396 * sp[28] + -0.4714045207910253 * sp[31] + 10.13519719700723 * sp[34] + 7.660323462854303 * sp[35] + 2.003469213361859 * sp[29] + -0.471404520791048 * sp[32] + -4.006938426723808 * sp[28] + -3.181980515339504 * sp[29] + 2.474873734152938 * sp[26] + 3.299831645537248 * sp[27] + -4.006938426723806 * sp[31] + -16.73486048808171 * sp[32] + 1.649915822768605 * sp[27] + -5.892556509887892 * sp[30];
    A[40] = -0.5773502691895797 * sp[33] + -0.7216878364869834 * sp[34] + -3.319764047840385 * sp[28] + -3.319764047840354 * sp[31] + 4.474464586219631 * sp[34] + 4.04145188432746 * sp[35] + -2.886751345948214 * sp[29] + -3.319764047840371 * sp[32] + -0.7216878364870567 * sp[28] + 6.928203230275569 * sp[26] + 7.649891066762596 * sp[27] + -0.7216878364870309 * sp[31] + -5.051814855409149 * sp[32] + 6.206515393788474 * sp[27] + -0.5773502691895755 * sp[30];
    A[41] = 4.833333333333361 * sp[33] + 2.416666666666678 * sp[34] + -4.083333333333377 * sp[28] + -4.083333333333371 * sp[31] + 14.91666666666671 * sp[34] + 22.91666666666669 * sp[35] + -12.0833333333334 * sp[29] + -4.083333333333316 * sp[32] + -4.083333333333366 * sp[28] + -5.75 * sp[29] + 3.250000000000027 * sp[26] + 1.583333333333342 * sp[27] + -4.083333333333372 * sp[31] + 11.41666666666676 * sp[32] + 4.916666666666707 * sp[27] + 19.83333333333343 * sp[30];
    A[42] = -5.892556509887931 * sp[33] + -4.006938426723798 * sp[34] + 0.2357022603955465 * sp[28] + 1.649915822768635 * sp[31] + -17.44196726926822 * sp[34] + -10.72445284799604 * sp[35] + -5.067598598503516 * sp[29] + 1.649915822768643 * sp[32] + 5.185449728701388 * sp[28] + 3.889087296526028 * sp[29] + -1.767766952966411 * sp[26] + -3.064129385141758 * sp[27] + 5.185449728701395 * sp[31] + 5.185449728701379 * sp[32] + -0.47140452079105 * sp[27] + -1.649915822768621 * sp[30];
    A[43] = -3.897114317030013 * sp[33] + -3.031088913245569 * sp[34] + -3.031088913245556 * sp[28] + -0.4330127018922375 * sp[31] + -5.196152422706674 * sp[34] + -4.11362066797613 * sp[35] + -1.515544456622851 * sp[29] + -0.4330127018922529 * sp[32] + 5.196152422706676 * sp[28] + 5.4126587736528 * sp[29] + -2.3815698604072 * sp[26] + -2.165063509461076 * sp[27] + 5.196152422706657 * sp[31] + 5.196152422706632 * sp[32] + -1.732050807568769 * sp[27] + 0.4330127018921945 * sp[30];
    A[44] = -10.41666666666672 * sp[33] + -7.083333333333378 * sp[34] + -4.08333333333333 * sp[28] + -0.5833333333333124 * sp[31] + -30.83333333333339 * sp[34] + -18.95833333333343 * sp[35] + -12.4583333333333 * sp[29] + -0.5833333333334186 * sp[32] + 9.166666666666734 * sp[28] + 6.875000000000027 * sp[29] + 3.375000000000034 * sp[26] + 1.083333333333322 * sp[27] + 9.166666666666746 * sp[31] + 9.166666666666718 * sp[32] + 0.1666666666666918 * sp[27] + -12.91666666666668 * sp[30];
    A[45] = -1.591666666666686 * sp[33] + -0.9416666666666804 * sp[34] + 0.6916666666666722 * sp[28] + 0.6916666666666673 * sp[31] + -0.6500000000000171 * sp[34] + -1.295833333333349 * sp[35] + 1.52083333333335 * sp[29] + 0.6916666666666718 * sp[32] + -2.283333333333352 * sp[28] + -0.1125000000000012 * sp[29] + -1.09583333333334 * sp[26] + 0.6916666666666635 * sp[27] + -0.6500000000000206 * sp[31] + -0.4666666666666746 * sp[32] + -0.266666666666653 * sp[27] + 0.5083333333333402 * sp[30];
    A[46] = -0.06666666666666507 * sp[33] + 0.4666666666666789 * sp[34] + 0.03333333333333222 * sp[28] + 0.03333333333333169 * sp[31] + -0.9499999999999953 * sp[34] + 1.258333333333346 * sp[35] + -0.7083333333333411 * sp[29] + 0.03333333333333885 * sp[32] + 0.3166666666666719 * sp[28] + -0.1083333333333382 * sp[29] + 0.8583333333333373 * sp[26] + 0.0333333333333086 * sp[27] + -0.9499999999999889 * sp[31] + 0.6833333333333361 * sp[32] + 0.1166666666666588 * sp[27] + -0.1833333333333436 * sp[30];
    A[47] = -1.008333333333345 * sp[33] + -2.191666666666688 * sp[34] + 1.108333333333346 * sp[28] + 1.108333333333343 * sp[31] + -1.150000000000009 * sp[34] + -3.170833333333346 * sp[35] + 1.479166666666678 * sp[29] + 1.108333333333335 * sp[32] + -1.116666666666674 * sp[28] + -1.154166666666678 * sp[29] + 0.3625000000000121 * sp[26] + 1.108333333333355 * sp[27] + -1.150000000000005 * sp[31] + -2.13333333333334 * sp[32] + 0.7333333333333448 * sp[27] + 1.091666666666677 * sp[30];
    A[48] = 2.63333333333336 * sp[33] + 2.275000000000021 * sp[34] + 3.241666666666685 * sp[28] + 2.275000000000018 * sp[31] + 2.275000000000021 * sp[34] + 2.775000000000018 * sp[35] + 1.008333333333346 * sp[29] + 1.508333333333345 * sp[32] + 3.241666666666685 * sp[28] + 1.008333333333346 * sp[29] + 10.04166666666665 * sp[26] + 5.508333333333332 * sp[27] + 2.275000000000018 * sp[31] + 1.508333333333345 * sp[32] + 5.508333333333332 * sp[27] + 3.683333333333333 * sp[30];
    A[49] = -2.016666666666687 * sp[33] + -3.13333333333336 * sp[34] + -1.400000000000002 * sp[28] + -3.133333333333346 * sp[31] + -2.300000000000016 * sp[34] + -4.216666666666682 * sp[35] + -0.6833333333333332 * sp[29] + -2.600000000000001 * sp[32] + -2.233333333333346 * sp[28] + -1.68333333333335 * sp[29] + -5.083333333333309 * sp[26] + -7.933333333333315 * sp[27] + -2.300000000000009 * sp[31] + -2.766666666666675 * sp[32] + -3.433333333333319 * sp[27] + -5.866666666666655 * sp[30];
    A[50] = -0.03333333333333369 * sp[33] + 0.858333333333346 * sp[34] + 0.1583333333333323 * sp[28] + 0.8583333333333484 * sp[31] + -0.4749999999999978 * sp[34] + 1.691666666666676 * sp[35] + -1.075 * sp[29] + 1.091666666666679 * sp[32] + 0.1583333333333345 * sp[28] + 0.2583333333333333 * sp[29] + 1.624999999999994 * sp[26] + 2.424999999999991 * sp[27] + -0.4749999999999943 * sp[31] + 1.091666666666669 * sp[32] + -0.2416666666666653 * sp[27] + 2.183333333333332 * sp[30];
    A[51] = 1.508333333333337 * sp[33] + 1.816666666666671 * sp[34] + 1.816666666666682 * sp[28] + 1.816666666666676 * sp[31] + 0.7750000000000075 * sp[34] + 0.3208333333333337 * sp[35] + 2.270833333333351 * sp[29] + 1.816666666666675 * sp[32] + 4.308333333333313 * sp[28] + 7.504166666666649 * sp[29] + 0.3208333333333437 * sp[26] + 1.816666666666671 * sp[27] + 2.591666666666663 * sp[31] + 4.308333333333327 * sp[32] + 0.7750000000000159 * sp[27] + 1.508333333333342 * sp[30];
    A[52] = -2.600000000000011 * sp[33] + -1.383333333333337 * sp[34] + -1.383333333333342 * sp[28] + -1.383333333333334 * sp[31] + -1.133333333333352 * sp[34] + -0.2250000000000082 * sp[35] + -2.291666666666688 * sp[29] + -1.38333333333334 * sp[32] + -7.533333333333301 * sp[28] + -5.258333333333315 * sp[29] + 0.9416666666666716 * sp[26] + -1.383333333333322 * sp[27] + -3.933333333333339 * sp[31] + -2.866666666666666 * sp[32] + 0.03333333333331595 * sp[27] + -1.016666666666673 * sp[30];
    A[53] = 1.091666666666673 * sp[33] + -0.01666666666666161 * sp[34] + -0.01666666666667027 * sp[28] + -0.01666666666667019 * sp[31] + 0.3583333333333419 * sp[34] + -0.3874999999999962 * sp[35] + 0.7291666666666725 * sp[29] + -0.01666666666667237 * sp[32] + 3.224999999999987 * sp[28] + 0.9625000000000133 * sp[29] + -1.05416666666668 * sp[26] + -0.01666666666665736 * sp[27] + 1.341666666666672 * sp[31] + 0.558333333333343 * sp[32] + -0.3083333333333292 * sp[27] + 0.09166666666667155 * sp[30];
    A[54] = -7.542472332656585 * sp[33] + -8.72098363463417 * sp[34] + 4.0069384267238 * sp[28] + 4.006938426723774 * sp[31] + -7.77817459305208 * sp[34] + -8.249579113843094 * sp[35] + 4.478342947514848 * sp[29] + 4.006938426723814 * sp[32] + -8.720983634634139 * sp[28] + -12.96362432175347 * sp[29] + -0.2357022603955072 * sp[26] + 4.006938426723677 * sp[27] + -7.778174593052063 * sp[31] + -11.07800623858929 * sp[32] + 0.235702260395553 * sp[27] + 2.357022603955154 * sp[30];
    A[55] = -5.917840259193776 * sp[33] + 0.7216878364869693 * sp[34] + 11.98001808568483 * sp[28] + 11.98001808568478 * sp[31] + -0.8660254037844863 * sp[34] + -2.237232293109845 * sp[35] + 13.35122497501021 * sp[29] + 11.98001808568482 * sp[32] + -11.83568051838748 * sp[28] + 18.25870226312174 * sp[29] + 2.670244995002088 * sp[26] + 11.98001808568464 * sp[27] + -0.8660254037845778 * sp[31] + 10.96965511460278 * sp[32] + 4.041451884327477 * sp[27] + 8.804591605141814 * sp[30];
    A[56] = -3.583333333333375 * sp[33] + -4.916666666666705 * sp[34] + 6.583333333333414 * sp[28] + 6.583333333333407 * sp[31] + -7.000000000000028 * sp[34] + -7.708333333333331 * sp[35] + 7.29166666666671 * sp[29] + 6.583333333333337 * sp[32] + -2.66666666666668 * sp[28] + 4.458333333333296 * sp[29] + 5.458333333333439 * sp[26] + 6.58333333333351 * sp[27] + -6.999999999999993 * sp[31] + 2.166666666666645 * sp[32] + 6.166666666666718 * sp[27] + 6.916666666666732 * sp[30];
    A[57] = 5.892556509887952 * sp[33] + 7.542472332656555 * sp[34] + -10.84230397819382 * sp[28] + -5.185449728701412 * sp[31] + 9.192388155425153 * sp[34] + 8.367430244040833 * sp[35] + -4.360491817317138 * sp[29] + -5.185449728701436 * sp[32] + 5.421151989096886 * sp[28] + 5.067598598503659 * sp[29] + -18.97403196183906 * sp[26] + -5.185449728701332 * sp[27] + 9.192388155425119 * sp[31] + 5.892556509887921 * sp[32] + -6.835365551470053 * sp[27] + -4.006938426723813 * sp[30];
    A[58] = 16.8874953737967 * sp[33] + 9.526279441628922 * sp[34] + 9.526279441628878 * sp[28] + -1.732050807568828 * sp[31] + 11.69134295109002 * sp[34] + 10.60881119635948 * sp[35] + -0.6495190528383068 * sp[29] + -1.732050807568829 * sp[32] + 22.0836477965033 * sp[28] + 2.814582562299464 * sp[29] + 36.58957330989248 * sp[26] + -1.732050807568818 * sp[27] + 11.69134295109003 * sp[31] + 3.897114317030043 * sp[32] + 19.48557158514982 * sp[27] + 0.433012701892227 * sp[30];
    A[59] = 10.41666666666677 * sp[33] + 13.33333333333342 * sp[34] + 0.3333333333333077 * sp[28] + 1.833333333333285 * sp[31] + 16.25000000000006 * sp[34] + 14.79166666666669 * sp[35] + 3.291666666666655 * sp[29] + 1.833333333333327 * sp[32] + 9.583333333333377 * sp[28] + 8.958333333333455 * sp[29] + 7.458333333333223 * sp[26] + 1.833333333333258 * sp[27] + 16.24999999999999 * sp[31] + 10.41666666666671 * sp[32] + 9.416666666666602 * sp[27] + 2.916666666666614 * sp[30];
    A[60] = -0.06666666666665388 * sp[33] + 0.8833333333333413 * sp[34] + -0.3833333333333367 * sp[28] + -0.383333333333339 * sp[31] + -0.5333333333333123 * sp[34] + 1.675000000000006 * sp[35] + -0.9583333333333401 * sp[29] + -0.3833333333333437 * sp[32] + -0.09999999999999276 * sp[28] + 0.1416666666666657 * sp[29] + 0.4416666666666685 * sp[26] + -0.3833333333333346 * sp[27] + -0.5333333333333181 * sp[31] + 0.9333333333333247 * sp[32] + -0.1333333333333383 * sp[27] + -0.6000000000000064 * sp[30];
    A[61] = 1.633333333333333 * sp[33] + -1.433333333333342 * sp[34] + 0.4333333333333372 * sp[28] + 0.4333333333333453 * sp[31] + 3.06666666666666 * sp[34] + -3.683333333333339 * sp[35] + 1.583333333333339 * sp[29] + 0.4333333333333401 * sp[32] + 1.199999999999992 * sp[28] + -0.2833333333333292 * sp[29] + -0.2166666666666642 * sp[26] + 0.4333333333333562 * sp[27] + 3.066666666666657 * sp[31] + -2.533333333333315 * sp[32] + 0.9333333333333445 * sp[27] + 1.200000000000032 * sp[30];
    A[62] = 1.266666666666677 * sp[33] + 3.383333333333351 * sp[34] + -1.216666666666678 * sp[28] + -1.216666666666678 * sp[31] + 2.133333333333346 * sp[34] + 7.258333333333349 * sp[35] + -2.375000000000014 * sp[29] + -1.216666666666669 * sp[32] + 0.9000000000000001 * sp[28] + 1.05833333333333 * sp[29] + -0.3083333333333389 * sp[26] + -1.216666666666679 * sp[27] + 2.13333333333334 * sp[31] + 4.93333333333333 * sp[32] + -1.46666666666668 * sp[27] + -2.600000000000022 * sp[30];
    A[63] = -2.016666666666687 * sp[33] + -2.300000000000016 * sp[34] + -2.233333333333346 * sp[28] + -2.300000000000009 * sp[31] + -3.13333333333336 * sp[34] + -4.216666666666682 * sp[35] + -1.68333333333335 * sp[29] + -2.766666666666675 * sp[32] + -1.400000000000002 * sp[28] + -0.6833333333333332 * sp[29] + -5.083333333333309 * sp[26] + -3.433333333333319 * sp[27] + -3.133333333333346 * sp[31] + -2.600000000000001 * sp[32] + -7.933333333333315 * sp[27] + -5.866666666666655 * sp[30];
    A[64] = 2.533333333333352 * sp[33] + 4.266666666666688 * sp[34] + 1.799999999999999 * sp[28] + 4.266666666666676 * sp[31] + 4.266666666666688 * sp[34] + 8.766666666666687 * sp[35] + 1.366666666666663 * sp[29] + 5.866666666666665 * sp[32] + 1.799999999999999 * sp[28] + 1.366666666666663 * sp[29] + 3.833333333333309 * sp[26] + 5.86666666666664 * sp[27] + 4.266666666666676 * sp[31] + 5.866666666666665 * sp[32] + 5.86666666666664 * sp[27] + 11.73333333333331 * sp[30];
    A[65] = 0.8166666666666655 * sp[33] + -1.966666666666677 * sp[34] + 1.433333333333337 * sp[28] + -1.966666666666681 * sp[31] + 1.533333333333328 * sp[34] + -4.716666666666675 * sp[35] + 3.149999999999999 * sp[29] + -3.100000000000011 * sp[32] + 0.5999999999999953 * sp[28] + -0.5166666666666631 * sp[29] + 0.4166666666666698 * sp[26] + -2.433333333333324 * sp[27] + 1.533333333333326 * sp[31] + -3.266666666666654 * sp[32] + 2.066666666666674 * sp[27] + -5.866666666666655 * sp[30];
    A[66] = -1.016666666666665 * sp[33] + -1.383333333333332 * sp[34] + -1.383333333333345 * sp[28] + -1.38333333333334 * sp[31] + 0.0333333333333346 * sp[34] + 0.9416666666666728 * sp[35] + -2.291666666666683 * sp[29] + -1.383333333333338 * sp[32] + -2.866666666666648 * sp[28] + -5.25833333333331 * sp[29] + -0.2250000000000027 * sp[26] + -1.383333333333332 * sp[27] + -3.933333333333314 * sp[31] + -7.533333333333325 * sp[32] + -1.133333333333344 * sp[27] + -2.600000000000007 * sp[30];
    A[67] = 1.200000000000004 * sp[33] + 0.7666666666666717 * sp[34] + 0.7666666666666715 * sp[28] + 0.7666666666666702 * sp[31] + 0.2666666666666785 * sp[34] + -0.38333333333332 * sp[35] + 1.416666666666676 * sp[29] + 0.7666666666666755 * sp[32] + 3.733333333333306 * sp[28] + 3.016666666666652 * sp[29] + -0.3833333333333361 * sp[26] + 0.7666666666666602 * sp[27] + 5.866666666666644 * sp[31] + 3.733333333333327 * sp[32] + 0.2666666666666714 * sp[27] + 1.199999999999998 * sp[30];
    A[68] = -0.1833333333333348 * sp[33] + -0.2166666666666839 * sp[34] + -0.2166666666666656 * sp[28] + -0.216666666666673 * sp[31] + -0.3000000000000052 * sp[34] + 0.5249999999999813 * sp[35] + -1.041666666666667 * sp[29] + -0.2166666666666721 * sp[32] + -0.8666666666666557 * sp[28] + -1.008333333333352 * sp[29] + 0.3583333333333361 * sp[26] + -0.2166666666666794 * sp[27] + -1.933333333333324 * sp[31] + -1.533333333333365 * sp[32] + -0.466666666666669 * sp[27] + -0.6000000000000176 * sp[30];
    A[69] = 8.0138768534476 * sp[33] + 10.37089945740278 * sp[34] + -0.9428090415820767 * sp[28] + -0.9428090415820471 * sp[31] + 13.19932658214896 * sp[34] + 11.78511301977585 * sp[35] + 0.4714045207910038 * sp[29] + -0.9428090415820778 * sp[32] + 5.656854249492381 * sp[28] + 11.78511301977582 * sp[29] + 0.4714045207910389 * sp[26] + -0.9428090415819883 * sp[27] + 13.19932658214891 * sp[31] + 24.51303508113375 * sp[32] + 1.885618083164131 * sp[27];
    A[70] = -1.15470053837916 * sp[33] + -1.443375672973966 * sp[34] + -6.63952809568076 * sp[28] + -6.639528095680699 * sp[31] + 4.618802153517098 * sp[34] + 5.91784025919377 * sp[35] + -7.938566201357448 * sp[29] + -6.639528095680721 * sp[32] + -5.19615242270654 * sp[28] + -14.86676943163269 * sp[29] + -1.01036297108185 * sp[26] + -6.63952809568059 * sp[27] + 4.618802153517145 * sp[31] + -16.16580753730935 * sp[32] + -2.309401076758538 * sp[27] + -10.39230484541318 * sp[30];
    A[71] = 9.666666666666714 * sp[33] + 4.83333333333335 * sp[34] + -8.166666666666746 * sp[28] + -8.166666666666739 * sp[31] + 17.33333333333337 * sp[34] + 24.58333333333336 * sp[35] + -15.41666666666675 * sp[29] + -8.166666666666661 * sp[32] + 6.999999999999981 * sp[28] + -11.41666666666667 * sp[29] + -3.41666666666671 * sp[26] + -8.16666666666676 * sp[27] + 17.33333333333334 * sp[31] + -2.666666666666702 * sp[32] + -10.66666666666675 * sp[27] + -18.00000000000016 * sp[30];
    A[72] = -11.78511301977585 * sp[33] + -8.013876853447588 * sp[34] + 0.47140452079109 * sp[28] + 3.299831645537266 * sp[31] + -20.74179891480545 * sp[34] + -14.37783788412653 * sp[35] + -3.064129385141606 * sp[29] + 3.299831645537274 * sp[32] + -8.485281374238552 * sp[28] + -3.064129385141713 * sp[29] + 2.592724864350671 * sp[26] + 3.299831645537213 * sp[27] + -20.7417989148054 * sp[31] + -9.428090415820702 * sp[32] + 1.88561808316415 * sp[27] + 5.656854249492358 * sp[30];
    A[73] = -7.794228634060016 * sp[33] + -6.062177826491131 * sp[34] + -6.062177826491107 * sp[28] + -0.8660254037844759 * sp[31] + -10.39230484541333 * sp[34] + -8.227241335952229 * sp[35] + -3.031088913245624 * sp[29] + -0.8660254037844788 * sp[32] + -5.196152422706628 * sp[28] + -1.299038105676664 * sp[29] + -16.88749537379647 * sp[26] + -0.8660254037844823 * sp[27] + -10.39230484541326 * sp[31] + -3.464101615137753 * sp[32] + -17.3205080756887 * sp[27] + 3.464101615137752 * sp[30];
    A[74] = -20.83333333333342 * sp[33] + -14.16666666666674 * sp[34] + -8.166666666666654 * sp[28] + -1.166666666666622 * sp[31] + -36.66666666666673 * sp[34] + -25.41666666666676 * sp[35] + -12.41666666666663 * sp[29] + -1.1666666666667 * sp[32] + -14.99999999999996 * sp[28] + -5.41666666666668 * sp[29] + -12.41666666666659 * sp[26] + -1.166666666666592 * sp[27] + -36.66666666666666 * sp[31] + -16.66666666666677 * sp[32] + -24.66666666666659 * sp[27] + 10.00000000000006 * sp[30];
    A[75] = -1.00833333333333 * sp[33] + 0.1416666666666642 * sp[34] + 0.1083333333333338 * sp[28] + 0.108333333333329 * sp[31] + 1.183333333333323 * sp[34] + -0.8374999999999995 * sp[35] + 1.145833333333345 * sp[29] + 0.1083333333333436 * sp[32] + -2.116666666666669 * sp[28] + 0.5124999999999996 * sp[29] + -0.6375000000000111 * sp[26] + 0.108333333333323 * sp[27] + 1.183333333333323 * sp[31] + -0.466666666666663 * sp[32] + 0.4000000000000148 * sp[27] + 0.09166666666667812 * sp[30];
    A[76] = 1.266666666666662 * sp[33] + -0.8666666666666623 * sp[34] + 0.3666666666666673 * sp[28] + 0.3666666666666739 * sp[31] + -2.116666666666662 * sp[34] + 3.008333333333324 * sp[35] + -1.958333333333339 * sp[29] + 0.3666666666666686 * sp[32] + 2.483333333333333 * sp[28] + -2.025000000000002 * sp[29] + 1.275000000000012 * sp[26] + 0.3666666666666736 * sp[27] + -2.116666666666665 * sp[31] + 1.84999999999998 * sp[32] + -1.050000000000009 * sp[27] + -1.016666666666669 * sp[30];
    A[77] = 0.408333333333333 * sp[33] + 1.391666666666662 * sp[34] + -0.3083333333333338 * sp[28] + -0.3083333333333352 * sp[31] + -0.9833333333333394 * sp[34] + -4.295833333333335 * sp[35] + 1.187500000000008 * sp[29] + -0.3083333333333382 * sp[32] + 0.7166666666666691 * sp[28] + 2.887500000000001 * sp[29] + -0.7625000000000042 * sp[26] + -0.3083333333333339 * sp[27] + -0.9833333333333407 * sp[31] + -2.800000000000002 * sp[32] + 0.7333333333333467 * sp[27] + 1.50833333333334 * sp[30];
    A[78] = -0.03333333333333369 * sp[33] + -0.4749999999999978 * sp[34] + 0.1583333333333345 * sp[28] + -0.4749999999999943 * sp[31] + 0.858333333333346 * sp[34] + 1.691666666666676 * sp[35] + 0.2583333333333333 * sp[29] + 1.091666666666669 * sp[32] + 0.1583333333333323 * sp[28] + -1.075 * sp[29] + 1.624999999999994 * sp[26] + -0.2416666666666653 * sp[27] + 0.8583333333333484 * sp[31] + 1.091666666666679 * sp[32] + 2.424999999999991 * sp[27] + 2.183333333333332 * sp[30];
    A[79] = 0.8166666666666655 * sp[33] + 1.533333333333328 * sp[34] + 0.5999999999999953 * sp[28] + 1.533333333333326 * sp[31] + -1.966666666666677 * sp[34] + -4.716666666666675 * sp[35] + -0.5166666666666631 * sp[29] + -3.266666666666654 * sp[32] + 1.433333333333337 * sp[28] + 3.149999999999999 * sp[29] + 0.4166666666666698 * sp[26] + 2.066666666666674 * sp[27] + -1.966666666666681 * sp[31] + -3.100000000000011 * sp[32] + -2.433333333333324 * sp[27] + -5.866666666666655 * sp[30];
    A[80] = 0.6333333333333298 * sp[33] + -1.058333333333329 * sp[34] + 1.241666666666664 * sp[28] + -1.05833333333333 * sp[31] + -1.058333333333329 * sp[34] + 3.441666666666661 * sp[35] + -2.325000000000002 * sp[29] + 2.174999999999987 * sp[32] + 1.241666666666664 * sp[28] + -2.325000000000002 * sp[29] + 2.708333333333338 * sp[26] + -1.825000000000008 * sp[27] + -1.05833333333333 * sp[31] + 2.174999999999987 * sp[32] + -1.825000000000008 * sp[27] + 3.683333333333308 * sp[30];
    A[81] = 0.09166666666666991 * sp[33] + -0.01666666666666239 * sp[34] + -0.01666666666666722 * sp[28] + -0.01666666666666683 * sp[31] + -0.3083333333333313 * sp[34] + -1.054166666666678 * sp[35] + 0.7291666666666818 * sp[29] + -0.01666666666666394 * sp[32] + 0.5583333333333285 * sp[28] + 0.9624999999999966 * sp[29] + -0.3875000000000052 * sp[26] + -0.01666666666666966 * sp[27] + 1.341666666666665 * sp[31] + 3.224999999999996 * sp[32] + 0.358333333333354 * sp[27] + 1.091666666666681 * sp[30];
    A[82] = -0.6000000000000019 * sp[33] + -0.2166666666666646 * sp[34] + -0.2166666666666672 * sp[28] + -0.2166666666666636 * sp[31] + -0.4666666666666724 * sp[34] + 0.3583333333333219 * sp[35] + -1.041666666666684 * sp[29] + -0.2166666666666793 * sp[32] + -1.533333333333319 * sp[28] + -1.008333333333321 * sp[29] + 0.5250000000000117 * sp[26] + -0.2166666666666559 * sp[27] + -1.933333333333328 * sp[31] + -0.8666666666666742 * sp[32] + -0.3000000000000215 * sp[27] + -0.1833333333333491 * sp[30];
    A[83] = 0.5083333333333343 * sp[33] + -0.1833333333333434 * sp[34] + -0.1833333333333336 * sp[28] + -0.1833333333333399 * sp[31] + 0.7749999999999986 * sp[34] + -1.012499999999997 * sp[35] + 1.604166666666672 * sp[29] + -0.183333333333331 * sp[32] + 0.9749999999999955 * sp[28] + 0.1708333333333185 * sp[29] + -1.012500000000013 * sp[26] + -0.1833333333333418 * sp[27] + 0.5916666666666598 * sp[31] + 0.9750000000000029 * sp[32] + 0.7750000000000077 * sp[27] + 0.5083333333333369 * sp[30];
    A[84] = 1.885618083164121 * sp[33] + 3.06412938514171 * sp[34] + 1.649915822768611 * sp[28] + 1.649915822768621 * sp[31] + -5.421151989096892 * sp[34] + -1.178511301977564 * sp[35] + -2.59272486435064 * sp[29] + 1.649915822768651 * sp[32] + 3.064129385141709 * sp[28] + 3.535533905932754 * sp[29] + 2.121320343559642 * sp[26] + 1.649915822768599 * sp[27] + -5.421151989096904 * sp[31] + -13.43502884254443 * sp[32] + -2.121320343559602 * sp[27] + -2.357022603955115 * sp[30];
    A[85] = -4.474464586219576 * sp[33] + -0.7216878364869845 * sp[34] + 1.876388374866283 * sp[28] + 1.876388374866303 * sp[31] + -3.752776749732479 * sp[34] + -0.07216878364873003 * sp[35] + -1.804219591217486 * sp[29] + 1.876388374866335 * sp[32] + -8.948929172439209 * sp[28] + 0.2165063509461299 * sp[29] + 1.948557158514983 * sp[26] + 1.876388374866271 * sp[27] + -3.752776749732457 * sp[31] + 5.196152422706626 * sp[32] + -1.732050807568758 * sp[27] + 1.587713240271567 * sp[30];
    A[86] = 5.583333333333321 * sp[33] + 0.916666666666652 * sp[34] + -2.583333333333338 * sp[28] + -2.583333333333337 * sp[31] + -10.33333333333335 * sp[34] + -18.95833333333333 * sp[35] + 6.041666666666704 * sp[29] + -2.583333333333396 * sp[32] + 10.66666666666668 * sp[28] + 4.874999999999964 * sp[29] + -4.125000000000002 * sp[26] + -2.583333333333312 * sp[27] + -10.33333333333336 * sp[31] + 0.5 * sp[32] + 4.500000000000062 * sp[27] + 11.08333333333336 * sp[30];
    A[87] = -5.892556509887884 * sp[33] + -1.885618083164129 * sp[34] + -6.128258770283397 * sp[28] + -0.4714045207910324 * sp[31] + 11.5494107593803 * sp[34] + 4.831896338108133 * sp[35] + 6.246109900481123 * sp[29] + -0.4714045207910516 * sp[32] + -11.07800623858926 * sp[28] + -3.181980515339466 * sp[29] + -13.08147545195113 * sp[26] + -0.4714045207910089 * sp[27] + 11.54941075938031 * sp[31] + 3.535533905932832 * sp[32] + 4.9497474683058 * sp[27] + -1.649915822768618 * sp[30];
    A[88] = 3.897114317029992 * sp[33] + 0.8660254037844445 * sp[34] + 0.8660254037844379 * sp[28] + -1.732050807568871 * sp[31] + -1.29903810567664 * sp[34] + -0.2165063509460619 * sp[35] + -2.814582562299352 * sp[29] + -1.732050807568833 * sp[32] + 9.09326673973667 * sp[28] + 0.6495190528383303 * sp[29] + 8.443747686898284 * sp[26] + -1.73205080756886 * sp[27] + -1.299038105676625 * sp[31] + -0.4330127018921599 * sp[32] + -2.165063509461048 * sp[27] + -3.897114317029969 * sp[30];
    A[89] = -10.41666666666664 * sp[33] + -3.333333333333333 * sp[34] + -6.333333333333309 * sp[28] + 0.1666666666666717 * sp[31] + 20.41666666666669 * sp[34] + 8.541666666666755 * sp[35] + 12.04166666666665 * sp[29] + 0.1666666666668597 * sp[32] + -19.58333333333335 * sp[28] + -5.624999999999993 * sp[29] + -12.12500000000005 * sp[26] + 0.1666666666666585 * sp[27] + 20.41666666666672 * sp[31] + 6.250000000000162 * sp[32] + 15.24999999999998 * sp[27] + -12.91666666666645 * sp[30];
    A[90] = -1.091666666666677 * sp[33] + -0.733333333333345 * sp[34] + 2.133333333333354 * sp[28] + 1.149999999999998 * sp[31] + -1.108333333333345 * sp[34] + -0.3624999999999972 * sp[35] + 1.154166666666664 * sp[29] + 1.116666666666658 * sp[32] + -1.108333333333344 * sp[28] + -1.479166666666687 * sp[29] + 3.170833333333359 * sp[26] + 1.149999999999999 * sp[27] + -1.108333333333341 * sp[31] + -1.108333333333342 * sp[32] + 2.19166666666667 * sp[27] + 1.008333333333327 * sp[30];
    A[91] = 0.1833333333333412 * sp[33] + -0.1166666666666599 * sp[34] + -0.6833333333333484 * sp[28] + 0.949999999999996 * sp[31] + -0.03333333333332403 * sp[34] + -0.8583333333333464 * sp[35] + 0.1083333333333287 * sp[29] + -0.3166666666666986 * sp[32] + -0.03333333333333258 * sp[28] + 0.7083333333333546 * sp[29] + -1.25833333333335 * sp[26] + 0.9500000000000109 * sp[27] + -0.03333333333333213 * sp[31] + -0.03333333333332755 * sp[32] + -0.4666666666666702 * sp[27] + 0.06666666666666018 * sp[30];
    A[92] = -0.5083333333333333 * sp[33] + 0.2666666666666676 * sp[34] + 0.4666666666666754 * sp[28] + 0.6500000000000062 * sp[31] + -0.6916666666666667 * sp[34] + 1.095833333333341 * sp[35] + 0.1125000000000072 * sp[29] + 2.283333333333364 * sp[32] + -0.6916666666666735 * sp[28] + -1.520833333333348 * sp[29] + 1.295833333333344 * sp[26] + 0.6499999999999992 * sp[27] + -0.6916666666666709 * sp[31] + -0.6916666666666703 * sp[32] + 0.9416666666666724 * sp[27] + 1.591666666666679 * sp[30];
    A[93] = 1.508333333333337 * sp[33] + 0.7750000000000075 * sp[34] + 4.308333333333313 * sp[28] + 2.591666666666663 * sp[31] + 1.816666666666671 * sp[34] + 0.3208333333333337 * sp[35] + 7.504166666666649 * sp[29] + 4.308333333333327 * sp[32] + 1.816666666666682 * sp[28] + 2.270833333333351 * sp[29] + 0.3208333333333437 * sp[26] + 0.7750000000000159 * sp[27] + 1.816666666666676 * sp[31] + 1.816666666666675 * sp[32] + 1.816666666666671 * sp[27] + 1.508333333333342 * sp[30];
    A[94] = -1.016666666666665 * sp[33] + 0.0333333333333346 * sp[34] + -2.866666666666648 * sp[28] + -3.933333333333314 * sp[31] + -1.383333333333332 * sp[34] + 0.9416666666666728 * sp[35] + -5.25833333333331 * sp[29] + -7.533333333333325 * sp[32] + -1.383333333333345 * sp[28] + -2.291666666666683 * sp[29] + -0.2250000000000027 * sp[26] + -1.133333333333344 * sp[27] + -1.38333333333334 * sp[31] + -1.383333333333338 * sp[32] + -1.383333333333332 * sp[27] + -2.600000000000007 * sp[30];
    A[95] = 0.09166666666666991 * sp[33] + -0.3083333333333313 * sp[34] + 0.5583333333333285 * sp[28] + 1.341666666666665 * sp[31] + -0.01666666666666239 * sp[34] + -1.054166666666678 * sp[35] + 0.9624999999999966 * sp[29] + 3.224999999999996 * sp[32] + -0.01666666666666722 * sp[28] + 0.7291666666666818 * sp[29] + -0.3875000000000052 * sp[26] + 0.358333333333354 * sp[27] + -0.01666666666666683 * sp[31] + -0.01666666666666394 * sp[32] + -0.01666666666666966 * sp[27] + 1.091666666666681 * sp[30];
    A[96] = 3.683333333333329 * sp[33] + 5.508333333333317 * sp[34] + 1.508333333333345 * sp[28] + 2.275 * sp[31] + 5.508333333333317 * sp[34] + 10.04166666666667 * sp[35] + 1.008333333333335 * sp[29] + 3.241666666666672 * sp[32] + 1.508333333333345 * sp[28] + 1.008333333333335 * sp[29] + 2.775000000000016 * sp[26] + 2.275000000000004 * sp[27] + 2.275 * sp[31] + 3.241666666666672 * sp[32] + 2.275000000000004 * sp[27] + 2.633333333333336 * sp[30];
    A[97] = -5.866666666666663 * sp[33] + -3.433333333333321 * sp[34] + -2.76666666666669 * sp[28] + -2.299999999999994 * sp[31] + -7.933333333333305 * sp[34] + -5.083333333333312 * sp[35] + -1.683333333333328 * sp[29] + -2.233333333333313 * sp[32] + -2.600000000000026 * sp[28] + -0.6833333333333379 * sp[29] + -4.216666666666695 * sp[26] + -2.3 * sp[27] + -3.133333333333332 * sp[31] + -1.399999999999995 * sp[32] + -3.133333333333336 * sp[27] + -2.016666666666655 * sp[30];
    A[98] = 2.183333333333335 * sp[33] + -0.2416666666666639 * sp[34] + 1.09166666666668 * sp[28] + -0.4750000000000031 * sp[31] + 2.424999999999991 * sp[34] + 1.625000000000026 * sp[35] + 0.2583333333333301 * sp[29] + 0.1583333333333439 * sp[32] + 1.09166666666668 * sp[28] + -1.075000000000002 * sp[29] + 1.691666666666682 * sp[26] + -0.4750000000000122 * sp[27] + 0.8583333333333323 * sp[31] + 0.1583333333333458 * sp[32] + 0.8583333333333326 * sp[27] + -0.03333333333333637 * sp[30];
    A[99] = -4.006938426723776 * sp[33] + -6.83536555146997 * sp[34] + 5.892556509887919 * sp[28] + 9.192388155425096 * sp[31] + -5.185449728701355 * sp[34] + -18.97403196183916 * sp[35] + 5.067598598503566 * sp[29] + 5.42115198909673 * sp[32] + -5.185449728701396 * sp[28] + -4.360491817317071 * sp[29] + 8.367430244040847 * sp[26] + 9.192388155425158 * sp[27] + -5.185449728701379 * sp[31] + -10.84230397819381 * sp[32] + 7.542472332656505 * sp[27] + 5.892556509887855 * sp[30];
    A[100] = 2.742413778650655 * sp[33] + 17.89785834487828 * sp[34] + 10.96965511460295 * sp[28] + 19.91858428704207 * sp[31] + 0.7216878364868284 * sp[34] + 24.75389279150502 * sp[35] + 9.165435523385295 * sp[29] + 19.34123401785233 * sp[32] + 0.7216878364869879 * sp[28] + 2.525907427704585 * sp[29] + 18.11436469582459 * sp[26] + 19.91858428704216 * sp[27] + 0.7216878364869621 * sp[31] + 5.051814855409154 * sp[32] + 16.31014510460695 * sp[27] + 17.46484564298615 * sp[30];
    A[101] = -1.083333333333309 * sp[33] + 12.16666666666667 * sp[34] + -1.833333333333321 * sp[28] + 2.000000000000052 * sp[31] + -2.416666666666638 * sp[34] + 27.95833333333339 * sp[35] + -2.041666666666608 * sp[29] + 14.3333333333336 * sp[32] + -2.416666666666696 * sp[28] + -2.208333333333344 * sp[29] + 1.791666666666688 * sp[26] + 1.999999999999996 * sp[27] + -2.416666666666683 * sp[31] + 8.083333333333389 * sp[32] + 1.58333333333337 * sp[27] + 9.416666666666774 * sp[30];
    A[102] = 2.357022603955135 * sp[33] + 0.2357022603954957 * sp[34] + -11.07800623858927 * sp[28] + -7.778174593052073 * sp[31] + 4.006938426723742 * sp[34] + -0.2357022603954957 * sp[35] + -12.96362432175338 * sp[29] + -8.72098363463407 * sp[32] + 4.006938426723805 * sp[28] + 4.478342947514792 * sp[29] + -8.249579113843119 * sp[26] + -7.778174593052123 * sp[27] + 4.006938426723788 * sp[31] + 4.006938426723769 * sp[32] + -8.720983634634109 * sp[27] + -7.542472332656553 * sp[30];
    A[103] = 10.39230484541331 * sp[33] + 7.361215932167805 * sp[34] + 7.361215932167593 * sp[28] + -6.495190528383217 * sp[31] + 11.69134295108997 * sp[34] + 6.062177826491085 * sp[35] + 12.99038105676645 * sp[29] + -8.227241335952131 * sp[32] + 11.69134295109 * sp[28] + 12.99038105676669 * sp[29] + -7.794228634059977 * sp[26] + -6.495190528383217 * sp[27] + 11.69134295108997 * sp[31] + 11.69134295108998 * sp[32] + -3.897114317029995 * sp[27] + -6.062177826490995 * sp[30];
    A[104] = 4.166666666666625 * sp[33] + 0.4166666666666394 * sp[34] + 8.416666666666636 * sp[28] + 2.749999999999922 * sp[31] + 7.083333333333286 * sp[34] + -0.4166666666666163 * sp[35] + 13.58333333333326 * sp[29] + -8.916666666666906 * sp[32] + 7.083333333333396 * sp[28] + 7.916666666666654 * sp[29] + 1.91666666666671 * sp[26] + 2.749999999999948 * sp[27] + 7.083333333333368 * sp[31] + 7.083333333333337 * sp[32] + 3.083333333333331 * sp[27] + -3.333333333333458 * sp[30];
    A[105] = 2.600000000000017 * sp[33] + 1.466666666666685 * sp[34] + -4.933333333333374 * sp[28] + -2.133333333333326 * sp[31] + 1.216666666666668 * sp[34] + 0.3083333333333411 * sp[35] + -1.058333333333336 * sp[29] + -0.8999999999999941 * sp[32] + 1.216666666666676 * sp[28] + 2.375000000000032 * sp[29] + -7.258333333333394 * sp[26] + -2.133333333333332 * sp[27] + 1.216666666666665 * sp[31] + 1.216666666666678 * sp[32] + -3.383333333333337 * sp[27] + -1.266666666666656 * sp[30];
    A[106] = -1.200000000000008 * sp[33] + -0.9333333333333429 * sp[34] + 2.533333333333363 * sp[28] + -3.06666666666667 * sp[31] + -0.4333333333333309 * sp[34] + 0.2166666666666547 * sp[35] + 0.2833333333333407 * sp[29] + -1.199999999999982 * sp[32] + -0.4333333333333368 * sp[28] + -1.583333333333362 * sp[29] + 3.683333333333375 * sp[26] + -3.066666666666695 * sp[27] + -0.4333333333333294 * sp[31] + -0.43333333333335 * sp[32] + 1.433333333333342 * sp[27] + -1.633333333333329 * sp[30];
    A[107] = 0.600000000000003 * sp[33] + 0.1333333333333413 * sp[34] + -0.9333333333333516 * sp[28] + 0.5333333333333284 * sp[31] + 0.3833333333333363 * sp[34] + -0.4416666666666544 * sp[35] + -0.1416666666666748 * sp[29] + 0.0999999999999871 * sp[32] + 0.3833333333333366 * sp[28] + 0.9583333333333427 * sp[29] + -1.675000000000016 * sp[26] + 0.5333333333333441 * sp[27] + 0.3833333333333357 * sp[31] + 0.3833333333333433 * sp[32] + -0.8833333333333384 * sp[27] + 0.0666666666666641 * sp[30];
    A[108] = -2.600000000000011 * sp[33] + -1.133333333333352 * sp[34] + -7.533333333333301 * sp[28] + -3.933333333333339 * sp[31] + -1.383333333333337 * sp[34] + -0.2250000000000082 * sp[35] + -5.258333333333315 * sp[29] + -2.866666666666666 * sp[32] + -1.383333333333342 * sp[28] + -2.291666666666688 * sp[29] + 0.9416666666666716 * sp[26] + 0.03333333333331595 * sp[27] + -1.383333333333334 * sp[31] + -1.38333333333334 * sp[32] + -1.383333333333322 * sp[27] + -1.016666666666673 * sp[30];
    A[109] = 1.200000000000004 * sp[33] + 0.2666666666666785 * sp[34] + 3.733333333333306 * sp[28] + 5.866666666666644 * sp[31] + 0.7666666666666717 * sp[34] + -0.38333333333332 * sp[35] + 3.016666666666652 * sp[29] + 3.733333333333327 * sp[32] + 0.7666666666666715 * sp[28] + 1.416666666666676 * sp[29] + -0.3833333333333361 * sp[26] + 0.2666666666666714 * sp[27] + 0.7666666666666702 * sp[31] + 0.7666666666666755 * sp[32] + 0.7666666666666602 * sp[27] + 1.199999999999998 * sp[30];
    A[110] = -0.6000000000000019 * sp[33] + -0.4666666666666724 * sp[34] + -1.533333333333319 * sp[28] + -1.933333333333328 * sp[31] + -0.2166666666666646 * sp[34] + 0.3583333333333219 * sp[35] + -1.008333333333321 * sp[29] + -0.8666666666666742 * sp[32] + -0.2166666666666672 * sp[28] + -1.041666666666684 * sp[29] + 0.5250000000000117 * sp[26] + -0.3000000000000215 * sp[27] + -0.2166666666666636 * sp[31] + -0.2166666666666793 * sp[32] + -0.2166666666666559 * sp[27] + -0.1833333333333491 * sp[30];
    A[111] = -5.866666666666663 * sp[33] + -7.933333333333305 * sp[34] + -2.600000000000026 * sp[28] + -3.133333333333332 * sp[31] + -3.433333333333321 * sp[34] + -5.083333333333312 * sp[35] + -0.6833333333333379 * sp[29] + -1.399999999999995 * sp[32] + -2.76666666666669 * sp[28] + -1.683333333333328 * sp[29] + -4.216666666666695 * sp[26] + -3.133333333333336 * sp[27] + -2.299999999999994 * sp[31] + -2.233333333333313 * sp[32] + -2.3 * sp[27] + -2.016666666666655 * sp[30];
    A[112] = 11.73333333333333 * sp[33] + 5.866666666666646 * sp[34] + 5.866666666666715 * sp[28] + 4.266666666666654 * sp[31] + 5.866666666666646 * sp[34] + 3.833333333333314 * sp[35] + 1.366666666666669 * sp[29] + 1.799999999999985 * sp[32] + 5.866666666666715 * sp[28] + 1.366666666666669 * sp[29] + 8.766666666666737 * sp[26] + 4.266666666666668 * sp[27] + 4.266666666666654 * sp[31] + 1.799999999999985 * sp[32] + 4.266666666666668 * sp[27] + 2.533333333333313 * sp[30];
    A[113] = -5.866666666666672 * sp[33] + 2.066666666666676 * sp[34] + -3.266666666666695 * sp[28] + 1.533333333333346 * sp[31] + -2.433333333333324 * sp[34] + 0.4166666666666548 * sp[35] + -0.5166666666666684 * sp[29] + 0.599999999999994 * sp[32] + -3.100000000000026 * sp[28] + 3.150000000000017 * sp[29] + -4.716666666666713 * sp[26] + 1.533333333333359 * sp[27] + -1.966666666666661 * sp[31] + 1.433333333333325 * sp[32] + -1.966666666666671 * sp[27] + 0.8166666666666708 * sp[30];
    A[114] = 5.656854249492408 * sp[33] + 1.885618083164146 * sp[34] + -9.428090415820675 * sp[28] + -20.74179891480537 * sp[31] + 3.299831645537243 * sp[34] + 2.592724864350731 * sp[35] + -3.064129385141692 * sp[29] + -8.485281374238479 * sp[32] + 3.299831645537247 * sp[28] + -3.064129385141726 * sp[29] + -14.37783788412653 * sp[26] + -20.74179891480549 * sp[27] + 3.299831645537235 * sp[31] + 0.4714045207910584 * sp[32] + -8.013876853447515 * sp[27] + -11.78511301977572 * sp[30];
    A[115] = 10.39230484541334 * sp[33] + -30.02221399786039 * sp[34] + -16.16580753730965 * sp[28] + -36.95041722813603 * sp[31] + -1.443375672973982 * sp[34] + -19.1968964505549 * sp[35] + -5.340489990004044 * sp[29] + -15.58845726811977 * sp[32] + -1.443375672974076 * sp[28] + -12.26869322027954 * sp[29] + -26.12509968083071 * sp[26] + -36.95041722813618 * sp[27] + -1.443375672974041 * sp[31] + -10.10362971081833 * sp[32] + -15.29978213352506 * sp[27] + -21.93931022920567 * sp[30];
    A[116] = -2.000000000000013 * sp[33] + -2.666666666666606 * sp[34] + 5.333333333333299 * sp[28] + 9.333333333333274 * sp[31] + -0.1666666666666485 * sp[34] + -8.416666666666643 * sp[35] + 1.583333333333281 * sp[29] + 2.999999999999887 * sp[32] + -0.1666666666666599 * sp[28] + 3.583333333333339 * sp[29] + 5.583333333333366 * sp[26] + 9.33333333333341 * sp[27] + -0.1666666666666413 * sp[31] + -1.166666666666664 * sp[32] + 1.833333333333304 * sp[27] + 3.666666666666619 * sp[30];
    A[117] = 1.885618083164115 * sp[34] + 24.51303508113369 * sp[28] + 13.19932658214895 * sp[31] + -0.942809041582085 * sp[34] + 0.4714045207910256 * sp[35] + 11.78511301977576 * sp[29] + 5.65685424949239 * sp[32] + -0.9428090415820687 * sp[28] + 0.4714045207910806 * sp[29] + 11.78511301977585 * sp[26] + 13.19932658214904 * sp[27] + -0.9428090415820858 * sp[31] + -0.9428090415820447 * sp[32] + 10.37089945740266 * sp[27] + 8.013876853447572 * sp[30];
    A[118] = -20.78460969082663 * sp[33] + -10.3923048454134 * sp[34] + -10.39230484541305 * sp[28] + 17.32050807568864 * sp[31] + -10.39230484541328 * sp[34] + -3.464101615137787 * sp[35] + -17.32050807568866 * sp[29] + 3.464101615137656 * sp[32] + -10.39230484541332 * sp[28] + -17.32050807568896 * sp[29] + 24.24871130596446 * sp[26] + 17.32050807568867 * sp[27] + -10.39230484541325 * sp[31] + -10.39230484541331 * sp[32] + 3.464101615137817 * sp[27] + 7.794228634059799 * sp[30];
    A[119] = 3.333333333333302 * sp[34] + -12.66666666666665 * sp[28] + -4.666666666666622 * sp[31] + -1.666666666666708 * sp[34] + 0.8333333333333162 * sp[35] + -7.166666666666653 * sp[29] + -7.999999999999877 * sp[32] + -1.666666666666677 * sp[28] + 0.8333333333334103 * sp[29] + -7.166666666666769 * sp[26] + -4.666666666666625 * sp[27] + -1.666666666666709 * sp[31] + -1.666666666666638 * sp[32] + -3.666666666666687 * sp[27] + -5.833333333333233 * sp[30];
    A[120] = -1.508333333333343 * sp[33] + -0.7333333333333387 * sp[34] + 2.80000000000002 * sp[28] + 0.9833333333333283 * sp[31] + 0.3083333333333477 * sp[34] + 0.7625000000000076 * sp[35] + -2.887500000000014 * sp[29] + -0.7166666666666626 * sp[32] + 0.3083333333333369 * sp[28] + -1.187500000000011 * sp[29] + 4.295833333333375 * sp[26] + 0.9833333333333349 * sp[27] + 0.3083333333333472 * sp[31] + 0.3083333333333429 * sp[32] + -1.391666666666686 * sp[27] + -0.408333333333335 * sp[30];
    A[121] = 1.016666666666671 * sp[33] + 1.049999999999999 * sp[34] + -1.850000000000013 * sp[28] + 2.116666666666674 * sp[31] + -0.3666666666666879 * sp[34] + -1.275000000000004 * sp[35] + 2.025000000000006 * sp[29] + -2.483333333333339 * sp[32] + -0.366666666666668 * sp[28] + 1.958333333333344 * sp[29] + -3.008333333333365 * sp[26] + 2.116666666666682 * sp[27] + -0.3666666666666805 * sp[31] + -0.3666666666666686 * sp[32] + 0.8666666666666734 * sp[27] + -1.266666666666672 * sp[30];
    A[122] = -0.09166666666666771 * sp[33] + -0.4000000000000018 * sp[34] + 0.4666666666666747 * sp[28] + -1.183333333333334 * sp[31] + -0.1083333333333418 * sp[34] + 0.6374999999999854 * sp[35] + -0.5124999999999972 * sp[29] + 2.116666666666677 * sp[32] + -0.1083333333333331 * sp[28] + -1.145833333333334 * sp[29] + 0.8375000000000083 * sp[26] + -1.183333333333342 * sp[27] + -0.1083333333333365 * sp[31] + -0.1083333333333393 * sp[32] + -0.1416666666666696 * sp[27] + 1.008333333333334 * sp[30];
    A[123] = 1.091666666666673 * sp[33] + 0.3583333333333419 * sp[34] + 3.224999999999987 * sp[28] + 1.341666666666672 * sp[31] + -0.01666666666666161 * sp[34] + -0.3874999999999962 * sp[35] + 0.9625000000000133 * sp[29] + 0.558333333333343 * sp[32] + -0.01666666666667027 * sp[28] + 0.7291666666666725 * sp[29] + -1.05416666666668 * sp[26] + -0.3083333333333292 * sp[27] + -0.01666666666667019 * sp[31] + -0.01666666666667237 * sp[32] + -0.01666666666665736 * sp[27] + 0.09166666666667155 * sp[30];
    A[124] = -0.1833333333333348 * sp[33] + -0.3000000000000052 * sp[34] + -0.8666666666666557 * sp[28] + -1.933333333333324 * sp[31] + -0.2166666666666839 * sp[34] + 0.5249999999999813 * sp[35] + -1.008333333333352 * sp[29] + -1.533333333333365 * sp[32] + -0.2166666666666656 * sp[28] + -1.041666666666667 * sp[29] + 0.3583333333333361 * sp[26] + -0.466666666666669 * sp[27] + -0.216666666666673 * sp[31] + -0.2166666666666721 * sp[32] + -0.2166666666666794 * sp[27] + -0.6000000000000176 * sp[30];
    A[125] = 0.5083333333333343 * sp[33] + 0.7749999999999986 * sp[34] + 0.9749999999999955 * sp[28] + 0.5916666666666598 * sp[31] + -0.1833333333333434 * sp[34] + -1.012499999999997 * sp[35] + 0.1708333333333185 * sp[29] + 0.9750000000000029 * sp[32] + -0.1833333333333336 * sp[28] + 1.604166666666672 * sp[29] + -1.012500000000013 * sp[26] + 0.7750000000000077 * sp[27] + -0.1833333333333399 * sp[31] + -0.183333333333331 * sp[32] + -0.1833333333333418 * sp[27] + 0.5083333333333369 * sp[30];
    A[126] = 2.183333333333335 * sp[33] + 2.424999999999991 * sp[34] + 1.09166666666668 * sp[28] + 0.8583333333333323 * sp[31] + -0.2416666666666639 * sp[34] + 1.625000000000026 * sp[35] + -1.075000000000002 * sp[29] + 0.1583333333333458 * sp[32] + 1.09166666666668 * sp[28] + 0.2583333333333301 * sp[29] + 1.691666666666682 * sp[26] + 0.8583333333333326 * sp[27] + -0.4750000000000031 * sp[31] + 0.1583333333333439 * sp[32] + -0.4750000000000122 * sp[27] + -0.03333333333333637 * sp[30];
    A[127] = -5.866666666666672 * sp[33] + -2.433333333333324 * sp[34] + -3.100000000000026 * sp[28] + -1.966666666666661 * sp[31] + 2.066666666666676 * sp[34] + 0.4166666666666548 * sp[35] + 3.150000000000017 * sp[29] + 1.433333333333325 * sp[32] + -3.266666666666695 * sp[28] + -0.5166666666666684 * sp[29] + -4.716666666666713 * sp[26] + -1.966666666666671 * sp[27] + 1.533333333333346 * sp[31] + 0.599999999999994 * sp[32] + 1.533333333333359 * sp[27] + 0.8166666666666708 * sp[30];
    A[128] = 3.683333333333338 * sp[33] + -1.825000000000012 * sp[34] + 2.175000000000014 * sp[28] + -1.058333333333343 * sp[31] + -1.825000000000012 * sp[34] + 2.708333333333335 * sp[35] + -2.32500000000001 * sp[29] + 1.241666666666671 * sp[32] + 2.175000000000014 * sp[28] + -2.32500000000001 * sp[29] + 3.441666666666703 * sp[26] + -1.058333333333344 * sp[27] + -1.058333333333343 * sp[31] + 1.241666666666671 * sp[32] + -1.058333333333344 * sp[27] + 0.6333333333333375 * sp[30];
    A[129] = -1.649915822768621 * sp[33] + 4.949747468305827 * sp[34] + 3.535533905932765 * sp[28] + 11.54941075938028 * sp[31] + -0.4714045207910759 * sp[34] + -13.08147545195119 * sp[35] + -3.181980515339484 * sp[29] + -11.07800623858923 * sp[32] + -0.471404520791022 * sp[28] + 6.246109900481198 * sp[29] + 4.831896338108104 * sp[26] + 11.54941075938033 * sp[27] + -0.4714045207910408 * sp[31] + -6.128258770283428 * sp[32] + -1.885618083164176 * sp[27] + -5.892556509887921 * sp[30];
    A[130] = -13.13471862406401 * sp[33] + 12.1243556529821 * sp[34] + 5.196152422706709 * sp[28] + 17.03183294109397 * sp[31] + -0.7216878364868879 * sp[34] + -6.278684177437039 * sp[35] + -4.546633369868329 * sp[29] + -12.41303078757689 * sp[32] + -0.721687836486975 * sp[28] + 9.021097956087921 * sp[29] + 7.289047148519082 * sp[26] + 17.03183294109403 * sp[27] + -0.7216878364869468 * sp[31] + -5.051814855409148 * sp[32] + -2.453738644056002 * sp[27] + -7.072540797572959 * sp[30];
    A[131] = 3.083333333333345 * sp[33] + -9.500000000000044 * sp[34] + -3.499999999999992 * sp[28] + -11.33333333333333 * sp[31] + -1.583333333333432 * sp[34] + 13.37500000000006 * sp[35] + 3.375000000000058 * sp[29] + 17.66666666666674 * sp[32] + -1.583333333333341 * sp[28] + -8.458333333333332 * sp[29] + -4.458333333333377 * sp[26] + -11.33333333333341 * sp[27] + -1.583333333333391 * sp[31] + 3.916666666666694 * sp[32] + 2.416666666666695 * sp[27] + 8.583333333333348 * sp[30];
    A[132] = -2.357022603955172 * sp[33] + -2.121320343559621 * sp[34] + -13.43502884254443 * sp[28] + -5.421151989096879 * sp[31] + 1.64991582276872 * sp[34] + 2.121320343559704 * sp[35] + 3.535533905932816 * sp[29] + 3.064129385141735 * sp[32] + 1.649915822768612 * sp[28] + -2.592724864350699 * sp[29] + -1.178511301977566 * sp[26] + -5.421151989096921 * sp[27] + 1.649915822768669 * sp[31] + 1.649915822768631 * sp[32] + 3.064129385141787 * sp[27] + 1.885618083164172 * sp[30];
    A[133] = 10.39230484541332 * sp[33] + 3.031088913245594 * sp[34] + 3.031088913245437 * sp[28] + -10.82531754730544 * sp[31] + -1.299038105676696 * sp[34] + -2.598076211353356 * sp[35] + 4.33012701892233 * sp[29] + 4.763139720814377 * sp[32] + -1.299038105676706 * sp[28] + 4.330127018922255 * sp[29] + -16.45448267190449 * sp[26] + -10.82531754730546 * sp[27] + -1.299038105676734 * sp[31] + -1.299038105676735 * sp[32] + 0.4330127018923413 * sp[27] + 2.598076211353326 * sp[30];
    A[134] = -4.166666666666684 * sp[33] + -3.74999999999996 * sp[34] + 4.24999999999999 * sp[28] + 1.916666666666683 * sp[31] + 2.91666666666686 * sp[34] + 3.75000000000011 * sp[35] + -2.249999999999909 * sp[29] + -13.08333333333321 * sp[32] + 2.916666666666663 * sp[28] + -4.583333333333377 * sp[29] + 9.416666666666767 * sp[26] + 1.916666666666685 * sp[27] + 2.916666666666768 * sp[31] + 2.916666666666702 * sp[32] + -1.083333333333272 * sp[27] + -6.666666666666599 * sp[30];
    A[135] = 1.649915822768669 * sp[33] + 3.064129385141739 * sp[34] + -1.649915822768626 * sp[28] + -1.649915822768627 * sp[31] + 0.4714045207910704 * sp[34] + 1.767766952966358 * sp[35] + 5.067598598503606 * sp[29] + -0.2357022603955365 * sp[32] + -5.185449728701382 * sp[28] + -3.889087296526076 * sp[29] + 10.72445284799603 * sp[26] + 4.006938426723749 * sp[27] + -5.185449728701383 * sp[31] + -5.185449728701422 * sp[32] + 17.44196726926825 * sp[27] + 5.892556509887858 * sp[30];
    A[136] = 3.771236166328242 * sp[33] + -3.771236166328277 * sp[34] + 0.9428090415820685 * sp[28] + 0.9428090415820897 * sp[31] + 6.128258770283427 * sp[34] + 1.178511301977614 * sp[35] + -5.421151989096865 * sp[29] + 12.25651754056687 * sp[32] + 3.299831645537233 * sp[28] + -1.649915822768554 * sp[29] + -2.592724864350704 * sp[26] + 3.771236166328294 * sp[27] + 3.299831645537253 * sp[31] + 3.299831645537291 * sp[32] + -8.956685895029651 * sp[27] + 11.78511301977579 * sp[30];
    A[137] = 4.006938426723805 * sp[33] + 10.13519719700723 * sp[34] + -4.006938426723808 * sp[28] + -4.006938426723806 * sp[31] + 5.185449728701394 * sp[34] + 7.660323462854303 * sp[35] + -3.181980515339504 * sp[29] + -16.73486048808171 * sp[32] + -0.4714045207910396 * sp[28] + 2.003469213361859 * sp[29] + 2.474873734152938 * sp[26] + 1.649915822768605 * sp[27] + -0.4714045207910253 * sp[31] + -0.471404520791048 * sp[32] + 3.299831645537248 * sp[27] + -5.892556509887892 * sp[30];
    A[138] = -7.542472332656585 * sp[33] + -7.77817459305208 * sp[34] + -8.720983634634139 * sp[28] + -7.778174593052063 * sp[31] + -8.72098363463417 * sp[34] + -8.249579113843094 * sp[35] + -12.96362432175347 * sp[29] + -11.07800623858929 * sp[32] + 4.0069384267238 * sp[28] + 4.478342947514848 * sp[29] + -0.2357022603955072 * sp[26] + 0.235702260395553 * sp[27] + 4.006938426723774 * sp[31] + 4.006938426723814 * sp[32] + 4.006938426723677 * sp[27] + 2.357022603955154 * sp[30];
    A[139] = 8.0138768534476 * sp[33] + 13.19932658214896 * sp[34] + 5.656854249492381 * sp[28] + 13.19932658214891 * sp[31] + 10.37089945740278 * sp[34] + 11.78511301977585 * sp[35] + 11.78511301977582 * sp[29] + 24.51303508113375 * sp[32] + -0.9428090415820767 * sp[28] + 0.4714045207910038 * sp[29] + 0.4714045207910389 * sp[26] + 1.885618083164131 * sp[27] + -0.9428090415820471 * sp[31] + -0.9428090415820778 * sp[32] + -0.9428090415819883 * sp[27];
    A[140] = 1.885618083164121 * sp[33] + -5.421151989096892 * sp[34] + 3.064129385141709 * sp[28] + -5.421151989096904 * sp[31] + 3.06412938514171 * sp[34] + -1.178511301977564 * sp[35] + 3.535533905932754 * sp[29] + -13.43502884254443 * sp[32] + 1.649915822768611 * sp[28] + -2.59272486435064 * sp[29] + 2.121320343559642 * sp[26] + -2.121320343559602 * sp[27] + 1.649915822768621 * sp[31] + 1.649915822768651 * sp[32] + 1.649915822768599 * sp[27] + -2.357022603955115 * sp[30];
    A[141] = -4.006938426723776 * sp[33] + -5.185449728701355 * sp[34] + -5.185449728701396 * sp[28] + -5.185449728701379 * sp[31] + -6.83536555146997 * sp[34] + -18.97403196183916 * sp[35] + -4.360491817317071 * sp[29] + -10.84230397819381 * sp[32] + 5.892556509887919 * sp[28] + 5.067598598503566 * sp[29] + 8.367430244040847 * sp[26] + 7.542472332656505 * sp[27] + 9.192388155425096 * sp[31] + 5.42115198909673 * sp[32] + 9.192388155425158 * sp[27] + 5.892556509887855 * sp[30];
    A[142] = 5.656854249492408 * sp[33] + 3.299831645537243 * sp[34] + 3.299831645537247 * sp[28] + 3.299831645537235 * sp[31] + 1.885618083164146 * sp[34] + 2.592724864350731 * sp[35] + -3.064129385141726 * sp[29] + 0.4714045207910584 * sp[32] + -9.428090415820675 * sp[28] + -3.064129385141692 * sp[29] + -14.37783788412653 * sp[26] + -8.013876853447515 * sp[27] + -20.74179891480537 * sp[31] + -8.485281374238479 * sp[32] + -20.74179891480549 * sp[27] + -11.78511301977572 * sp[30];
    A[143] = -1.649915822768621 * sp[33] + -0.4714045207910759 * sp[34] + -0.471404520791022 * sp[28] + -0.4714045207910408 * sp[31] + 4.949747468305827 * sp[34] + -13.08147545195119 * sp[35] + 6.246109900481198 * sp[29] + -6.128258770283428 * sp[32] + 3.535533905932765 * sp[28] + -3.181980515339484 * sp[29] + 4.831896338108104 * sp[26] + -1.885618083164176 * sp[27] + 11.54941075938028 * sp[31] + -11.07800623858923 * sp[32] + 11.54941075938033 * sp[27] + -5.892556509887921 * sp[30];
    A[144] = 26.66666666666689 * sp[33] + 33.33333333333361 * sp[34] + -6.666666666666757 * sp[28] + -6.666666666666657 * sp[31] + 33.33333333333361 * sp[34] + 113.3333333333339 * sp[35] + -6.666666666666671 * sp[29] + 33.3333333333333 * sp[32] + -6.666666666666757 * sp[28] + -6.666666666666671 * sp[29] + 33.33333333333342 * sp[26] + 33.33333333333341 * sp[27] + -6.666666666666657 * sp[31] + 33.3333333333333 * sp[32] + 33.33333333333341 * sp[27] + 66.66666666666646 * sp[30];
    A[145] = 4.082482904638933 * sp[33] + -4.082482904638354 * sp[34] + -28.57738033247071 * sp[28] + -28.57738033247051 * sp[31] + 8.164965809277518 * sp[34] + 14.28869016623502 * sp[35] + -34.70110468942848 * sp[29] + -4.082482904638951 * sp[32] + 8.164965809277152 * sp[28] + 14.28869016623505 * sp[29] + 63.27848502189898 * sp[26] + 69.40220937885684 * sp[27] + 8.164965809276888 * sp[31] + 57.15476066494002 * sp[32] + 57.15476066494105 * sp[27] + 102.0620726159654 * sp[30];
    A[146] = 25.92724864350687 * sp[33] + 16.49915822768613 * sp[34] + -25.927248643507 * sp[28] + -25.92724864350699 * sp[31] + 37.71236166328278 * sp[34] + -64.81812160876711 * sp[35] + -36.5338503613053 * sp[29] + -124.922198009624 * sp[32] + 9.428090415820641 * sp[28] + 20.03469213361882 * sp[29] + -8.249579113843033 * sp[26] + 2.357022603955166 * sp[27] + 9.428090415820753 * sp[31] + -18.85618083164141 * sp[32] + -18.85618083164127 * sp[27] + -58.92556509887885 * sp[30];
    A[147] = -33.3333333333335 * sp[33] + -26.66666666666683 * sp[34] + 13.33333333333362 * sp[28] + 13.33333333333352 * sp[31] + -46.66666666666697 * sp[34] + -36.66666666666695 * sp[35] + 3.333333333333524 * sp[29] + 13.3333333333334 * sp[32] + -6.666666666666662 * sp[28] + 3.333333333333249 * sp[29] + -36.66666666666685 * sp[26] + -26.66666666666696 * sp[27] + -6.666666666666803 * sp[31] + -6.666666666666813 * sp[32] + -46.66666666666675 * sp[27] + -33.33333333333358 * sp[30];
    A[148] = -36.74234614174803 * sp[33] + -24.49489742783205 * sp[34] + -24.49489742783194 * sp[28] + -36.74234614174794 * sp[34] + -30.61862178478981 * sp[35] + -6.123724356958395 * sp[29] + 36.74234614174796 * sp[28] + 42.86607049870599 * sp[29] + -30.61862178478983 * sp[26] + -24.49489742783145 * sp[27] + 36.74234614174784 * sp[31] + 36.74234614174807 * sp[32] + -12.24744871391663 * sp[27] + -36.74234614174714 * sp[30];
    A[149] = -58.92556509887923 * sp[33] + -47.14045207910343 * sp[34] + -18.85618083164117 * sp[28] + -4.714045207910202 * sp[31] + -82.49579113843104 * sp[34] + -64.81812160876734 * sp[35] + -22.39171473757406 * sp[29] + 80.13876853447547 * sp[32] + -11.78511301977576 * sp[28] + 5.892556509887768 * sp[29] + -8.249579113843051 * sp[26] + 9.428090415820435 * sp[27] + -11.78511301977602 * sp[31] + -11.78511301977603 * sp[32] + 16.49915822768595 * sp[27] + 54.21151989096802 * sp[30];
    A[150] = 10.96965511460295 * sp[33] + 0.1443375672973302 * sp[34] + 0.7216878364870659 * sp[28] + 0.7216878364870556 * sp[31] + 0.7216878364869966 * sp[34] + -1.732050807568884 * sp[35] + 11.54700538379251 * sp[29] + 5.051814855409181 * sp[32] + -10.53664241271075 * sp[28] + -8.660254037844528 * sp[29] + 18.47520861406814 * sp[26] + 7.649891066762519 * sp[27] + -10.53664241271075 * sp[31] + -10.5366424127108 * sp[32] + 29.30052616137363 * sp[27] + 10.96965511460283 * sp[30];
    A[151] = -8.948929172439176 * sp[33] + -3.175426480542789 * sp[34] + 1.443375672974009 * sp[28] + 1.443375672973953 * sp[31] + -1.443375672973974 * sp[34] + 2.020725942163688 * sp[35] + -7.216878364870351 * sp[29] + 10.10362971081829 * sp[32] + 3.752776749732586 * sp[28] + -1.443375672973926 * sp[29] + -3.752776749732634 * sp[26] + 4.907477288111901 * sp[27] + 3.752776749732625 * sp[31] + 3.752776749732667 * sp[32] + -12.41303078757703 * sp[27] + 14.14508159514581 * sp[30];
    A[152] = -0.5773502691895797 * sp[33] + 4.474464586219631 * sp[34] + -0.7216878364870567 * sp[28] + -0.7216878364870309 * sp[31] + -0.7216878364869834 * sp[34] + 4.04145188432746 * sp[35] + -5.051814855409149 * sp[32] + -3.319764047840385 * sp[28] + -2.886751345948214 * sp[29] + 6.928203230275569 * sp[26] + 6.206515393788474 * sp[27] + -3.319764047840354 * sp[31] + -3.319764047840371 * sp[32] + 7.649891066762596 * sp[27] + -0.5773502691895755 * sp[30];
    A[153] = -5.917840259193776 * sp[33] + -0.8660254037844863 * sp[34] + -11.83568051838748 * sp[28] + -0.8660254037845778 * sp[31] + 0.7216878364869693 * sp[34] + -2.237232293109845 * sp[35] + 18.25870226312174 * sp[29] + 10.96965511460278 * sp[32] + 11.98001808568483 * sp[28] + 13.35122497501021 * sp[29] + 2.670244995002088 * sp[26] + 4.041451884327477 * sp[27] + 11.98001808568478 * sp[31] + 11.98001808568482 * sp[32] + 11.98001808568464 * sp[27] + 8.804591605141814 * sp[30];
    A[154] = -1.15470053837916 * sp[33] + 4.618802153517098 * sp[34] + -5.19615242270654 * sp[28] + 4.618802153517145 * sp[31] + -1.443375672973966 * sp[34] + 5.91784025919377 * sp[35] + -14.86676943163269 * sp[29] + -16.16580753730935 * sp[32] + -6.63952809568076 * sp[28] + -7.938566201357448 * sp[29] + -1.01036297108185 * sp[26] + -2.309401076758538 * sp[27] + -6.639528095680699 * sp[31] + -6.639528095680721 * sp[32] + -6.63952809568059 * sp[27] + -10.39230484541318 * sp[30];
    A[155] = -4.474464586219576 * sp[33] + -3.752776749732479 * sp[34] + -8.948929172439209 * sp[28] + -3.752776749732457 * sp[31] + -0.7216878364869845 * sp[34] + -0.07216878364873003 * sp[35] + 0.2165063509461299 * sp[29] + 5.196152422706626 * sp[32] + 1.876388374866283 * sp[28] + -1.804219591217486 * sp[29] + 1.948557158514983 * sp[26] + -1.732050807568758 * sp[27] + 1.876388374866303 * sp[31] + 1.876388374866335 * sp[32] + 1.876388374866271 * sp[27] + 1.587713240271567 * sp[30];
    A[156] = 2.742413778650655 * sp[33] + 0.7216878364868284 * sp[34] + 0.7216878364869879 * sp[28] + 0.7216878364869621 * sp[31] + 17.89785834487828 * sp[34] + 24.75389279150502 * sp[35] + 2.525907427704585 * sp[29] + 5.051814855409154 * sp[32] + 10.96965511460295 * sp[28] + 9.165435523385295 * sp[29] + 18.11436469582459 * sp[26] + 16.31014510460695 * sp[27] + 19.91858428704207 * sp[31] + 19.34123401785233 * sp[32] + 19.91858428704216 * sp[27] + 17.46484564298615 * sp[30];
    A[157] = 10.39230484541334 * sp[33] + -1.443375672973982 * sp[34] + -1.443375672974076 * sp[28] + -1.443375672974041 * sp[31] + -30.02221399786039 * sp[34] + -19.1968964505549 * sp[35] + -12.26869322027954 * sp[29] + -10.10362971081833 * sp[32] + -16.16580753730965 * sp[28] + -5.340489990004044 * sp[29] + -26.12509968083071 * sp[26] + -15.29978213352506 * sp[27] + -36.95041722813603 * sp[31] + -15.58845726811977 * sp[32] + -36.95041722813618 * sp[27] + -21.93931022920567 * sp[30];
    A[158] = -13.13471862406401 * sp[33] + -0.7216878364868879 * sp[34] + -0.721687836486975 * sp[28] + -0.7216878364869468 * sp[31] + 12.1243556529821 * sp[34] + -6.278684177437039 * sp[35] + 9.021097956087921 * sp[29] + -5.051814855409148 * sp[32] + 5.196152422706709 * sp[28] + -4.546633369868329 * sp[29] + 7.289047148519082 * sp[26] + -2.453738644056002 * sp[27] + 17.03183294109397 * sp[31] + -12.41303078757689 * sp[32] + 17.03183294109403 * sp[27] + -7.072540797572959 * sp[30];
    A[159] = 4.082482904638933 * sp[33] + 8.164965809277518 * sp[34] + 8.164965809277152 * sp[28] + 8.164965809276888 * sp[31] + -4.082482904638354 * sp[34] + 14.28869016623502 * sp[35] + 14.28869016623505 * sp[29] + 57.15476066494002 * sp[32] + -28.57738033247071 * sp[28] + -34.70110468942848 * sp[29] + 63.27848502189898 * sp[26] + 57.15476066494105 * sp[27] + -28.57738033247051 * sp[31] + -4.082482904638951 * sp[32] + 69.40220937885684 * sp[27] + 102.0620726159654 * sp[30];
    A[160] = 189.9999999999995 * sp[33] + 57.49999999999882 * sp[34] + 12.49999999999961 * sp[28] + 12.4999999999992 * sp[31] + 57.49999999999882 * sp[34] + 132.4999999999984 * sp[35] + 12.49999999999973 * sp[29] + 87.49999999999876 * sp[32] + 12.49999999999961 * sp[28] + 12.49999999999973 * sp[29] + 132.5000000000005 * sp[26] + 132.5000000000004 * sp[27] + 12.4999999999992 * sp[31] + 87.49999999999876 * sp[32] + 132.5000000000004 * sp[27] + 189.9999999999995 * sp[30];
    A[161] = -31.75426480542917 * sp[33] + 105.3664241271069 * sp[34] + -7.216878364870619 * sp[28] + -7.216878364870393 * sp[31] + -7.216878364869847 * sp[34] + 57.73502691896256 * sp[35] + -28.86751345948135 * sp[29] + -50.5181485540916 * sp[32] + 1.443375672973969 * sp[28] + 23.09401076758494 * sp[29] + 5.773502691896395 * sp[26] + 27.42413778650727 * sp[27] + 1.4433756729742 * sp[31] + 10.10362971081847 * sp[32] + -15.8771324027146 * sp[27] + -31.75426480542889 * sp[30];
    A[162] = 28.57738033247013 * sp[33] + -4.082482904639336 * sp[34] + 69.40220937885701 * sp[28] + -4.082482904638946 * sp[31] + 8.164965809276733 * sp[34] + -22.45365597551276 * sp[35] + -22.45365597551244 * sp[29] + -28.57738033247035 * sp[32] + 8.164965809277401 * sp[28] + 26.53613888015099 * sp[29] + -71.44345083117652 * sp[26] + -53.07227776030285 * sp[27] + 8.164965809277113 * sp[31] + 8.164965809277074 * sp[32] + -89.81462390205014 * sp[27] + -69.40220937885722 * sp[30];
    A[163] = -67.50000000000072 * sp[33] + 7.500000000000039 * sp[34] + 7.499999999998909 * sp[28] + 52.50000000000036 * sp[31] + 3.749999999999981 * sp[35] + 48.74999999999874 * sp[29] + -22.49999999999961 * sp[32] + 90.00000000000068 * sp[28] + 93.7500000000008 * sp[29] + -41.25000000000006 * sp[26] + -37.49999999999942 * sp[27] + 90.00000000000045 * sp[31] + 90.00000000000075 * sp[32] + -30.00000000000099 * sp[27] + -67.49999999999913 * sp[30];
    A[164] = 50.51814855409169 * sp[33] + -7.216878364871537 * sp[34] + 44.74464586219597 * sp[28] + 105.3664241271054 * sp[31] + 14.4337567297397 * sp[34] + -39.69283100678724 * sp[35] + 72.89047148518969 * sp[29] + 62.06515393788322 * sp[32] + 14.43375672974092 * sp[28] + 46.90970937165693 * sp[29] + -13.71206889325355 * sp[26] + 18.7638837486624 * sp[27] + 14.4337567297404 * sp[31] + 14.43375672974037 * sp[32] + 31.75426480542914 * sp[27] + 50.518148554091 * sp[30];
    A[165] = -6.83333333333331 * sp[33] + 2.416666666666669 * sp[34] + 0.08333333333332811 * sp[28] + 0.08333333333329537 * sp[31] + 1.583333333333384 * sp[34] + 3.749999999999967 * sp[35] + -4.916666666666663 * sp[29] + 0.5833333333333339 * sp[32] + 0.08333333333329618 * sp[28] + -1.25000000000001 * sp[29] + -5.916666666666699 * sp[26] + -0.9166666666666407 * sp[27] + 0.08333333333330017 * sp[31] + 0.08333333333337012 * sp[32] + -10.91666666666673 * sp[27] + -1.833333333333309 * sp[30];
    A[166] = 11.16666666666666 * sp[33] + -8.166666666666675 * sp[34] + 3.166666666666689 * sp[28] + 3.166666666666742 * sp[31] + 1.833333333333302 * sp[34] + -16.66666666666665 * sp[35] + 10.66666666666666 * sp[29] + -7.833333333333401 * sp[32] + -5.166666666666681 * sp[28] + 3.333333333333356 * sp[29] + 2.66666666666669 * sp[26] + -4.833333333333373 * sp[27] + -5.166666666666679 * sp[31] + -5.16666666666675 * sp[32] + 10.16666666666672 * sp[27] + -17.1666666666667 * sp[30];
    A[167] = 4.833333333333361 * sp[33] + 14.91666666666671 * sp[34] + -4.083333333333366 * sp[28] + -4.083333333333372 * sp[31] + 2.416666666666678 * sp[34] + 22.91666666666669 * sp[35] + -5.75 * sp[29] + 11.41666666666676 * sp[32] + -4.083333333333377 * sp[28] + -12.0833333333334 * sp[29] + 3.250000000000027 * sp[26] + 4.916666666666707 * sp[27] + -4.083333333333371 * sp[31] + -4.083333333333316 * sp[32] + 1.583333333333342 * sp[27] + 19.83333333333343 * sp[30];
    A[168] = -3.583333333333375 * sp[33] + -7.000000000000028 * sp[34] + -2.66666666666668 * sp[28] + -6.999999999999993 * sp[31] + -4.916666666666705 * sp[34] + -7.708333333333331 * sp[35] + 4.458333333333296 * sp[29] + 2.166666666666645 * sp[32] + 6.583333333333414 * sp[28] + 7.29166666666671 * sp[29] + 5.458333333333439 * sp[26] + 6.166666666666718 * sp[27] + 6.583333333333407 * sp[31] + 6.583333333333337 * sp[32] + 6.58333333333351 * sp[27] + 6.916666666666732 * sp[30];
    A[169] = 9.666666666666714 * sp[33] + 17.33333333333337 * sp[34] + 6.999999999999981 * sp[28] + 17.33333333333334 * sp[31] + 4.83333333333335 * sp[34] + 24.58333333333336 * sp[35] + -11.41666666666667 * sp[29] + -2.666666666666702 * sp[32] + -8.166666666666746 * sp[28] + -15.41666666666675 * sp[29] + -3.41666666666671 * sp[26] + -10.66666666666675 * sp[27] + -8.166666666666739 * sp[31] + -8.166666666666661 * sp[32] + -8.16666666666676 * sp[27] + -18.00000000000016 * sp[30];
    A[170] = 5.583333333333321 * sp[33] + -10.33333333333335 * sp[34] + 10.66666666666668 * sp[28] + -10.33333333333336 * sp[31] + 0.916666666666652 * sp[34] + -18.95833333333333 * sp[35] + 4.874999999999964 * sp[29] + 0.5 * sp[32] + -2.583333333333338 * sp[28] + 6.041666666666704 * sp[29] + -4.125000000000002 * sp[26] + 4.500000000000062 * sp[27] + -2.583333333333337 * sp[31] + -2.583333333333396 * sp[32] + -2.583333333333312 * sp[27] + 11.08333333333336 * sp[30];
    A[171] = -1.083333333333309 * sp[33] + -2.416666666666638 * sp[34] + -2.416666666666696 * sp[28] + -2.416666666666683 * sp[31] + 12.16666666666667 * sp[34] + 27.95833333333339 * sp[35] + -2.208333333333344 * sp[29] + 8.083333333333389 * sp[32] + -1.833333333333321 * sp[28] + -2.041666666666608 * sp[29] + 1.791666666666688 * sp[26] + 1.58333333333337 * sp[27] + 2.000000000000052 * sp[31] + 14.3333333333336 * sp[32] + 1.999999999999996 * sp[27] + 9.416666666666774 * sp[30];
    A[172] = -2.000000000000013 * sp[33] + -0.1666666666666485 * sp[34] + -0.1666666666666599 * sp[28] + -0.1666666666666413 * sp[31] + -2.666666666666606 * sp[34] + -8.416666666666643 * sp[35] + 3.583333333333339 * sp[29] + -1.166666666666664 * sp[32] + 5.333333333333299 * sp[28] + 1.583333333333281 * sp[29] + 5.583333333333366 * sp[26] + 1.833333333333304 * sp[27] + 9.333333333333274 * sp[31] + 2.999999999999887 * sp[32] + 9.33333333333341 * sp[27] + 3.666666666666619 * sp[30];
    A[173] = 3.083333333333345 * sp[33] + -1.583333333333432 * sp[34] + -1.583333333333341 * sp[28] + -1.583333333333391 * sp[31] + -9.500000000000044 * sp[34] + 13.37500000000006 * sp[35] + -8.458333333333332 * sp[29] + 3.916666666666694 * sp[32] + -3.499999999999992 * sp[28] + 3.375000000000058 * sp[29] + -4.458333333333377 * sp[26] + 2.416666666666695 * sp[27] + -11.33333333333333 * sp[31] + 17.66666666666674 * sp[32] + -11.33333333333341 * sp[27] + 8.583333333333348 * sp[30];
    A[174] = 25.92724864350687 * sp[33] + 37.71236166328278 * sp[34] + 9.428090415820641 * sp[28] + 9.428090415820753 * sp[31] + 16.49915822768613 * sp[34] + -64.81812160876711 * sp[35] + 20.03469213361882 * sp[29] + -18.85618083164141 * sp[32] + -25.927248643507 * sp[28] + -36.5338503613053 * sp[29] + -8.249579113843033 * sp[26] + -18.85618083164127 * sp[27] + -25.92724864350699 * sp[31] + -124.922198009624 * sp[32] + 2.357022603955166 * sp[27] + -58.92556509887885 * sp[30];
    A[175] = -31.75426480542917 * sp[33] + -7.216878364869847 * sp[34] + 1.443375672973969 * sp[28] + 1.4433756729742 * sp[31] + 105.3664241271069 * sp[34] + 57.73502691896256 * sp[35] + 23.09401076758494 * sp[29] + 10.10362971081847 * sp[32] + -7.216878364870619 * sp[28] + -28.86751345948135 * sp[29] + 5.773502691896395 * sp[26] + -15.8771324027146 * sp[27] + -7.216878364870393 * sp[31] + -50.5181485540916 * sp[32] + 27.42413778650727 * sp[27] + -31.75426480542889 * sp[30];
    A[176] = 53.33333333333346 * sp[33] + 14.16666666666665 * sp[34] + -30.83333333333356 * sp[28] + -30.83333333333354 * sp[31] + 14.16666666666665 * sp[34] + 219.1666666666674 * sp[35] + -30.83333333333335 * sp[29] + 84.16666666666737 * sp[32] + -30.83333333333356 * sp[28] + -30.83333333333335 * sp[29] + 39.16666666666696 * sp[26] + 39.1666666666669 * sp[27] + -30.83333333333354 * sp[31] + 84.16666666666737 * sp[32] + 39.1666666666669 * sp[27] + 153.3333333333341 * sp[30];
    A[177] = -58.92556509887911 * sp[33] + -25.92724864350689 * sp[34] + -40.06938426723762 * sp[28] + 2.357022603955231 * sp[31] + -18.85618083164121 * sp[34] + -22.39171473757421 * sp[35] + 5.892556509888148 * sp[29] + -11.78511301977597 * sp[32] + 37.71236166328282 * sp[28] + 34.17682775735001 * sp[29] + 5.89255650988768 * sp[26] + 2.357022603955071 * sp[27] + 37.71236166328279 * sp[31] + 37.71236166328276 * sp[32] + 9.428090415820371 * sp[27] + -2.357022603955201 * sp[30];
    A[178] = 12.99038105676664 * sp[33] + -4.330127018922257 * sp[34] + -4.330127018922227 * sp[28] + -12.99038105676662 * sp[31] + -25.98076211353328 * sp[34] + 10.82531754730563 * sp[35] + 2.16506350946079 * sp[29] + 12.99038105676667 * sp[32] + 25.98076211353342 * sp[28] + 10.82531754730556 * sp[29] + 36.80607966083909 * sp[26] + 21.65063509461092 * sp[27] + 25.98076211353342 * sp[31] + 25.98076211353313 * sp[32] + -8.660254037843561 * sp[27] + 12.99038105676616 * sp[30];
    A[179] = -104.1666666666669 * sp[33] + -45.83333333333356 * sp[34] + -55.83333333333329 * sp[28] + -0.8333333333332087 * sp[31] + -33.33333333333321 * sp[34] + -39.58333333333358 * sp[35] + 5.416666666666849 * sp[29] + -25.83333333333388 * sp[32] + 66.66666666666715 * sp[28] + 60.41666666666699 * sp[29] + 5.416666666666674 * sp[26] + -0.8333333333334121 * sp[27] + 66.66666666666711 * sp[31] + 66.66666666666708 * sp[32] + -3.333333333333247 * sp[27] + -104.1666666666667 * sp[30];
    A[180] = 5.892556509887864 * sp[33] + -3.299831645537231 * sp[34] + 0.4714045207910353 * sp[28] + 0.4714045207910698 * sp[31] + -1.649915822768637 * sp[34] + -2.47487373415293 * sp[35] + -2.003469213361916 * sp[29] + 0.4714045207910301 * sp[32] + 16.7348604880817 * sp[28] + 3.181980515339541 * sp[29] + -7.660323462854307 * sp[26] + -5.185449728701302 * sp[27] + 4.006938426723819 * sp[31] + 4.006938426723851 * sp[32] + -10.1351971970073 * sp[27] + -4.006938426723785 * sp[30];
    A[181] = -11.78511301977579 * sp[33] + 8.956685895029612 * sp[34] + -3.299831645537241 * sp[28] + -3.299831645537303 * sp[31] + -3.771236166328259 * sp[34] + 2.592724864350727 * sp[35] + 1.649915822768612 * sp[29] + -3.299831645537264 * sp[32] + -12.25651754056683 * sp[28] + 5.421151989096808 * sp[29] + -1.17851130197758 * sp[26] + -6.128258770283473 * sp[27] + -0.9428090415820713 * sp[31] + -0.9428090415821013 * sp[32] + 3.771236166328304 * sp[27] + -3.7712361663283 * sp[30];
    A[182] = -5.892556509887931 * sp[33] + -17.44196726926822 * sp[34] + 5.185449728701388 * sp[28] + 5.185449728701395 * sp[31] + -4.006938426723798 * sp[34] + -10.72445284799604 * sp[35] + 3.889087296526028 * sp[29] + 5.185449728701379 * sp[32] + 0.2357022603955465 * sp[28] + -5.067598598503516 * sp[29] + -1.767766952966411 * sp[26] + -0.47140452079105 * sp[27] + 1.649915822768635 * sp[31] + 1.649915822768643 * sp[32] + -3.064129385141758 * sp[27] + -1.649915822768621 * sp[30];
    A[183] = 5.892556509887952 * sp[33] + 9.192388155425153 * sp[34] + 5.421151989096886 * sp[28] + 9.192388155425119 * sp[31] + 7.542472332656555 * sp[34] + 8.367430244040833 * sp[35] + 5.067598598503659 * sp[29] + 5.892556509887921 * sp[32] + -10.84230397819382 * sp[28] + -4.360491817317138 * sp[29] + -18.97403196183906 * sp[26] + -6.835365551470053 * sp[27] + -5.185449728701412 * sp[31] + -5.185449728701436 * sp[32] + -5.185449728701332 * sp[27] + -4.006938426723813 * sp[30];
    A[184] = -11.78511301977585 * sp[33] + -20.74179891480545 * sp[34] + -8.485281374238552 * sp[28] + -20.7417989148054 * sp[31] + -8.013876853447588 * sp[34] + -14.37783788412653 * sp[35] + -3.064129385141713 * sp[29] + -9.428090415820702 * sp[32] + 0.47140452079109 * sp[28] + -3.064129385141606 * sp[29] + 2.592724864350671 * sp[26] + 1.88561808316415 * sp[27] + 3.299831645537266 * sp[31] + 3.299831645537274 * sp[32] + 3.299831645537213 * sp[27] + 5.656854249492358 * sp[30];
    A[185] = -5.892556509887884 * sp[33] + 11.5494107593803 * sp[34] + -11.07800623858926 * sp[28] + 11.54941075938031 * sp[31] + -1.885618083164129 * sp[34] + 4.831896338108133 * sp[35] + -3.181980515339466 * sp[29] + 3.535533905932832 * sp[32] + -6.128258770283397 * sp[28] + 6.246109900481123 * sp[29] + -13.08147545195113 * sp[26] + 4.9497474683058 * sp[27] + -0.4714045207910324 * sp[31] + -0.4714045207910516 * sp[32] + -0.4714045207910089 * sp[27] + -1.649915822768618 * sp[30];
    A[186] = 2.357022603955135 * sp[33] + 4.006938426723742 * sp[34] + 4.006938426723805 * sp[28] + 4.006938426723788 * sp[31] + 0.2357022603954957 * sp[34] + -0.2357022603954957 * sp[35] + 4.478342947514792 * sp[29] + 4.006938426723769 * sp[32] + -11.07800623858927 * sp[28] + -12.96362432175338 * sp[29] + -8.249579113843119 * sp[26] + -8.720983634634109 * sp[27] + -7.778174593052073 * sp[31] + -8.72098363463407 * sp[32] + -7.778174593052123 * sp[27] + -7.542472332656553 * sp[30];
    A[187] = -0.942809041582085 * sp[34] + -0.9428090415820687 * sp[28] + -0.9428090415820858 * sp[31] + 1.885618083164115 * sp[34] + 0.4714045207910256 * sp[35] + 0.4714045207910806 * sp[29] + -0.9428090415820447 * sp[32] + 24.51303508113369 * sp[28] + 11.78511301977576 * sp[29] + 11.78511301977585 * sp[26] + 10.37089945740266 * sp[27] + 13.19932658214895 * sp[31] + 5.65685424949239 * sp[32] + 13.19932658214904 * sp[27] + 8.013876853447572 * sp[30];
    A[188] = -2.357022603955172 * sp[33] + 1.64991582276872 * sp[34] + 1.649915822768612 * sp[28] + 1.649915822768669 * sp[31] + -2.121320343559621 * sp[34] + 2.121320343559704 * sp[35] + -2.592724864350699 * sp[29] + 1.649915822768631 * sp[32] + -13.43502884254443 * sp[28] + 3.535533905932816 * sp[29] + -1.178511301977566 * sp[26] + 3.064129385141787 * sp[27] + -5.421151989096879 * sp[31] + 3.064129385141735 * sp[32] + -5.421151989096921 * sp[27] + 1.885618083164172 * sp[30];
    A[189] = -33.3333333333335 * sp[33] + -46.66666666666697 * sp[34] + -6.666666666666662 * sp[28] + -6.666666666666803 * sp[31] + -26.66666666666683 * sp[34] + -36.66666666666695 * sp[35] + 3.333333333333249 * sp[29] + -6.666666666666813 * sp[32] + 13.33333333333362 * sp[28] + 3.333333333333524 * sp[29] + -36.66666666666685 * sp[26] + -46.66666666666675 * sp[27] + 13.33333333333352 * sp[31] + 13.3333333333334 * sp[32] + -26.66666666666696 * sp[27] + -33.33333333333358 * sp[30];
    A[190] = 28.57738033247013 * sp[33] + 8.164965809276733 * sp[34] + 8.164965809277401 * sp[28] + 8.164965809277113 * sp[31] + -4.082482904639336 * sp[34] + -22.45365597551276 * sp[35] + 26.53613888015099 * sp[29] + 8.164965809277074 * sp[32] + 69.40220937885701 * sp[28] + -22.45365597551244 * sp[29] + -71.44345083117652 * sp[26] + -89.81462390205014 * sp[27] + -4.082482904638946 * sp[31] + -28.57738033247035 * sp[32] + -53.07227776030285 * sp[27] + -69.40220937885722 * sp[30];
    A[191] = -58.92556509887911 * sp[33] + -18.85618083164121 * sp[34] + 37.71236166328282 * sp[28] + 37.71236166328279 * sp[31] + -25.92724864350689 * sp[34] + -22.39171473757421 * sp[35] + 34.17682775735001 * sp[29] + 37.71236166328276 * sp[32] + -40.06938426723762 * sp[28] + 5.892556509888148 * sp[29] + 5.89255650988768 * sp[26] + 9.428090415820371 * sp[27] + 2.357022603955231 * sp[31] + -11.78511301977597 * sp[32] + 2.357022603955071 * sp[27] + -2.357022603955201 * sp[30];
    A[192] = 66.66666666666684 * sp[33] + 33.33333333333351 * sp[34] + 33.33333333333321 * sp[28] + -6.666666666666777 * sp[31] + 33.33333333333351 * sp[34] + 33.33333333333339 * sp[35] + -6.666666666666792 * sp[29] + -6.66666666666672 * sp[32] + 33.33333333333321 * sp[28] + -6.666666666666792 * sp[29] + 113.3333333333337 * sp[26] + 33.33333333333359 * sp[27] + -6.666666666666777 * sp[31] + -6.66666666666672 * sp[32] + 33.33333333333359 * sp[27] + 26.66666666666708 * sp[30];
    A[193] = 12.247448713916 * sp[34] + 12.24744871391598 * sp[28] + 12.24744871391601 * sp[31] + 36.74234614174779 * sp[34] + 24.49489742783174 * sp[35] + 24.49489742783188 * sp[29] + 12.24744871391584 * sp[32] + -110.2270384252438 * sp[28] + -48.98979485566408 * sp[29] + -48.98979485566356 * sp[26] + 36.74234614174732 * sp[27] + -36.74234614174808 * sp[31] + -36.74234614174831 * sp[32] + 12.24744871391606 * sp[27] + 24.49489742783143 * sp[30];
    A[194] = 117.8511301977582 * sp[33] + 58.92556509887922 * sp[34] + 58.9255650988789 * sp[28] + 2.357022603955017 * sp[31] + 58.92556509887925 * sp[34] + 58.92556509887903 * sp[35] + 2.357022603955151 * sp[29] + 2.357022603954562 * sp[32] + 58.92556509887865 * sp[28] + -11.78511301977605 * sp[29] + 44.78342947514815 * sp[26] + -11.78511301977565 * sp[27] + -11.78511301977599 * sp[31] + -11.78511301977591 * sp[32] + -11.78511301977583 * sp[27] + -9.428090415820883 * sp[30];
    A[195] = -16.88749537379671 * sp[33] + -5.196152422706717 * sp[34] + 5.196152422706665 * sp[28] + 5.196152422706609 * sp[31] + -7.361215932167815 * sp[34] + -6.278684177437303 * sp[35] + 11.90784930203618 * sp[29] + 5.196152422706646 * sp[32] + -7.361215932167775 * sp[28] + 4.979646071760514 * sp[29] + -21.86714144555724 * sp[26] + -1.732050807568885 * sp[27] + 3.897114317029945 * sp[31] + 3.897114317029919 * sp[32] + -15.1554445662276 * sp[27] + -3.897114317029883 * sp[30];
    A[196] = 7.794228634060015 * sp[33] + -2.598076211353281 * sp[34] + 2.598076211353348 * sp[28] + 2.598076211353373 * sp[31] + 1.732050807568902 * sp[34] + -0.4330127018921353 * sp[35] + -2.165063509461153 * sp[29] + 2.5980762113534 * sp[32] + 1.732050807568887 * sp[28] + -5.629165124598794 * sp[29] + 13.42339375865891 * sp[26] + -0.8660254037846384 * sp[27] + -3.464101615137751 * sp[31] + -3.464101615137699 * sp[32] + 8.66025403784438 * sp[27] + -5.19615242270659 * sp[30];
    A[197] = -3.897114317030013 * sp[33] + -5.196152422706674 * sp[34] + 5.196152422706676 * sp[28] + 5.196152422706657 * sp[31] + -3.031088913245569 * sp[34] + -4.11362066797613 * sp[35] + 5.4126587736528 * sp[29] + 5.196152422706632 * sp[32] + -3.031088913245556 * sp[28] + -1.515544456622851 * sp[29] + -2.3815698604072 * sp[26] + -1.732050807568769 * sp[27] + -0.4330127018922375 * sp[31] + -0.4330127018922529 * sp[32] + -2.165063509461076 * sp[27] + 0.4330127018921945 * sp[30];
    A[198] = 16.8874953737967 * sp[33] + 11.69134295109002 * sp[34] + 22.0836477965033 * sp[28] + 11.69134295109003 * sp[31] + 9.526279441628922 * sp[34] + 10.60881119635948 * sp[35] + 2.814582562299464 * sp[29] + 3.897114317030043 * sp[32] + 9.526279441628878 * sp[28] + -0.6495190528383068 * sp[29] + 36.58957330989248 * sp[26] + 19.48557158514982 * sp[27] + -1.732050807568828 * sp[31] + -1.732050807568829 * sp[32] + -1.732050807568818 * sp[27] + 0.433012701892227 * sp[30];
    A[199] = -7.794228634060016 * sp[33] + -10.39230484541333 * sp[34] + -5.196152422706628 * sp[28] + -10.39230484541326 * sp[31] + -6.062177826491131 * sp[34] + -8.227241335952229 * sp[35] + -1.299038105676664 * sp[29] + -3.464101615137753 * sp[32] + -6.062177826491107 * sp[28] + -3.031088913245624 * sp[29] + -16.88749537379647 * sp[26] + -17.3205080756887 * sp[27] + -0.8660254037844759 * sp[31] + -0.8660254037844788 * sp[32] + -0.8660254037844823 * sp[27] + 3.464101615137752 * sp[30];
    A[200] = 3.897114317029992 * sp[33] + -1.29903810567664 * sp[34] + 9.09326673973667 * sp[28] + -1.299038105676625 * sp[31] + 0.8660254037844445 * sp[34] + -0.2165063509460619 * sp[35] + 0.6495190528383303 * sp[29] + -0.4330127018921599 * sp[32] + 0.8660254037844379 * sp[28] + -2.814582562299352 * sp[29] + 8.443747686898284 * sp[26] + -2.165063509461048 * sp[27] + -1.732050807568871 * sp[31] + -1.732050807568833 * sp[32] + -1.73205080756886 * sp[27] + -3.897114317029969 * sp[30];
    A[201] = 10.39230484541331 * sp[33] + 11.69134295108997 * sp[34] + 11.69134295109 * sp[28] + 11.69134295108997 * sp[31] + 7.361215932167805 * sp[34] + 6.062177826491085 * sp[35] + 12.99038105676669 * sp[29] + 11.69134295108998 * sp[32] + 7.361215932167593 * sp[28] + 12.99038105676645 * sp[29] + -7.794228634059977 * sp[26] + -3.897114317029995 * sp[27] + -6.495190528383217 * sp[31] + -8.227241335952131 * sp[32] + -6.495190528383217 * sp[27] + -6.062177826490995 * sp[30];
    A[202] = -20.78460969082663 * sp[33] + -10.39230484541328 * sp[34] + -10.39230484541332 * sp[28] + -10.39230484541325 * sp[31] + -10.3923048454134 * sp[34] + -3.464101615137787 * sp[35] + -17.32050807568896 * sp[29] + -10.39230484541331 * sp[32] + -10.39230484541305 * sp[28] + -17.32050807568866 * sp[29] + 24.24871130596446 * sp[26] + 3.464101615137817 * sp[27] + 17.32050807568864 * sp[31] + 3.464101615137656 * sp[32] + 17.32050807568867 * sp[27] + 7.794228634059799 * sp[30];
    A[203] = 10.39230484541332 * sp[33] + -1.299038105676696 * sp[34] + -1.299038105676706 * sp[28] + -1.299038105676734 * sp[31] + 3.031088913245594 * sp[34] + -2.598076211353356 * sp[35] + 4.330127018922255 * sp[29] + -1.299038105676735 * sp[32] + 3.031088913245437 * sp[28] + 4.33012701892233 * sp[29] + -16.45448267190449 * sp[26] + 0.4330127018923413 * sp[27] + -10.82531754730544 * sp[31] + 4.763139720814377 * sp[32] + -10.82531754730546 * sp[27] + 2.598076211353326 * sp[30];
    A[204] = -36.74234614174803 * sp[33] + -36.74234614174794 * sp[34] + 36.74234614174796 * sp[28] + 36.74234614174784 * sp[31] + -24.49489742783205 * sp[34] + -30.61862178478981 * sp[35] + 42.86607049870599 * sp[29] + 36.74234614174807 * sp[32] + -24.49489742783194 * sp[28] + -6.123724356958395 * sp[29] + -30.61862178478983 * sp[26] + -12.24744871391663 * sp[27] + -24.49489742783145 * sp[27] + -36.74234614174714 * sp[30];
    A[205] = -67.50000000000072 * sp[33] + 90.00000000000068 * sp[28] + 90.00000000000045 * sp[31] + 7.500000000000039 * sp[34] + 3.749999999999981 * sp[35] + 93.7500000000008 * sp[29] + 90.00000000000075 * sp[32] + 7.499999999998909 * sp[28] + 48.74999999999874 * sp[29] + -41.25000000000006 * sp[26] + -30.00000000000099 * sp[27] + 52.50000000000036 * sp[31] + -22.49999999999961 * sp[32] + -37.49999999999942 * sp[27] + -67.49999999999913 * sp[30];
    A[206] = 12.99038105676664 * sp[33] + -25.98076211353328 * sp[34] + 25.98076211353342 * sp[28] + 25.98076211353342 * sp[31] + -4.330127018922257 * sp[34] + 10.82531754730563 * sp[35] + 10.82531754730556 * sp[29] + 25.98076211353313 * sp[32] + -4.330127018922227 * sp[28] + 2.16506350946079 * sp[29] + 36.80607966083909 * sp[26] + -8.660254037843561 * sp[27] + -12.99038105676662 * sp[31] + 12.99038105676667 * sp[32] + 21.65063509461092 * sp[27] + 12.99038105676616 * sp[30];
    A[207] = 36.74234614174779 * sp[34] + -110.2270384252438 * sp[28] + -36.74234614174808 * sp[31] + 12.247448713916 * sp[34] + 24.49489742783174 * sp[35] + -48.98979485566408 * sp[29] + -36.74234614174831 * sp[32] + 12.24744871391598 * sp[28] + 24.49489742783188 * sp[29] + -48.98979485566356 * sp[26] + 12.24744871391606 * sp[27] + 12.24744871391601 * sp[31] + 12.24744871391584 * sp[32] + 36.74234614174732 * sp[27] + 24.49489742783143 * sp[30];
    A[208] = 135.0000000000012 * sp[33] + 67.50000000000065 * sp[34] + 67.50000000000037 * sp[28] + -22.49999999999969 * sp[31] + 67.50000000000065 * sp[34] + 67.50000000000082 * sp[35] + -22.50000000000009 * sp[29] + -22.49999999999965 * sp[32] + 67.50000000000037 * sp[28] + -22.50000000000009 * sp[29] + 247.4999999999998 * sp[26] + 67.50000000000021 * sp[27] + -22.49999999999969 * sp[31] + -22.49999999999965 * sp[32] + 67.50000000000021 * sp[27] + 59.99999999999974 * sp[30];
    A[209] = 64.9519052838331 * sp[34] + -38.97114317030019 * sp[28] + 12.99038105676635 * sp[31] + 21.65063509461118 * sp[34] + 43.30127018922187 * sp[35] + -8.660254037844377 * sp[29] + 12.99038105676658 * sp[32] + 21.65063509461114 * sp[28] + 43.30127018922207 * sp[29] + -8.66025403784505 * sp[26] + 99.59292143520936 * sp[27] + 21.65063509461115 * sp[31] + 21.65063509461086 * sp[32] + -12.99038105676651 * sp[27] + 43.30127018922251 * sp[30];
    A[210] = 10.41666666666659 * sp[33] + -5.833333333333347 * sp[34] + 0.8333333333333394 * sp[28] + 0.8333333333334019 * sp[31] + -2.916666666666717 * sp[34] + -4.375000000000023 * sp[35] + -3.541666666666716 * sp[29] + 0.8333333333333339 * sp[32] + 10.08333333333334 * sp[28] + -2.874999999999992 * sp[29] + 7.95833333333343 * sp[26] + 1.833333333333375 * sp[27] + -1.416666666666649 * sp[31] + -1.416666666666772 * sp[32] + 3.583333333333321 * sp[27] + 2.916666666666639 * sp[30];
    A[211] = -20.8333333333333 * sp[33] + 15.83333333333334 * sp[34] + -5.833333333333362 * sp[28] + -5.833333333333472 * sp[31] + -6.666666666666666 * sp[34] + 4.583333333333418 * sp[35] + 2.916666666666671 * sp[29] + -5.833333333333407 * sp[32] + -12.66666666666665 * sp[28] + 11.58333333333331 * sp[29] + -10.08333333333344 * sp[26] + 2.166666666666587 * sp[27] + 0.3333333333333474 * sp[31] + 0.3333333333335826 * sp[32] + -1.333333333333365 * sp[27] + 13.33333333333322 * sp[30];
    A[212] = -10.41666666666672 * sp[33] + -30.83333333333339 * sp[34] + 9.166666666666734 * sp[28] + 9.166666666666746 * sp[31] + -7.083333333333378 * sp[34] + -18.95833333333343 * sp[35] + 6.875000000000027 * sp[29] + 9.166666666666718 * sp[32] + -4.08333333333333 * sp[28] + -12.4583333333333 * sp[29] + 3.375000000000034 * sp[26] + 0.1666666666666918 * sp[27] + -0.5833333333333124 * sp[31] + -0.5833333333334186 * sp[32] + 1.083333333333322 * sp[27] + -12.91666666666668 * sp[30];
    A[213] = 10.41666666666677 * sp[33] + 16.25000000000006 * sp[34] + 9.583333333333377 * sp[28] + 16.24999999999999 * sp[31] + 13.33333333333342 * sp[34] + 14.79166666666669 * sp[35] + 8.958333333333455 * sp[29] + 10.41666666666671 * sp[32] + 0.3333333333333077 * sp[28] + 3.291666666666655 * sp[29] + 7.458333333333223 * sp[26] + 9.416666666666602 * sp[27] + 1.833333333333285 * sp[31] + 1.833333333333327 * sp[32] + 1.833333333333258 * sp[27] + 2.916666666666614 * sp[30];
    A[214] = -20.83333333333342 * sp[33] + -36.66666666666673 * sp[34] + -14.99999999999996 * sp[28] + -36.66666666666666 * sp[31] + -14.16666666666674 * sp[34] + -25.41666666666676 * sp[35] + -5.41666666666668 * sp[29] + -16.66666666666677 * sp[32] + -8.166666666666654 * sp[28] + -12.41666666666663 * sp[29] + -12.41666666666659 * sp[26] + -24.66666666666659 * sp[27] + -1.166666666666622 * sp[31] + -1.1666666666667 * sp[32] + -1.166666666666592 * sp[27] + 10.00000000000006 * sp[30];
    A[215] = -10.41666666666664 * sp[33] + 20.41666666666669 * sp[34] + -19.58333333333335 * sp[28] + 20.41666666666672 * sp[31] + -3.333333333333333 * sp[34] + 8.541666666666755 * sp[35] + -5.624999999999993 * sp[29] + 6.250000000000162 * sp[32] + -6.333333333333309 * sp[28] + 12.04166666666665 * sp[29] + -12.12500000000005 * sp[26] + 15.24999999999998 * sp[27] + 0.1666666666666717 * sp[31] + 0.1666666666668597 * sp[32] + 0.1666666666666585 * sp[27] + -12.91666666666645 * sp[30];
    A[216] = 4.166666666666625 * sp[33] + 7.083333333333286 * sp[34] + 7.083333333333396 * sp[28] + 7.083333333333368 * sp[31] + 0.4166666666666394 * sp[34] + -0.4166666666666163 * sp[35] + 7.916666666666654 * sp[29] + 7.083333333333337 * sp[32] + 8.416666666666636 * sp[28] + 13.58333333333326 * sp[29] + 1.91666666666671 * sp[26] + 3.083333333333331 * sp[27] + 2.749999999999922 * sp[31] + -8.916666666666906 * sp[32] + 2.749999999999948 * sp[27] + -3.333333333333458 * sp[30];
    A[217] = -1.666666666666708 * sp[34] + -1.666666666666677 * sp[28] + -1.666666666666709 * sp[31] + 3.333333333333302 * sp[34] + 0.8333333333333162 * sp[35] + 0.8333333333334103 * sp[29] + -1.666666666666638 * sp[32] + -12.66666666666665 * sp[28] + -7.166666666666653 * sp[29] + -7.166666666666769 * sp[26] + -3.666666666666687 * sp[27] + -4.666666666666622 * sp[31] + -7.999999999999877 * sp[32] + -4.666666666666625 * sp[27] + -5.833333333333233 * sp[30];
    A[218] = -4.166666666666684 * sp[33] + 2.91666666666686 * sp[34] + 2.916666666666663 * sp[28] + 2.916666666666768 * sp[31] + -3.74999999999996 * sp[34] + 3.75000000000011 * sp[35] + -4.583333333333377 * sp[29] + 2.916666666666702 * sp[32] + 4.24999999999999 * sp[28] + -2.249999999999909 * sp[29] + 9.416666666666767 * sp[26] + -1.083333333333272 * sp[27] + 1.916666666666683 * sp[31] + -13.08333333333321 * sp[32] + 1.916666666666685 * sp[27] + -6.666666666666599 * sp[30];
    A[219] = -58.92556509887923 * sp[33] + -82.49579113843104 * sp[34] + -11.78511301977576 * sp[28] + -11.78511301977602 * sp[31] + -47.14045207910343 * sp[34] + -64.81812160876734 * sp[35] + 5.892556509887768 * sp[29] + -11.78511301977603 * sp[32] + -18.85618083164117 * sp[28] + -22.39171473757406 * sp[29] + -8.249579113843051 * sp[26] + 16.49915822768595 * sp[27] + -4.714045207910202 * sp[31] + 80.13876853447547 * sp[32] + 9.428090415820435 * sp[27] + 54.21151989096802 * sp[30];
    A[220] = 50.51814855409169 * sp[33] + 14.4337567297397 * sp[34] + 14.43375672974092 * sp[28] + 14.4337567297404 * sp[31] + -7.216878364871537 * sp[34] + -39.69283100678724 * sp[35] + 46.90970937165693 * sp[29] + 14.43375672974037 * sp[32] + 44.74464586219597 * sp[28] + 72.89047148518969 * sp[29] + -13.71206889325355 * sp[26] + 31.75426480542914 * sp[27] + 105.3664241271054 * sp[31] + 62.06515393788322 * sp[32] + 18.7638837486624 * sp[27] + 50.518148554091 * sp[30];
    A[221] = -104.1666666666669 * sp[33] + -33.33333333333321 * sp[34] + 66.66666666666715 * sp[28] + 66.66666666666711 * sp[31] + -45.83333333333356 * sp[34] + -39.58333333333358 * sp[35] + 60.41666666666699 * sp[29] + 66.66666666666708 * sp[32] + -55.83333333333329 * sp[28] + 5.416666666666849 * sp[29] + 5.416666666666674 * sp[26] + -3.333333333333247 * sp[27] + -0.8333333333332087 * sp[31] + -25.83333333333388 * sp[32] + -0.8333333333334121 * sp[27] + -104.1666666666667 * sp[30];
    A[222] = 117.8511301977582 * sp[33] + 58.92556509887925 * sp[34] + 58.92556509887865 * sp[28] + -11.78511301977599 * sp[31] + 58.92556509887922 * sp[34] + 58.92556509887903 * sp[35] + -11.78511301977605 * sp[29] + -11.78511301977591 * sp[32] + 58.9255650988789 * sp[28] + 2.357022603955151 * sp[29] + 44.78342947514815 * sp[26] + -11.78511301977583 * sp[27] + 2.357022603955017 * sp[31] + 2.357022603954562 * sp[32] + -11.78511301977565 * sp[27] + -9.428090415820883 * sp[30];
    A[223] = 21.65063509461118 * sp[34] + 21.65063509461114 * sp[28] + 21.65063509461115 * sp[31] + 64.9519052838331 * sp[34] + 43.30127018922187 * sp[35] + 43.30127018922207 * sp[29] + 21.65063509461086 * sp[32] + -38.97114317030019 * sp[28] + -8.660254037844377 * sp[29] + -8.66025403784505 * sp[26] + -12.99038105676651 * sp[27] + 12.99038105676635 * sp[31] + 12.99038105676658 * sp[32] + 99.59292143520936 * sp[27] + 43.30127018922251 * sp[30];
    A[224] = 208.3333333333336 * sp[33] + 104.1666666666671 * sp[34] + 104.1666666666665 * sp[28] + 4.166666666666407 * sp[31] + 104.1666666666671 * sp[34] + 104.1666666666667 * sp[35] + 4.166666666666629 * sp[29] + 4.166666666665602 * sp[32] + 104.1666666666665 * sp[28] + 4.166666666666629 * sp[29] + 104.1666666666668 * sp[26] + 4.166666666666584 * sp[27] + 4.166666666666407 * sp[31] + 4.166666666665602 * sp[32] + 4.166666666666584 * sp[27] + 183.3333333333315 * sp[30];
  }

};


class forms_cell_integral_1_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_1_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_1_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 6
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 6
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           6
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q12[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q12[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q12[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q12[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q12[0][0][1];
    alignas(32) double sp[20];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 / sp[2];
    sp[4] = -1 * J_c1 / sp[2];
    sp[5] = sp[3] * sp[3];
    sp[6] = sp[3] * sp[4];
    sp[7] = sp[4] * sp[4];
    sp[8] = J_c3 / sp[2];
    sp[9] = -1 * J_c2 / sp[2];
    sp[10] = sp[9] * sp[9];
    sp[11] = sp[8] * sp[9];
    sp[12] = sp[8] * sp[8];
    sp[13] = sp[5] + sp[10];
    sp[14] = sp[6] + sp[11];
    sp[15] = sp[12] + sp[7];
    sp[16] = std::abs(sp[2]);
    sp[17] = sp[13] * sp[16];
    sp[18] = sp[14] * sp[16];
    sp[19] = sp[15] * sp[16];
    A[0] = 0.02162698412698431 * sp[19] + -0.01116071428571437 * sp[18] + -0.01116071428571437 * sp[18] + 0.05734126984127032 * sp[17];
    A[1] = -0.02986111111111118 * sp[19] + 0.005952380952380903 * sp[18] + 0.009920634920635015 * sp[18] + -0.04871031746031777 * sp[17];
    A[2] = 0.01765873015873009 * sp[19] + -0.004712301587301558 * sp[18] + -0.004712301587301607 * sp[18] + 0.01765873015873015 * sp[17];
    A[3] = -0.01542658730158741 * sp[19] + -0.02447916666666681 * sp[18] + 0.009052579365079392 * sp[18] + 0.0186011904761906 * sp[17];
    A[4] = 0.01746031746031738 * sp[19] + 0.02167658730158717 * sp[18] + -0.005704365079365078 * sp[18] + -0.01190476190476185 * sp[17];
    A[5] = -0.02385912698412696 * sp[19] + -0.03266369047619052 * sp[18] + 0.006820436507936557 * sp[18] + 0.01116071428571416 * sp[17];
    A[6] = -0.01314484126984131 * sp[19] + -0.008804563492063548 * sp[18] + 0.03067956349206364 * sp[18] + 0.02385912698412709 * sp[17];
    A[7] = 0.02777777777777805 * sp[19] + 0.01413690476190489 * sp[18] + -0.07276785714285777 * sp[18] + -0.06111111111111162 * sp[17];
    A[8] = -0.02058531746031764 * sp[19] + -0.007068452380952363 * sp[18] + 0.05820932539682567 * sp[18] + 0.0511408730158734 * sp[17];
    A[9] = 0.04349267900155124 * sp[19] + -0.02314932914598865 * sp[18] + -0.06243303921190617 * sp[18] + 0.03507474113028569 * sp[17];
    A[10] = 0.06529556615835215 * sp[19] + -0.05154913117764595 * sp[18] + -0.1271545235715235 * sp[18] + 0.06529556615835112 * sp[17];
    A[11] = -0.0168650793650812 * sp[19] + -0.007440476190475788 * sp[18] + 0.07192460317460243 * sp[18] + -0.01091269841269967 * sp[17];
    A[12] = 0.03507474113028562 * sp[19] + 0.1283735525368425 * sp[18] + -0.01192541198429724 * sp[18] + -0.124866078423815 * sp[17];
    A[13] = -0.1005208057964094 * sp[19] + -0.06314768569261547 * sp[18] + 0.07088005536926248 * sp[18] + -0.08505606644311371 * sp[17];
    A[14] = 0.06200396825396911 * sp[19] + 0.09598214285714152 * sp[18] + -0.02108134920634971 * sp[18] + 0.05307539682539852 * sp[17];
    A[15] = -0.02986111111111118 * sp[19] + 0.009920634920635015 * sp[18] + 0.005952380952380903 * sp[18] + -0.04871031746031777 * sp[17];
    A[16] = 0.06865079365079399 * sp[19] + -0.01289682539682546 * sp[18] + -0.01289682539682546 * sp[18] + 0.06865079365079424 * sp[17];
    A[17] = -0.04871031746031763 * sp[19] + 0.005952380952380869 * sp[18] + 0.009920634920634972 * sp[18] + -0.02986111111111127 * sp[17];
    A[18] = 0.0174603174603174 * sp[19] + 0.02316468253968253 * sp[18] + -0.004216269841269752 * sp[18] + -0.01041666666666663 * sp[17];
    A[19] = -0.04384920634920639 * sp[19] + -0.05327380952380974 * sp[18] + 0.009424603174603174 * sp[18] + 0.01785714285714286 * sp[17];
    A[20] = 0.06111111111111138 * sp[19] + 0.07524801587301631 * sp[18] + -0.0116567460317461 * sp[18] + -0.0252976190476191 * sp[17];
    A[21] = 0.01041666666666671 * sp[19] + 0.004216269841269759 * sp[18] + -0.02316468253968258 * sp[18] + -0.01746031746031746 * sp[17];
    A[22] = -0.01785714285714306 * sp[19] + -0.009424603174603233 * sp[18] + 0.05327380952380988 * sp[18] + 0.04384920634920656 * sp[17];
    A[23] = 0.02529761904761937 * sp[19] + 0.01165674603174613 * sp[18] + -0.07524801587301645 * sp[18] + -0.06111111111111164 * sp[17];
    A[24] = -0.07856742013183785 * sp[19] + -0.009820927516479843 * sp[18] + 0.1360899955855051 * sp[18] + 0.07014948226057119 * sp[17];
    A[25] = -0.05326743555023473 * sp[19] + -0.008591521862941334 * sp[18] + 0.1838585678669346 * sp[18] + 0.08419691425682214 * sp[17];
    A[26] = -0.004960317460315044 * sp[19] + 0.01984126984126906 * sp[18] + -0.1626984126984117 * sp[18] + -0.1021825396825402 * sp[17];
    A[27] = -0.07014948226057116 * sp[19] + -0.136089995585506 * sp[18] + 0.009820927516480083 * sp[18] + 0.07856742013183708 * sp[17];
    A[28] = 0.04639421805988016 * sp[19] + 0.04897167461876187 * sp[18] + -0.01288728279441055 * sp[18] + 0.03092947870658585 * sp[17];
    A[29] = -0.1240079365079382 * sp[19] + -0.2405753968253959 * sp[18] + 0.01736111111111155 * sp[18] + 0.04365079365079512 * sp[17];
    A[30] = 0.01765873015873009 * sp[19] + -0.004712301587301607 * sp[18] + -0.004712301587301558 * sp[18] + 0.01765873015873015 * sp[17];
    A[31] = -0.04871031746031763 * sp[19] + 0.009920634920634972 * sp[18] + 0.005952380952380869 * sp[18] + -0.02986111111111127 * sp[17];
    A[32] = 0.05734126984127025 * sp[19] + -0.01116071428571432 * sp[18] + -0.01116071428571432 * sp[18] + 0.02162698412698432 * sp[17];
    A[33] = -0.02385912698412708 * sp[19] + -0.0306795634920637 * sp[18] + 0.008804563492063534 * sp[18] + 0.0131448412698413 * sp[17];
    A[34] = 0.06111111111111157 * sp[19] + 0.07276785714285776 * sp[18] + -0.01413690476190482 * sp[18] + -0.02777777777777793 * sp[17];
    A[35] = -0.05114087301587329 * sp[19] + -0.05820932539682572 * sp[18] + 0.007068452380952331 * sp[18] + 0.02058531746031751 * sp[17];
    A[36] = -0.01860119047619069 * sp[19] + -0.00905257936507938 * sp[18] + 0.02447916666666685 * sp[18] + 0.01542658730158742 * sp[17];
    A[37] = 0.01190476190476204 * sp[19] + 0.005704365079365079 * sp[18] + -0.02167658730158728 * sp[18] + -0.01746031746031744 * sp[17];
    A[38] = -0.01116071428571438 * sp[19] + -0.006820436507936539 * sp[18] + 0.03266369047619064 * sp[18] + 0.02385912698412706 * sp[17];
    A[39] = 0.1248660784238154 * sp[19] + 0.01192541198429702 * sp[18] + -0.1283735525368422 * sp[18] + -0.03507474113028557 * sp[17];
    A[40] = -0.003436608745177563 * sp[19] + -0.01718304372588165 * sp[18] + -0.05154913117764414 * sp[18] + -0.003436608745176412 * sp[17];
    A[41] = 0.1001984126984122 * sp[19] + -0.07192460317460342 * sp[18] + 0.1026785714285712 * sp[18] + 0.1180555555555571 * sp[17];
    A[42] = -0.0350747411302858 * sp[19] + 0.06243303921190661 * sp[18] + 0.02314932914598852 * sp[18] + -0.04349267900155108 * sp[17];
    A[43] = -0.02319710902993956 * sp[19] + 0.001288728279441068 * sp[18] + 0.03221820698602833 * sp[18] + -0.01804219591217487 * sp[17];
    A[44] = -0.06200396825396939 * sp[19] + 0.1460813492063476 * sp[18] + 0.04092261904761967 * sp[18] + -0.06498015873016047 * sp[17];
    A[45] = -0.01542658730158741 * sp[19] + 0.009052579365079392 * sp[18] + -0.02447916666666681 * sp[18] + 0.0186011904761906 * sp[17];
    A[46] = 0.0174603174603174 * sp[19] + -0.004216269841269752 * sp[18] + 0.02316468253968253 * sp[18] + -0.01041666666666663 * sp[17];
    A[47] = -0.02385912698412708 * sp[19] + 0.008804563492063534 * sp[18] + -0.0306795634920637 * sp[18] + 0.0131448412698413 * sp[17];
    A[48] = 0.02162698412698436 * sp[19] + 0.0327876984126987 * sp[18] + 0.0327876984126987 * sp[18] + 0.1012896825396831 * sp[17];
    A[49] = -0.0298611111111113 * sp[19] + -0.03581349206349219 * sp[18] + -0.03978174603174633 * sp[18] + -0.09444444444444482 * sp[17];
    A[50] = 0.01765873015873012 * sp[19] + 0.02237103174603169 * sp[18] + 0.02237103174603176 * sp[18] + 0.04474206349206338 * sp[17];
    A[51] = 0.0205853174603176 * sp[19] + 0.0135168650793652 * sp[18] + 0.07879464285714322 * sp[18] + 0.02058531746031758 * sp[17];
    A[52] = -0.02777777777777799 * sp[19] + -0.01364087301587309 * sp[18] + -0.1005456349206355 * sp[18] + -0.02529761904761922 * sp[17];
    A[53] = 0.01314484126984127 * sp[19] + 0.004340277777777687 * sp[18] + 0.04382440476190481 * sp[18] + 0.01116071428571424 * sp[17];
    A[54] = -0.07856742013183698 * sp[19] + 0.02665680325901717 * sp[18] + -0.1529258713280408 * sp[18] + 0.04208968935634278 * sp[17];
    A[55] = -0.03522523963805742 * sp[19] + 0.07947157723220415 * sp[18] + 0.02104922856420399 * sp[18] + 0.1159855451497029 * sp[17];
    A[56] = -0.04513888888888831 * sp[19] + 0.04340277777777805 * sp[18] + 0.005704365079364558 * sp[18] + 0.05208333333333324 * sp[17];
    A[57] = 0.03507474113028569 * sp[19] + -0.09329881140655695 * sp[18] + 0.04700015311458283 * sp[18] + -0.2062394778460747 * sp[17];
    A[58] = 0.1005208057964094 * sp[19] + 0.03737312010379369 * sp[18] + 0.1714008611656717 * sp[18] + 0.1933092419161692 * sp[17];
    A[59] = 0.0620039682539693 * sp[19] + -0.03397817460317268 * sp[18] + 0.0830853174603189 * sp[18] + 0.04017857142857449 * sp[17];
    A[60] = 0.01746031746031738 * sp[19] + -0.005704365079365078 * sp[18] + 0.02167658730158717 * sp[18] + -0.01190476190476185 * sp[17];
    A[61] = -0.04384920634920639 * sp[19] + 0.009424603174603174 * sp[18] + -0.05327380952380974 * sp[18] + 0.01785714285714286 * sp[17];
    A[62] = 0.06111111111111157 * sp[19] + -0.01413690476190482 * sp[18] + 0.07276785714285776 * sp[18] + -0.02777777777777793 * sp[17];
    A[63] = -0.0298611111111113 * sp[19] + -0.03978174603174633 * sp[18] + -0.03581349206349219 * sp[18] + -0.09444444444444482 * sp[17];
    A[64] = 0.0686507936507942 * sp[19] + 0.08154761904761974 * sp[18] + 0.08154761904761974 * sp[18] + 0.1630952380952394 * sp[17];
    A[65] = -0.04871031746031766 * sp[19] + -0.05466269841269861 * sp[18] + -0.05863095238095276 * sp[18] + -0.09444444444444496 * sp[17];
    A[66] = -0.02529761904761931 * sp[19] + -0.01364087301587309 * sp[18] + -0.1005456349206356 * sp[18] + -0.02777777777777794 * sp[17];
    A[67] = 0.01785714285714301 * sp[19] + 0.008432539682539684 * sp[18] + 0.0711309523809525 * sp[18] + 0.01785714285714282 * sp[17];
    A[68] = -0.01041666666666667 * sp[19] + -0.006200396825396797 * sp[18] + -0.03358134920634908 * sp[18] + -0.01190476190476182 * sp[17];
    A[69] = 0.1487169023924092 * sp[19] + 0.002805979290422735 * sp[18] + 0.2946278254943949 * sp[18];
    A[70] = -0.006873217490354508 * sp[19] + -0.04725337024617514 * sp[18] + -0.1778445025628795 * sp[18] + -0.1030982623552911 * sp[17];
    A[71] = 0.1289682539682541 * sp[19] + -0.09176587301587352 * sp[18] + -0.01636904761904639 * sp[18] + -0.17857142857143 * sp[17];
    A[72] = -0.07014948226057147 * sp[19] + 0.06594051332493477 * sp[18] + -0.07997040977705129 * sp[18] + 0.1346870059402917 * sp[17];
    A[73] = -0.04639421805988027 * sp[19] + 0.00257745655888166 * sp[18] + -0.05928150085429051 * sp[18] + -0.04123930494211492 * sp[17];
    A[74] = -0.1240079365079386 * sp[19] + 0.116567460317458 * sp[18] + -0.1413690476190498 * sp[18] + 0.1428571428571433 * sp[17];
    A[75] = -0.02385912698412696 * sp[19] + 0.006820436507936557 * sp[18] + -0.03266369047619052 * sp[18] + 0.01116071428571416 * sp[17];
    A[76] = 0.06111111111111138 * sp[19] + -0.0116567460317461 * sp[18] + 0.07524801587301631 * sp[18] + -0.0252976190476191 * sp[17];
    A[77] = -0.05114087301587329 * sp[19] + 0.007068452380952331 * sp[18] + -0.05820932539682572 * sp[18] + 0.02058531746031751 * sp[17];
    A[78] = 0.01765873015873012 * sp[19] + 0.02237103174603176 * sp[18] + 0.02237103174603169 * sp[18] + 0.04474206349206338 * sp[17];
    A[79] = -0.04871031746031766 * sp[19] + -0.05863095238095276 * sp[18] + -0.05466269841269861 * sp[18] + -0.09444444444444496 * sp[17];
    A[80] = 0.05734126984127012 * sp[19] + 0.06850198412698452 * sp[18] + 0.06850198412698452 * sp[18] + 0.1012896825396833 * sp[17];
    A[81] = 0.01116071428571437 * sp[19] + 0.004340277777777704 * sp[18] + 0.0438244047619049 * sp[18] + 0.01314484126984122 * sp[17];
    A[82] = -0.01190476190476203 * sp[19] + -0.006200396825396831 * sp[18] + -0.03358134920634905 * sp[18] + -0.01041666666666648 * sp[17];
    A[83] = 0.0186011904761907 * sp[19] + 0.009548611111111192 * sp[18] + 0.0430803571428574 * sp[18] + 0.01860119047619047 * sp[17];
    A[84] = -0.0897913372935298 * sp[19] + -0.01543288609732559 * sp[18] + -0.1950155606843834 * sp[18] + -0.04208968935634275 * sp[17];
    A[85] = -0.02663371777511697 * sp[19] + -0.01073940232867664 * sp[18] + -0.007302793583500569 * sp[18] + -0.0128872827944121 * sp[17];
    A[86] = -0.03819444444444288 * sp[19] + 0.03596230158730113 * sp[18] + 0.1054067460317481 * sp[18] + 0.1264880952380961 * sp[17];
    A[87] = -0.03507474113028548 * sp[19] + -0.09750778034219214 * sp[18] + -0.05822407027627419 * sp[18] + -0.1641497884897314 * sp[17];
    A[88] = 0.02319710902993937 * sp[19] + 0.02448583730938059 * sp[18] + 0.05541531601596755 * sp[18] + 0.07474624020758393 * sp[17];
    A[89] = -0.06200396825396894 * sp[19] + -0.2080853174603165 * sp[18] + -0.1029265873015889 * sp[18] + -0.3139880952380977 * sp[17];
    A[90] = -0.01314484126984131 * sp[19] + 0.03067956349206364 * sp[18] + -0.008804563492063548 * sp[18] + 0.02385912698412709 * sp[17];
    A[91] = 0.01041666666666671 * sp[19] + -0.02316468253968258 * sp[18] + 0.004216269841269759 * sp[18] + -0.01746031746031746 * sp[17];
    A[92] = -0.01860119047619069 * sp[19] + 0.02447916666666685 * sp[18] + -0.00905257936507938 * sp[18] + 0.01542658730158742 * sp[17];
    A[93] = 0.0205853174603176 * sp[19] + 0.07879464285714322 * sp[18] + 0.0135168650793652 * sp[18] + 0.02058531746031758 * sp[17];
    A[94] = -0.02529761904761931 * sp[19] + -0.1005456349206356 * sp[18] + -0.01364087301587309 * sp[18] + -0.02777777777777794 * sp[17];
    A[95] = 0.01116071428571437 * sp[19] + 0.0438244047619049 * sp[18] + 0.004340277777777704 * sp[18] + 0.01314484126984122 * sp[17];
    A[96] = 0.1012896825396833 * sp[19] + 0.03278769841269871 * sp[18] + 0.03278769841269871 * sp[18] + 0.02162698412698432 * sp[17];
    A[97] = -0.09444444444444482 * sp[19] + -0.03978174603174628 * sp[18] + -0.03581349206349222 * sp[18] + -0.02986111111111129 * sp[17];
    A[98] = 0.04474206349206343 * sp[19] + 0.02237103174603173 * sp[18] + 0.02237103174603171 * sp[18] + 0.01765873015873015 * sp[17];
    A[99] = -0.2062394778460755 * sp[19] + 0.04700015311458272 * sp[18] + -0.09329881140655671 * sp[18] + 0.03507474113028559 * sp[17];
    A[100] = 0.131450284502998 * sp[19] + 0.1576544261849668 * sp[18] + -0.01073940232867408 * sp[18] + 0.1039574145415858 * sp[17];
    A[101] = 0.1473214285714273 * sp[19] + 0.1068948412698423 * sp[18] + 0.04935515873015877 * sp[18] + 0.05605158730158792 * sp[17];
    A[102] = 0.0420896893563427 * sp[19] + -0.1529258713280411 * sp[18] + 0.02665680325901705 * sp[18] + -0.07856742013183673 * sp[17];
    A[103] = 0.1030982623552906 * sp[19] + 0.01546473935329254 * sp[18] + 0.07732369676646855 * sp[18] + -0.05670404429540904 * sp[17];
    A[104] = 0.07440476190476301 * sp[19] + 0.01537698412698307 * sp[18] + 0.04712301587301656 * sp[18] + -0.007936507936507811 * sp[17];
    A[105] = 0.02777777777777805 * sp[19] + -0.07276785714285777 * sp[18] + 0.01413690476190489 * sp[18] + -0.06111111111111162 * sp[17];
    A[106] = -0.01785714285714306 * sp[19] + 0.05327380952380988 * sp[18] + -0.009424603174603233 * sp[18] + 0.04384920634920656 * sp[17];
    A[107] = 0.01190476190476204 * sp[19] + -0.02167658730158728 * sp[18] + 0.005704365079365079 * sp[18] + -0.01746031746031744 * sp[17];
    A[108] = -0.02777777777777799 * sp[19] + -0.1005456349206355 * sp[18] + -0.01364087301587309 * sp[18] + -0.02529761904761922 * sp[17];
    A[109] = 0.01785714285714301 * sp[19] + 0.0711309523809525 * sp[18] + 0.008432539682539684 * sp[18] + 0.01785714285714282 * sp[17];
    A[110] = -0.01190476190476203 * sp[19] + -0.03358134920634905 * sp[18] + -0.006200396825396831 * sp[18] + -0.01041666666666648 * sp[17];
    A[111] = -0.09444444444444482 * sp[19] + -0.03581349206349222 * sp[18] + -0.03978174603174628 * sp[18] + -0.02986111111111129 * sp[17];
    A[112] = 0.1630952380952393 * sp[19] + 0.08154761904761974 * sp[18] + 0.08154761904761974 * sp[18] + 0.06865079365079425 * sp[17];
    A[113] = -0.09444444444444484 * sp[19] + -0.0586309523809528 * sp[18] + -0.05466269841269859 * sp[18] + -0.04871031746031778 * sp[17];
    A[114] = 0.1346870059402921 * sp[19] + -0.07997040977705104 * sp[18] + 0.06594051332493422 * sp[18] + -0.07014948226057124 * sp[17];
    A[115] = 0.1030982623552914 * sp[19] + -0.1520699369740544 * sp[18] + 0.1022391101689944 * sp[18] + -0.1305911323167025 * sp[17];
    A[116] = -0.1071428571428559 * sp[19] + 0.0193452380952398 * sp[18] + -0.05605158730158683 * sp[18] + 0.02182539682539825 * sp[17];
    A[117] = 0.2946278254943946 * sp[18] + 0.002805979290423023 * sp[18] + 0.1487169023924087 * sp[17];
    A[118] = -0.2061965247105823 * sp[19] + -0.1030982623552906 * sp[18] + -0.1030982623552912 * sp[18] + 0.1082531754730541 * sp[17];
    A[119] = -0.1458333333333369 * sp[18] + 0.004960317460317807 * sp[18] + -0.07043650793651041 * sp[17];
    A[120] = -0.02058531746031764 * sp[19] + 0.05820932539682567 * sp[18] + -0.007068452380952363 * sp[18] + 0.0511408730158734 * sp[17];
    A[121] = 0.02529761904761937 * sp[19] + -0.07524801587301645 * sp[18] + 0.01165674603174613 * sp[18] + -0.06111111111111164 * sp[17];
    A[122] = -0.01116071428571438 * sp[19] + 0.03266369047619064 * sp[18] + -0.006820436507936539 * sp[18] + 0.02385912698412706 * sp[17];
    A[123] = 0.01314484126984127 * sp[19] + 0.04382440476190481 * sp[18] + 0.004340277777777687 * sp[18] + 0.01116071428571424 * sp[17];
    A[124] = -0.01041666666666667 * sp[19] + -0.03358134920634908 * sp[18] + -0.006200396825396797 * sp[18] + -0.01190476190476182 * sp[17];
    A[125] = 0.0186011904761907 * sp[19] + 0.0430803571428574 * sp[18] + 0.009548611111111192 * sp[18] + 0.01860119047619047 * sp[17];
    A[126] = 0.04474206349206343 * sp[19] + 0.02237103174603171 * sp[18] + 0.02237103174603173 * sp[18] + 0.01765873015873015 * sp[17];
    A[127] = -0.09444444444444484 * sp[19] + -0.05466269841269859 * sp[18] + -0.0586309523809528 * sp[18] + -0.04871031746031778 * sp[17];
    A[128] = 0.1012896825396833 * sp[19] + 0.06850198412698466 * sp[18] + 0.06850198412698466 * sp[18] + 0.05734126984127037 * sp[17];
    A[129] = -0.1641497884897314 * sp[19] + -0.05822407027627442 * sp[18] + -0.09750778034219118 * sp[18] + -0.03507474113028566 * sp[17];
    A[130] = -0.2345485468582882 * sp[19] + -0.06142938132002914 * sp[18] + -0.167964252420494 * sp[18] + -0.0420984571284115 * sp[17];
    A[131] = 0.2217261904761904 * sp[19] + 0.09945436507936561 * sp[18] + 0.1252480158730149 * sp[18] + 0.05109126984126949 * sp[17];
    A[132] = -0.04208968935634314 * sp[19] + -0.195015560684383 * sp[18] + -0.01543288609732586 * sp[18] + -0.08979133729352878 * sp[17];
    A[133] = 0.1030982623552906 * sp[19] + 0.08763352300199809 * sp[18] + 0.02577456558882199 * sp[18] + -0.0463942180598798 * sp[17];
    A[134] = -0.07440476190476362 * sp[19] + -0.05902777777777996 * sp[18] + -0.02728174603174675 * sp[18] + -0.003968253968254352 * sp[17];
    A[135] = 0.04349267900155124 * sp[19] + -0.06243303921190617 * sp[18] + -0.02314932914598865 * sp[18] + 0.03507474113028569 * sp[17];
    A[136] = -0.07856742013183785 * sp[19] + 0.1360899955855051 * sp[18] + -0.009820927516479843 * sp[18] + 0.07014948226057119 * sp[17];
    A[137] = 0.1248660784238154 * sp[19] + -0.1283735525368422 * sp[18] + 0.01192541198429702 * sp[18] + -0.03507474113028557 * sp[17];
    A[138] = -0.07856742013183698 * sp[19] + -0.1529258713280408 * sp[18] + 0.02665680325901717 * sp[18] + 0.04208968935634278 * sp[17];
    A[139] = 0.1487169023924092 * sp[19] + 0.2946278254943949 * sp[18] + 0.002805979290422735 * sp[18];
    A[140] = -0.0897913372935298 * sp[19] + -0.1950155606843834 * sp[18] + -0.01543288609732559 * sp[18] + -0.04208968935634275 * sp[17];
    A[141] = -0.2062394778460755 * sp[19] + -0.09329881140655671 * sp[18] + 0.04700015311458272 * sp[18] + 0.03507474113028559 * sp[17];
    A[142] = 0.1346870059402921 * sp[19] + 0.06594051332493422 * sp[18] + -0.07997040977705104 * sp[18] + -0.07014948226057124 * sp[17];
    A[143] = -0.1641497884897314 * sp[19] + -0.09750778034219118 * sp[18] + -0.05822407027627442 * sp[18] + -0.03507474113028566 * sp[17];
    A[144] = 4.920634920634906 * sp[19] + 0.1984126984127007 * sp[18] + 0.1984126984127007 * sp[18] + 0.3968253968254026 * sp[17];
    A[145] = 0.02430049347996754 * sp[19] + -0.06075123369997279 * sp[18] + 0.2308546880599302 * sp[18] + 0.607512336999805 * sp[17];
    A[146] = -0.5191061687282003 * sp[19] + -0.8067190459965515 * sp[18] + -0.301642773720451 * sp[18] + -0.350747411302856 * sp[17];
    A[147] = -0.1984126984127007 * sp[19] + 4.305555555555532 * sp[18] + 0.0198412698412701 * sp[18] + -0.1984126984127016 * sp[17];
    A[148] = -0.21870444131991 * sp[19] + -0.03645074021998912 * sp[18] + 0.2551551815399188 * sp[18] + -0.2187044413199263 * sp[17];
    A[149] = -0.3507474113028552 * sp[19] + 0.5401510134063866 * sp[18] + 0.03507474113028562 * sp[18] + 0.3226876183986334 * sp[17];
    A[150] = 0.06529556615835215 * sp[19] + -0.1271545235715235 * sp[18] + -0.05154913117764595 * sp[18] + 0.06529556615835112 * sp[17];
    A[151] = -0.05326743555023473 * sp[19] + 0.1838585678669346 * sp[18] + -0.008591521862941334 * sp[18] + 0.08419691425682214 * sp[17];
    A[152] = -0.003436608745177563 * sp[19] + -0.05154913117764414 * sp[18] + -0.01718304372588165 * sp[18] + -0.003436608745176412 * sp[17];
    A[153] = -0.03522523963805742 * sp[19] + 0.02104922856420399 * sp[18] + 0.07947157723220415 * sp[18] + 0.1159855451497029 * sp[17];
    A[154] = -0.006873217490354508 * sp[19] + -0.1778445025628795 * sp[18] + -0.04725337024617514 * sp[18] + -0.1030982623552911 * sp[17];
    A[155] = -0.02663371777511697 * sp[19] + -0.007302793583500569 * sp[18] + -0.01073940232867664 * sp[18] + -0.0128872827944121 * sp[17];
    A[156] = 0.131450284502998 * sp[19] + -0.01073940232867408 * sp[18] + 0.1576544261849668 * sp[18] + 0.1039574145415858 * sp[17];
    A[157] = 0.1030982623552914 * sp[19] + 0.1022391101689944 * sp[18] + -0.1520699369740544 * sp[18] + -0.1305911323167025 * sp[17];
    A[158] = -0.2345485468582882 * sp[19] + -0.167964252420494 * sp[18] + -0.06142938132002914 * sp[18] + -0.0420984571284115 * sp[17];
    A[159] = 0.02430049347996754 * sp[19] + 0.2308546880599302 * sp[18] + -0.06075123369997279 * sp[18] + 0.607512336999805 * sp[17];
    A[160] = 5.41666666666671 * sp[19] + 0.4315476190476344 * sp[18] + 0.4315476190476344 * sp[18] + 1.130952380952398 * sp[17];
    A[161] = -0.1890134809847077 * sp[19] + -0.06873217490352268 * sp[18] + -0.2749286996141042 * sp[18] + -0.1890134809847009 * sp[17];
    A[162] = 0.1701034543599534 * sp[19] + 0.4495591293798421 * sp[18] + 0.1579532076199494 * sp[18] + -0.4131083891598586 * sp[17];
    A[163] = -0.4017857142857221 * sp[19] + 3.593749999999994 * sp[18] + 0.5580357142857235 * sp[18] + -0.4017857142857134 * sp[17];
    A[164] = 0.3007032652029481 * sp[19] + 0.1761261981902894 * sp[18] + 0.2792244605455823 * sp[18] + 0.3007032652029423 * sp[17];
    A[165] = -0.0168650793650812 * sp[19] + 0.07192460317460243 * sp[18] + -0.007440476190475788 * sp[18] + -0.01091269841269967 * sp[17];
    A[166] = -0.004960317460315044 * sp[19] + -0.1626984126984117 * sp[18] + 0.01984126984126906 * sp[18] + -0.1021825396825402 * sp[17];
    A[167] = 0.1001984126984122 * sp[19] + 0.1026785714285712 * sp[18] + -0.07192460317460342 * sp[18] + 0.1180555555555571 * sp[17];
    A[168] = -0.04513888888888831 * sp[19] + 0.005704365079364558 * sp[18] + 0.04340277777777805 * sp[18] + 0.05208333333333324 * sp[17];
    A[169] = 0.1289682539682541 * sp[19] + -0.01636904761904639 * sp[18] + -0.09176587301587352 * sp[18] + -0.17857142857143 * sp[17];
    A[170] = -0.03819444444444288 * sp[19] + 0.1054067460317481 * sp[18] + 0.03596230158730113 * sp[18] + 0.1264880952380961 * sp[17];
    A[171] = 0.1473214285714273 * sp[19] + 0.04935515873015877 * sp[18] + 0.1068948412698423 * sp[18] + 0.05605158730158792 * sp[17];
    A[172] = -0.1071428571428559 * sp[19] + -0.05605158730158683 * sp[18] + 0.0193452380952398 * sp[18] + 0.02182539682539825 * sp[17];
    A[173] = 0.2217261904761904 * sp[19] + 0.1252480158730149 * sp[18] + 0.09945436507936561 * sp[18] + 0.05109126984126949 * sp[17];
    A[174] = -0.5191061687282003 * sp[19] + -0.301642773720451 * sp[18] + -0.8067190459965515 * sp[18] + -0.350747411302856 * sp[17];
    A[175] = -0.1890134809847077 * sp[19] + -0.2749286996141042 * sp[18] + -0.06873217490352268 * sp[18] + -0.1890134809847009 * sp[17];
    A[176] = 5.555555555555569 * sp[19] + 0.5902777777777782 * sp[18] + 0.5902777777777782 * sp[18] + 0.9126984126984276 * sp[17];
    A[177] = -0.3507474113028588 * sp[19] + -0.3016427737204441 * sp[18] + 0.203433498555657 * sp[18] + -0.01402989645209562 * sp[17];
    A[178] = 0.07732369676647544 * sp[19] + 0.1675346763273495 * sp[18] + 0.06443641397205629 * sp[18] + 0.07732369676647213 * sp[17];
    A[179] = -0.6200396825396948 * sp[19] + 3.395337301587296 * sp[18] + 0.3596230158730219 * sp[18] + -0.6200396825397007 * sp[17];
    A[180] = 0.03507474113028562 * sp[19] + -0.01192541198429724 * sp[18] + 0.1283735525368425 * sp[18] + -0.124866078423815 * sp[17];
    A[181] = -0.07014948226057116 * sp[19] + 0.009820927516480083 * sp[18] + -0.136089995585506 * sp[18] + 0.07856742013183708 * sp[17];
    A[182] = -0.0350747411302858 * sp[19] + 0.02314932914598852 * sp[18] + 0.06243303921190661 * sp[18] + -0.04349267900155108 * sp[17];
    A[183] = 0.03507474113028569 * sp[19] + 0.04700015311458283 * sp[18] + -0.09329881140655695 * sp[18] + -0.2062394778460747 * sp[17];
    A[184] = -0.07014948226057147 * sp[19] + -0.07997040977705129 * sp[18] + 0.06594051332493477 * sp[18] + 0.1346870059402917 * sp[17];
    A[185] = -0.03507474113028548 * sp[19] + -0.05822407027627419 * sp[18] + -0.09750778034219214 * sp[18] + -0.1641497884897314 * sp[17];
    A[186] = 0.0420896893563427 * sp[19] + 0.02665680325901705 * sp[18] + -0.1529258713280411 * sp[18] + -0.07856742013183673 * sp[17];
    A[187] = 0.002805979290423023 * sp[18] + 0.2946278254943946 * sp[18] + 0.1487169023924087 * sp[17];
    A[188] = -0.04208968935634314 * sp[19] + -0.01543288609732586 * sp[18] + -0.195015560684383 * sp[18] + -0.08979133729352878 * sp[17];
    A[189] = -0.1984126984127007 * sp[19] + 0.0198412698412701 * sp[18] + 4.305555555555532 * sp[18] + -0.1984126984127016 * sp[17];
    A[190] = 0.1701034543599534 * sp[19] + 0.1579532076199494 * sp[18] + 0.4495591293798421 * sp[18] + -0.4131083891598586 * sp[17];
    A[191] = -0.3507474113028588 * sp[19] + 0.203433498555657 * sp[18] + -0.3016427737204441 * sp[18] + -0.01402989645209562 * sp[17];
    A[192] = 0.3968253968254034 * sp[19] + 0.1984126984127025 * sp[18] + 0.1984126984127025 * sp[18] + 4.920634920634906 * sp[17];
    A[193] = -0.145802960879946 * sp[18] + -0.7290148043997476 * sp[18] + -0.4374088826398526 * sp[17];
    A[194] = 0.7014948226057131 * sp[19] + 0.3507474113028552 * sp[18] + 0.3507474113028576 * sp[18] + 0.2805979290422569 * sp[17];
    A[195] = -0.1005208057964094 * sp[19] + 0.07088005536926248 * sp[18] + -0.06314768569261547 * sp[18] + -0.08505606644311371 * sp[17];
    A[196] = 0.04639421805988016 * sp[19] + -0.01288728279441055 * sp[18] + 0.04897167461876187 * sp[18] + 0.03092947870658585 * sp[17];
    A[197] = -0.02319710902993956 * sp[19] + 0.03221820698602833 * sp[18] + 0.001288728279441068 * sp[18] + -0.01804219591217487 * sp[17];
    A[198] = 0.1005208057964094 * sp[19] + 0.1714008611656717 * sp[18] + 0.03737312010379369 * sp[18] + 0.1933092419161692 * sp[17];
    A[199] = -0.04639421805988027 * sp[19] + -0.05928150085429051 * sp[18] + 0.00257745655888166 * sp[18] + -0.04123930494211492 * sp[17];
    A[200] = 0.02319710902993937 * sp[19] + 0.05541531601596755 * sp[18] + 0.02448583730938059 * sp[18] + 0.07474624020758393 * sp[17];
    A[201] = 0.1030982623552906 * sp[19] + 0.07732369676646855 * sp[18] + 0.01546473935329254 * sp[18] + -0.05670404429540904 * sp[17];
    A[202] = -0.2061965247105823 * sp[19] + -0.1030982623552912 * sp[18] + -0.1030982623552906 * sp[18] + 0.1082531754730541 * sp[17];
    A[203] = 0.1030982623552906 * sp[19] + 0.02577456558882199 * sp[18] + 0.08763352300199809 * sp[18] + -0.0463942180598798 * sp[17];
    A[204] = -0.21870444131991 * sp[19] + 0.2551551815399188 * sp[18] + -0.03645074021998912 * sp[18] + -0.2187044413199263 * sp[17];
    A[205] = -0.4017857142857221 * sp[19] + 0.5580357142857235 * sp[18] + 3.593749999999994 * sp[18] + -0.4017857142857134 * sp[17];
    A[206] = 0.07732369676647544 * sp[19] + 0.06443641397205629 * sp[18] + 0.1675346763273495 * sp[18] + 0.07732369676647213 * sp[17];
    A[207] = -0.7290148043997476 * sp[18] + -0.145802960879946 * sp[18] + -0.4374088826398526 * sp[17];
    A[208] = 0.8035714285714427 * sp[19] + 0.4017857142857201 * sp[18] + 0.4017857142857201 * sp[18] + 5.357142857142864 * sp[17];
    A[209] = -0.05154913117763515 * sp[18] + -0.2577456558882169 * sp[18] + -0.1546473935329276 * sp[17];
    A[210] = 0.06200396825396911 * sp[19] + -0.02108134920634971 * sp[18] + 0.09598214285714152 * sp[18] + 0.05307539682539852 * sp[17];
    A[211] = -0.1240079365079382 * sp[19] + 0.01736111111111155 * sp[18] + -0.2405753968253959 * sp[18] + 0.04365079365079512 * sp[17];
    A[212] = -0.06200396825396939 * sp[19] + 0.04092261904761967 * sp[18] + 0.1460813492063476 * sp[18] + -0.06498015873016047 * sp[17];
    A[213] = 0.0620039682539693 * sp[19] + 0.0830853174603189 * sp[18] + -0.03397817460317268 * sp[18] + 0.04017857142857449 * sp[17];
    A[214] = -0.1240079365079386 * sp[19] + -0.1413690476190498 * sp[18] + 0.116567460317458 * sp[18] + 0.1428571428571433 * sp[17];
    A[215] = -0.06200396825396894 * sp[19] + -0.1029265873015889 * sp[18] + -0.2080853174603165 * sp[18] + -0.3139880952380977 * sp[17];
    A[216] = 0.07440476190476301 * sp[19] + 0.04712301587301656 * sp[18] + 0.01537698412698307 * sp[18] + -0.007936507936507811 * sp[17];
    A[217] = 0.004960317460317807 * sp[18] + -0.1458333333333369 * sp[18] + -0.07043650793651041 * sp[17];
    A[218] = -0.07440476190476362 * sp[19] + -0.02728174603174675 * sp[18] + -0.05902777777777996 * sp[18] + -0.003968253968254352 * sp[17];
    A[219] = -0.3507474113028552 * sp[19] + 0.03507474113028562 * sp[18] + 0.5401510134063866 * sp[18] + 0.3226876183986334 * sp[17];
    A[220] = 0.3007032652029481 * sp[19] + 0.2792244605455823 * sp[18] + 0.1761261981902894 * sp[18] + 0.3007032652029423 * sp[17];
    A[221] = -0.6200396825396948 * sp[19] + 0.3596230158730219 * sp[18] + 3.395337301587296 * sp[18] + -0.6200396825397007 * sp[17];
    A[222] = 0.7014948226057131 * sp[19] + 0.3507474113028576 * sp[18] + 0.3507474113028552 * sp[18] + 0.2805979290422569 * sp[17];
    A[223] = -0.2577456558882169 * sp[18] + -0.05154913117763515 * sp[18] + -0.1546473935329276 * sp[17];
    A[224] = 1.240079365079384 * sp[19] + 0.6200396825396906 * sp[18] + 0.6200396825396906 * sp[18] + 5.615079365079412 * sp[17];
  }

};


class forms_form_0: public ufc::form
{
public:

  forms_form_0() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "f7ade342237e5af4964c4356cf0b121fecb7c546c2c72d54a3d7f9c3718a8755a939353c4e59adb32539a005c2463fb5e8af82bc1aadd81f9dfdc51a48bee4cd";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_0_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};


class forms_form_1: public ufc::form
{
public:

  forms_form_1() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "a3226853386d2b74b50fbefb85d9e0f4f839379042f756b24439e8ccc90d14f112726c9f00229d697576706f783f14fe1fb718aff5c3d4d48b40494a4aef7b2b";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_1_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};

// DOLFIN wrappers

// Standard library includes
#include <string>

// DOLFIN includes
#include <dolfin/common/NoDeleter.h>
#include <dolfin/mesh/Mesh.h>
#include <dolfin/mesh/MultiMesh.h>
#include <dolfin/fem/FiniteElement.h>
#include <dolfin/fem/DofMap.h>
#include <dolfin/fem/Form.h>
#include <dolfin/fem/MultiMeshForm.h>
#include <dolfin/function/FunctionSpace.h>
#include <dolfin/function/MultiMeshFunctionSpace.h>
#include <dolfin/function/GenericFunction.h>
#include <dolfin/function/CoefficientAssigner.h>
#include <dolfin/function/MultiMeshCoefficientAssigner.h>
#include <dolfin/adaptivity/ErrorControl.h>
#include <dolfin/adaptivity/GoalFunctional.h>
#include <dolfin/la/GenericVector.h>

namespace Forms
{

class Form_a_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a: public dolfin::Form
{
public:

  // Constructor
  Form_a(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_0>();
  }

  // Destructor
  ~Form_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_a: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_a(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_a(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class Form_L_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L: public dolfin::Form
{
public:

  // Constructor
  Form_L(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_1>();
  }

  // Destructor
  ~Form_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_L: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_L(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_L(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

// Class typedefs
typedef Form_a::TestSpace FunctionSpace;
typedef Form_a::MultiMeshTestSpace MultiMeshFunctionSpace;

}

#endif
